/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MavenSkipTestOptionAction.java,v 1.2 2007/04/11 13:34:07 lam Exp $
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;

/**
 * @author LAM
 */
public class MavenSkipTestOptionAction extends Action {

    private static boolean skipped = false;

    /**
     * @return the verbose
     */
    public static boolean isSkipped() {
        return MavenSkipTestOptionAction.skipped;
    }

    public MavenSkipTestOptionAction() {
        super(null, IAction.AS_CHECK_BOX);
        this.setText(Messages.MavenSkipTestOptionAction_0);
        this
                .setToolTipText(Messages.MavenSkipTestOptionAction_1);
        this.setChecked(MavenSkipTestOptionAction.skipped);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.action.Action#run()
     */
    @Override
    public void run() {
        // Toggle the verbose boolean option
        MavenSkipTestOptionAction.skipped = !MavenSkipTestOptionAction.skipped;
    }

}
