/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ShowOrphanSuAction.java,v 1.1 2007/04/26 10:44:01 lam Exp $
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.actions;

import org.eclipse.jface.action.IAction;

/**
 * Refresh action for the Petals Component Dependencies view
 * 
 * @author LAM
 */
public class MavenUpdateSnapshotsOptionAction extends
        AbstractViewerActionFactory {

    private static boolean updateSnapshots = false;

    /**
     * @return the updateSnapshots
     */
    public static boolean isUpdateSnapshots() {
        return MavenUpdateSnapshotsOptionAction.updateSnapshots;
    }

    /**
     * Constructor
     */
    public MavenUpdateSnapshotsOptionAction() {
        super(null, IAction.AS_CHECK_BOX);
        this.setText(Messages.MavenUpdateSnapshotsOptionAction_0);
        this
                .setToolTipText(Messages.MavenUpdateSnapshotsOptionAction_1);
        this.setChecked(MavenUpdateSnapshotsOptionAction.updateSnapshots);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.action.Action#run()
     */
    @Override
    public void run() {
        MavenUpdateSnapshotsOptionAction.updateSnapshots = !MavenUpdateSnapshotsOptionAction.updateSnapshots;
        this.refreshViewer();
    }

}
