/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ShowOrphanSuAction.java,v 1.1 2007/04/26 10:44:01 lam Exp $
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.actions;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IWorkbenchPartSite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.development.Activator;

/**
 * Refresh action for the Petals Component Dependencies view
 * 
 * @author LAM
 */
public class ShowOrphanSuAction extends AbstractViewerActionFactory {

    private static boolean showSu = true;

    /**
     * @return the showSu
     */
    public static boolean isShowSu() {
        return ShowOrphanSuAction.showSu;
    }

    /**
     * Constructor
     * 
     * @param viewer
     *            The tree viewer
     * @param site
     *            The site
     */
    public ShowOrphanSuAction(final TreeViewer viewer,
            final IWorkbenchPartSite site) {
        super(viewer, site);
        this.setToolTipText(Messages.ShowOrphanSuAction_0);
        this.setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(
                Activator.PLUGIN_ID, "resources/icons/sa.gif")); //$NON-NLS-1$
        this.setChecked(ShowOrphanSuAction.showSu);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.action.Action#run()
     */
    @Override
    public void run() {
        ShowOrphanSuAction.showSu = !ShowOrphanSuAction.showSu;
        this.refreshViewer();
    }

}
