/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ConsoleMavenFactory.java,v 1.2 2007/04/11 13:34:07 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.consoles;

import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleFactory;
import org.eclipse.ui.console.IConsoleManager;
import org.objectweb.petals.tools.plugin.development.Activator;

/**
 * The console for Maven commands
 * 
 * @author LAM
 */
public class ConsoleMavenFactory implements IConsoleFactory {

    public ConsoleMavenFactory() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.ui.console.IConsoleFactory#openConsole()
     */
    public void openConsole() {
        showConsole();
    }

    /**
     * Creates the static instance for the console
     */
    public static void showConsole() {
        MavenOutputConsole console = Activator.getDefault().getConsole();
        if (console != null) {
            IConsoleManager manager = ConsolePlugin.getDefault()
                    .getConsoleManager();
            IConsole[] existing = manager.getConsoles();
            boolean exists = false;
            for (int i = 0; i < existing.length; i++) {
                if (console == existing[i]) {
                    exists = true;
                }
            }
            if (!exists) {
                manager.addConsoles(new IConsole[] { console });
                ConsolePlugin.getDefault().getConsoleManager()
                        .addConsoleListener(console.new MyLifecycle());
            }
            manager.showConsoleView(console);
        }
    }

    /**
     * 
     */
    public static void closeConsole() {
        IConsoleManager manager = ConsolePlugin.getDefault()
                .getConsoleManager();
        MavenOutputConsole console = Activator.getDefault().getConsole();
        if (console != null) {
            console.clearConsole();
            manager.removeConsoles(new IConsole[] { console });
            ConsolePlugin.getDefault().getConsoleManager()
                    .removeConsoleListener(console.new MyLifecycle());
        }
    }

}
