/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MavenConsolePageParticipant.java,v 1.2 2007/04/11 13:34:07 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.consoles;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleConstants;
import org.eclipse.ui.console.IConsolePageParticipant;
import org.eclipse.ui.part.IPageBookViewPage;
import org.objectweb.petals.tools.plugin.development.actions.MavenRemoveConsoleAction;

/**
 * @author LAM
 */
public class MavenConsolePageParticipant implements IConsolePageParticipant {

    private Action consoleRemoveAction;
    
    public MavenConsolePageParticipant() {
    }

    public void init(IPageBookViewPage page, IConsole console) {
        this.consoleRemoveAction = new MavenRemoveConsoleAction();
        IActionBars bars = page.getSite().getActionBars();
        bars.getToolBarManager().appendToGroup(IConsoleConstants.LAUNCH_GROUP,
                consoleRemoveAction);
    }

    public void dispose() {
        this.consoleRemoveAction = null;
    }

    public void activated() {
    }

    public void deactivated() {
    }

    public Object getAdapter(Class adapter) {
        return null;
    }

}
