/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.constants;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public enum Artifacts {

    SOAP12("petals-binding-soap", "org.objectweb.petals", "1.2", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
            Constants.ArtifactsType.JBI_COMPONENT, "SOAP"), SOAP13( //$NON-NLS-1$
            "petals-binding-soap", "org.objectweb.petals", "1.3", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
            Constants.ArtifactsType.JBI_COMPONENT, "SOAP"), SOAP14( //$NON-NLS-1$
            "petals-binding-soap", "org.objectweb.petals", "1.4", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
            Constants.ArtifactsType.JBI_COMPONENT, "SOAP"), SOAP20( //$NON-NLS-1$
            "petals-bc-soap", "org.objectweb.petals", "2.0", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
            Constants.ArtifactsType.JBI_COMPONENT, "SOAP"); //$NON-NLS-1$

    /**
     * 
     * @param name
     * @param sorted
     * @return
     */
    public static List<Artifacts> getList(final String name,
            final Boolean sorted) {
        final List<Artifacts> list = new LinkedList<Artifacts>();
        for (final Artifacts value : Artifacts.values()) {
            if (value.getName().equals(name)) {
                list.add(value);
            }
        }
        if (sorted) {
            Collections.sort(list);
        }
        return list;
    }

    private String name;

    private String group;

    private String version;

    private String type;

    private String familyId;

    private Artifacts(String name, String group, String version, String type,
            String familyId) {
        this.name = name;
        this.group = group;
        this.version = version;
        this.type = type;
        this.familyId = familyId;
    }

    /**
     * @return the name
     */
    public String getName() {
        return this.name;
    }

    /**
     * @param name
     *            the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the group
     */
    public String getGroup() {
        return this.group;
    }

    /**
     * @param group
     *            the group to set
     */
    public void setGroup(String group) {
        this.group = group;
    }

    /**
     * @return the version
     */
    public String getVersion() {
        return this.version;
    }

    /**
     * @param version
     *            the version to set
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * @return the type
     */
    public String getType() {
        return this.type;
    }

    /**
     * @param type
     *            the type to set
     */
    public void setType(String type) {
        this.type = type;
    }

}
