/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: Wizards.java,v 1.2 2007/04/24 07:26:57 lam Exp $
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.constants;

import java.io.File;

/**
 * Constants used for project components creation
 * 
 * @author LAM
 */
public final class Wizards {

    /**
     * JAVA = "java"
     */
    public static final String JAVA = "java"; //$NON-NLS-1$

    /**
     * JBI = "jbi"
     */
    public static final String JBI = "jbi"; //$NON-NLS-1$

    /**
     * JBI_FILENAME = "jbi.xml"
     */
    public static final String JBI_FILENAME = "jbi.xml"; //$NON-NLS-1$

    /**
     * POM_FILENAME = "pom.xml"
     */
    public static final String POM_FILENAME = "pom.xml"; //$NON-NLS-1$

    /**
     * MAIN = "main"
     */
    public static final String MAIN = "main"; //$NON-NLS-1$

    /**
     * RESOURCES = "ressources"
     */
    public static final String RESOURCES = "resources"; //$NON-NLS-1$

    /**
     * SRC = "src"
     */
    public static final String SRC = "src"; //$NON-NLS-1$

    /**
     * TEST = "test"
     */
    public static final String TEST = "test"; //$NON-NLS-1$

    /**
     * DIR_TARGET = "target"
     */
    public static final String DIR_TARGET = "target"; //$NON-NLS-1$

    /**
     * DIR_CLASSES = "classes"
     */
    public static final String DIR_CLASSES = "classes"; //$NON-NLS-1$

    /**
     * Default outpu directory if "Use Maven" is disabled DIR_BIN = "bin"
     */
    public static final String DIR_BIN = "bin"; //$NON-NLS-1$

    /**
     * 
     */
    public static final String JAVA_MAIN_PATH = SRC + File.separator + MAIN
            + File.separator + JAVA;

    /**
     * 
     */
    public static final String JAVA_TEST_PATH = SRC + File.separator + TEST
            + File.separator + JAVA;

    /**
     * WIZARD_CUSTOM_BC = "BC"
     */
    public static final String WIZARD_CUSTOM_BC = "BC"; //$NON-NLS-1$

    /**
     * WIZARD_CUSTOM_SE = "SE"
     */
    public static final String WIZARD_CUSTOM_SE = "SE"; //$NON-NLS-1$

    /**
     * WIZARD_CUSTOM_SU = "SU"
     */
    public static final String WIZARD_CUSTOM_SU = "SU"; //$NON-NLS-1$

    /**
     * WIZARD_CUSTOM_SA = "SA"
     */
    public static final String WIZARD_CUSTOM_SA = "SA"; //$NON-NLS-1$

    /**
     * WIZARD_CUSTOM_SL = "SL"
     */
    public static final String WIZARD_CUSTOM_SL = "SL"; //$NON-NLS-1$

    /**
     * String to replace in jbi.xml file when creating SA project.
     * IN_FILE_SULIST = "<!-- IN_FILE_SULIST -->"
     */
    public static final String IN_FILE_SULIST = "<!-- IN_FILE_SULIST -->"; //$NON-NLS-1$
    
    public static final String IN_FILE_JBI_SA_NAME = "IN_FILE_JBI_SA_NAME"; //$NON-NLS-1$

    public static final String JBI_SU_NODE_BEGIN = "<service-unit><identification><name>"; //$NON-NLS-1$

    public static final String JBI_SU_NODE_END = "</name><description></description></identification>"; //$NON-NLS-1$

    public static final String JBI_SU_NODE_TARGET_BEGIN = "<target><artifacts-zip>"; //$NON-NLS-1$

    public static final String JBI_SU_NODE_TARGET_END = "</artifacts-zip><component-name>" //$NON-NLS-1$
            + "</component-name></target></service-unit>"; //$NON-NLS-1$

    /**
     * String to replace in the generated pomfile IN_FILE_POM_ARTIFACT_ID =
     * "IN_FILE_POM_ARTIFACT_ID"
     */
    public static final String IN_FILE_POM_ARTIFACT_ID = "IN_FILE_POM_ARTIFACT_ID"; //$NON-NLS-1$

    /**
     * String to replace in the generated pomfile IN_FILE_POM_GROUP_ID =
     * "IN_FILE_POM_GROUP_ID"
     */
    public static final String IN_FILE_POM_GROUP_ID = "IN_FILE_POM_GROUP_ID"; //$NON-NLS-1$

    /**
     * String to replace in the generated pomfile IN_FILE_POM_VERSION =
     * "IN_FILE_POM_VERSION"
     */
    public static final String IN_FILE_POM_VERSION = "IN_FILE_POM_VERSION"; //$NON-NLS-1$

    /**
     * Used to replace the maven.petals.plugin version tag in the pom.xml
     * IN_FILE_POM_MPPV = "IN_FILE_POM_MPPV"
     */
    public static final String IN_FILE_POM_MPPV = "IN_FILE_POM_MPPV"; //$NON-NLS-1$

    /**
     * The CDK version to use
     */
    public static final String IN_FILE_POM_CDK_VERSION = "IN_FILE_POM_CDK_VERSION"; //$NON-NLS-1$

    /**
     * The Component Framework name to use
     */
    public static final String IN_FILE_POM_CDK_NAME = "IN_FILE_POM_CDK_NAME"; //$NON-NLS-1$

    /**
     * The Component Framework group to use
     */
    public static final String IN_FILE_POM_CDK_GROUP = "IN_FILE_POM_CDK_GROUP"; //$NON-NLS-1$

    /**
     * The dependency element in the POM file
     */
    public static final String IN_FILE_POM_DEPENDENCY = "<!-- IN_FILE_POM_DEPENDENCY -->"; //$NON-NLS-1$

    public static final String IN_FILE_POM_DEPENDENCIES = "<!-- IN_FILE_POM_DEPENDENCIES -->"; //$NON-NLS-1$

    /**
     * String to replace in the generated pomfile IN_FILE_POM_PACKAGING =
     * "IN_FILE_POM_PACKAGING"
     */
    public static final String IN_FILE_POM_PACKAGING = "IN_FILE_POM_PACKAGING"; //$NON-NLS-1$

    public static final String IN_FILE_JAVA_PACKAGE = "IN_FILE_JAVA_PACKAGE"; //$NON-NLS-1$

    public static final String IN_FILE_JAVA_CLASSNAME = "IN_FILE_JAVA_CLASSNAME"; //$NON-NLS-1$

    /**
     * If is set in the preferences, OBJECTWEB_MAVEN_REPO declaration will be
     * added in the generated pom.xml files
     */
    public static final String IN_FILE_OBJECTWEB_MAVEN_REPO = "IN_FILE_OBJECTWEB_MAVEN_REPO"; //$NON-NLS-1$

    /**
     * The ObjectWeb repository declaration for pom.xml files
     */
    public static final String OBJECTWEB_MAVEN_REPO = "<repositories>\r" //$NON-NLS-1$
            + "\t\t<repository>\r" + "\t\t\t<id>objectweb-repo</id>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t<name>ObjectWeb Repository</name>\r" //$NON-NLS-1$
            + "\t\t\t<url>http://maven.objectweb.org/maven2</url>\r" //$NON-NLS-1$
            + "\t\t\t<releases>\r" + "\t\t\t\t<enabled>true</enabled>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t</releases>\r" + "\t\t\t<snapshots>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t\t<enabled>false</enabled>\r" + "\t\t\t</snapshots>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t</repository>\r" + "\t</repositories>\r\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t<pluginRepositories>\r" + "\t\t<pluginRepository>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t<id>objectweb-repo</id>\r" //$NON-NLS-1$
            + "\t\t\t<name>ObjectWeb Repository</name>\r" //$NON-NLS-1$
            + "\t\t\t<url>http://maven.objectweb.org/maven2</url>\r" //$NON-NLS-1$
            + "\t\t\t<releases>\r" + "\t\t\t\t<enabled>true</enabled>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t</releases>\r" + "\t\t\t<snapshots>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t\t\t<enabled>false</enabled>\r" + "\t\t\t</snapshots>\r" //$NON-NLS-1$ //$NON-NLS-2$
            + "\t\t</pluginRepository>\r" + "\t</pluginRepositories>\r"; //$NON-NLS-1$ //$NON-NLS-2$

    private Wizards() {

    }

}
