/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: XMLDocumentProvider.java,v 1.3 2007/04/16 07:54:23 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.jbieditor;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.ui.editors.text.FileDocumentProvider;
import 
    org.objectweb.petals.tools.plugin.development.jbieditor.scanners.XMLPartitionScanner;

public class XMLDocumentProvider extends FileDocumentProvider {
    
    public XMLDocumentProvider() {
    }

    protected IDocument createDocument(Object element) throws CoreException {
        IDocument document = super.createDocument(element);
        if (document != null) {
            IDocumentPartitioner partitioner = new XMLPartitioner(
                    new XMLPartitionScanner(), new String[] {
                            XMLPartitionScanner.XML_START_TAG,
                            XMLPartitionScanner.XML_PI,
                            XMLPartitionScanner.XML_DOCTYPE,
                            XMLPartitionScanner.XML_END_TAG,
                            XMLPartitionScanner.XML_TEXT,
                            XMLPartitionScanner.XML_CDATA,
                            XMLPartitionScanner.XML_COMMENT });
            partitioner.connect(document);
            document.setDocumentPartitioner(partitioner);
        }
        return document;
    }
    
}
