/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: Attribute.java,v 1.3 2007/04/11 13:34:07 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.jbieditor.beans;

/**
 * Binding for a DOM Element attribute
 * 
 * @author LAM
 */
public class Attribute {

    /**
     * The description
     */
    private String description;

    /**
     * The value
     */
    private String value;

    /**
     * Constructor using fields
     * 
     * @param value
     *            The value
     * @param description
     *            The description
     */
    public Attribute(String description, String value) {
        this.value = value;
        this.description = description;
    }

    /**
     * Getter
     * 
     * @return The description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Setter
     * 
     * @param description
     *            The description
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Getter
     * 
     * @return The value
     */
    public String getValue() {
        return value;
    }

    /**
     * Setter
     * 
     * @param value
     *            The value
     */
    public void setValue(String value) {
        this.value = value;
    }
}
