/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: SeConsumesProvides.java,v 1.4 2007/04/16 08:39:55 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.jbieditor.beans;

/**
 * Binding for DOM Element tag : jbi &gt; services &gt; consumes / provides
 * 
 * @author LAM
 */
public class SeConsumesProvides {

    private String interfaceName;

    private String serviceName;

    private String endpointName;

    private String linkType;

    private StringBuffer extensions;
    
    public SeConsumesProvides() {
    }

    /**
     * Getter
     * 
     * @return the endpointName
     */
    public String getEndpointName() {
        return endpointName;
    }

    /**
     * Setter
     * 
     * @param endpointName
     *            the endpointName to set
     */
    public void setEndpointName(String endpointName) {
        this.endpointName = endpointName;
    }

    /**
     * Getter
     * 
     * @return the interfaceName
     */
    public String getInterfaceName() {
        return interfaceName;
    }

    /**
     * Setter
     * 
     * @param interfaceName
     *            the interfaceName to set
     */
    public void setInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
    }

    /**
     * Getter
     * 
     * @return the linkType
     */
    public String getLinkType() {
        if (linkType != null) {
            return linkType;
        } else {
            return ""; //$NON-NLS-1$
        }
    }

    /**
     * Setter
     * 
     * @param linkType
     *            the linkType to set
     */
    public void setLinkType(String linkType) {
        this.linkType = linkType;
    }

    /**
     * Getter
     * 
     * @return the serviceName
     */
    public String getServiceName() {
        return serviceName;
    }

    /**
     * Setter
     * 
     * @param serviceName
     *            the serviceName to set
     */
    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }

    /**
     * Getter
     * 
     * @return the extensions
     */
    public StringBuffer getExtensions() {
        return extensions;
    }

    /**
     * Setter
     * 
     * @param extensions
     *            the extensions to set
     */
    public void setExtensions(StringBuffer extensions) {
        this.extensions = extensions;
    }
}
