/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ServiceTableLine.java,v 1.5 2007/04/16 08:39:55 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.jbieditor.beans;

/**
 * Bean that represent a Service comsumed or provided in the Service Unit JBI
 * descriptor file editor tables
 * 
 * @author LAM
 */
public class ServiceTableLine {

    private String interfaceName = ""; //$NON-NLS-1$

    private String serviceName = ""; //$NON-NLS-1$

    private String endpointName = ""; //$NON-NLS-1$

    private String linkType = ""; //$NON-NLS-1$

    private StringBuffer extensions;
    
    /**
     * Constructor
     * 
     * @param interfaceName
     *            The interfaceName
     * @param serviceName
     *            The serviceName
     * @param endpointName
     *            The endpointName
     * @param linkType
     *            The linkType
     */
    public ServiceTableLine(String interfaceName, String serviceName,
            String endpointName, String linkType, StringBuffer extensions) {
        super();
        this.interfaceName = interfaceName;
        this.serviceName = serviceName;
        this.endpointName = endpointName;
        this.linkType = linkType;
        this.extensions = extensions;
    }

    /**
     * Getter
     * 
     * @return the Petals extensions
     */
    public StringBuffer getExtensions() {
        return extensions;
    }

    /**
     * Setter
     * 
     * @param extensions
     *            the extensions to set
     */
    public void setExtensions(StringBuffer extensions) {
        this.extensions = extensions;
    }

    /**
     * Getter
     * 
     * @return the endpointName
     */
    public String getEndpointName() {
        return endpointName;
    }

    /**
     * Setter
     * 
     * @param endpointName
     *            the endpointName to set
     */
    public void setEndpointName(String endpointName) {
        this.endpointName = endpointName;
    }

    /**
     * Getter
     * 
     * @return the interfaceName
     */
    public String getInterfaceName() {
        return interfaceName;
    }

    /**
     * Setter
     * 
     * @param interfaceName
     *            the interfaceName to set
     */
    public void setInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
    }

    /**
     * Getter
     * 
     * @return the linkType
     */
    public String getLinkType() {
        return linkType;
    }

    /**
     * Setter
     * 
     * @param linkType
     *            the linkType to set
     */
    public void setLinkType(String linkType) {
        this.linkType = linkType;
    }

    /**
     * Getter
     * 
     * @return the serviceName
     */
    public String getServiceName() {
        return serviceName;
    }

    /**
     * Setter
     * 
     * @param serviceName
     *            the serviceName to set
     */
    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }
}
