/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: CDataScanner.java,v 1.3 2007/04/16 14:43:44 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.jbieditor.scanners;

import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.RuleBasedScanner;
import org.eclipse.jface.text.rules.Token;
import org.objectweb.petals.tools.plugin.development.jbieditor.ColorManager;
import org.objectweb.petals.tools.plugin.development.jbieditor.IXMLColorConstants;
import org.objectweb.petals.tools.plugin.development.jbieditor.rules.CDataRule;

public class CDataScanner extends RuleBasedScanner {

    private static IToken cData;

    public CDataScanner(ColorManager colorManager) {

        cData = new Token(new TextAttribute(colorManager
                .getColor(IXMLColorConstants.CDATA)));

        IRule[] rules = new IRule[2];

        // Add rule to pick up start of c section
        rules[0] = new CDataRule(cData, true);
        // Add a rule to pick up end of CDATA sections
        rules[1] = new CDataRule(cData, false);

        setRules(rules);
    }

    public IToken nextToken() {
        return super.nextToken();
    }
}
