/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.maven;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class ArtifactInformation {

    private String name;

    private String group;

    private String version;

    private String type;

    /**
     * Creates a new instance of {@link ArtifactInformation}
     * 
     */
    public ArtifactInformation() {
    }

    /**
     * Creates a new instance of {@link ArtifactInformation}
     * 
     * @param name
     * @param group
     * @param version
     * @param type
     */
    public ArtifactInformation(String name, String group, String version,
            String type) {
        super();
        this.name = name;
        this.group = group;
        this.version = version;
        this.type = type;
    }

    /**
     * Build the maven element of the dependency
     * 
     * @return
     */
    public String toMaven() {
        StringBuffer sb = new StringBuffer("<dependency>"); //$NON-NLS-1$
        sb.append("<artifactId>"); //$NON-NLS-1$
        sb.append(name);
        sb.append("</artifactId>"); //$NON-NLS-1$
        sb.append("<groupId>"); //$NON-NLS-1$
        sb.append(group);
        sb.append("</groupId>"); //$NON-NLS-1$
        sb.append("<version>"); //$NON-NLS-1$
        sb.append(version);
        sb.append("</version>"); //$NON-NLS-1$
        if (type != null) {
            sb.append("<type>"); //$NON-NLS-1$
            sb.append(type);
            sb.append("</type>"); //$NON-NLS-1$
        }
        sb.append("</dependency>"); //$NON-NLS-1$
        return sb.toString();
    }

    /**
     * @return the artifactId
     */
    public String getName() {
        return this.name;
    }

    /**
     * @param name
     *            the artifactId to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the groupId
     */
    public String getGroup() {
        return this.group;
    }

    /**
     * @param group
     *            the groupId to set
     */
    public void setGroup(String group) {
        this.group = group;
    }

    /**
     * @return the version
     */
    public String getVersion() {
        return this.version;
    }

    /**
     * @param version
     *            the version to set
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * @return the type
     */
    public String getType() {
        return this.type;
    }

    /**
     * @param type
     *            the type to set
     */
    public void setType(String type) {
        this.type = type;
    }
}
