/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ESBDevelopmentPreferencesInitializer.java,v 1.5 2007/04/16 14:43:44 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.objectweb.petals.tools.plugin.development.Activator;
import org.objectweb.petals.tools.plugin.development.constants.ESBDevPrefConstants;

/**
 * @author LAM
 */
public class ESBDevelopmentPreferencesInitializer extends
        AbstractPreferenceInitializer {

    public ESBDevelopmentPreferencesInitializer() {
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
     */
    @Override
    public void initializeDefaultPreferences() {
        IPreferenceStore store = Activator.getDefault().getPreferenceStore();
        store.setDefault(ESBDevPrefConstants.JBI_XSD_PATH_NAME,
                ""); //$NON-NLS-1$
        store.setDefault(ESBDevPrefConstants.MAVEN_CMD_NAME, ""); //$NON-NLS-1$
        store.setDefault(ESBDevPrefConstants.USE_MAVEN_FOR_BUILDING_NAME, true);
        store.setDefault(
                ESBDevPrefConstants.MAVEN_PETALS_PLUGIN_VERSION_NAME, 
                ESBDevPrefConstants.MAVEN_PETALS_PLUGIN_VERSION_DEFAULT);
        store.setDefault(ESBDevPrefConstants.OBJECTWEB_MAVEN_REPO_NAME, true);
    }

}
