/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ServicesTableLabelProvider.java,v 1.8 2007/04/24 07:26:57 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.providers;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.objectweb.petals.tools.plugin.development.jbieditor.beans.ServiceTableLine;

/**
 * Label provider for the ServicesTableViewer
 * 
 * @see org.eclipse.jface.viewers.LabelProvider
 */
public class ServicesTableLabelProvider extends LabelProvider implements
        ITableLabelProvider {
    
    /**
     * ID_COLUMN_INTERFACE = 0
     */
    public static final int ID_COLUMN_INTERFACE = 0;
    
    /**
     * ID_COLUMN_SERVICE = 1
     */
    public static final int ID_COLUMN_SERVICE = 1;
    
    /**
     * ID_COLUMN_ENDPOINT = 2
     */
    public static final int ID_COLUMN_ENDPOINT = 2;
    
    /**
     * ID_COLUMN_LINK = 3
     */
    public static final int ID_COLUMN_LINK = 3;
    
    /**
     * ID_COLUMN_EXT = 4
     */
    public static final int ID_COLUMN_EXT = 4;

    public ServicesTableLabelProvider() {
        
    }
    
    /**
     * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object,
     *      int)
     */
    public String getColumnText(Object element, int columnIndex) {
        String result = ""; //$NON-NLS-1$
        ServiceTableLine service = (ServiceTableLine) element;

        if (columnIndex == ID_COLUMN_INTERFACE) {
            result = service.getInterfaceName();
        } else if (columnIndex == ID_COLUMN_SERVICE) {
            result = service.getServiceName();
        } else if (columnIndex == ID_COLUMN_ENDPOINT) {
            result = service.getEndpointName();
        } else if (columnIndex == ID_COLUMN_LINK) {
            result = service.getLinkType();
        } else if (columnIndex == ID_COLUMN_EXT) {
            result = service.getExtensions().toString();
        }
        
        return result;
    }

    /**
     * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object,
     *      int)
     */
    public Image getColumnImage(Object element, int columnIndex) {
        return null;
    }

}
