/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ViewLabelProvider.java,v 1.5 2007/04/26 10:45:31 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.providers;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.objectweb.petals.tools.plugin.development.constants.Constants;
import org.objectweb.petals.tools.plugin.development.jbieditor.business.JbiBeanUtils;
import org.objectweb.petals.tools.plugin.development.views.PetalsTreeObject;

/**
 * ViewLabelProvider for the Petals Component Dependencies view
 * 
 * @author LAM
 */
public class ViewLabelProvider extends LabelProvider {

    public ViewLabelProvider() {
        
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
     */
    public String getText(Object obj) {
        return obj.toString();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.viewers.LabelProvider#getImage(java.lang.Object)
     */
    public Image getImage(Object obj) {
        Image image = PlatformUI.getWorkbench().getSharedImages().getImage(
                ISharedImages.IMG_OBJ_FOLDER);

        if (obj instanceof PetalsTreeObject) {
            if (JbiBeanUtils.isBc(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.BC_IMAGE;
            }
            if (JbiBeanUtils.isSa(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.SA_IMAGE;
            }
            if (JbiBeanUtils.isSe(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.SE_IMAGE;
            }
            if (JbiBeanUtils.isSl(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.SL_IMAGE;
            }
            if (JbiBeanUtils.isSu(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.SU_IMAGE;
            }
            if (JbiBeanUtils.isEmpty(((PetalsTreeObject) obj).getJbiBean())) {
                image = Constants.NO_IMAGE;
            }
        }

        return image;
    }
}
