/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: PetalsTreeObject.java,v 1.6 2007/04/26 10:45:53 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.views;

import org.eclipse.core.runtime.IAdaptable;
import org.objectweb.petals.tools.plugin.development.jbieditor.beans.Jbi;

/**
 * The content provider class is responsible for providing objects to the view.
 * It can wrap existing objects in adapters or simply return objects as-is.
 * These objects may be sensitive to the current input of the view, or ignore it
 * and always show the same content (like Task List, for example).
 * 
 * @author LAM
 */
public class PetalsTreeObject implements IAdaptable {

    private String name;
    private PetalsTreeParent parent;
    private Jbi jbiBean;

    public PetalsTreeObject(String name) {
        this.name = name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setParent(PetalsTreeParent parent) {
        this.parent = parent;
    }

    public PetalsTreeParent getParent() {
        return parent;
    }

    public String toString() {
        return getName();
    }

    public Object getAdapter(Class key) {
        return null;
    }

    /**
     * @return the jbiBean
     */
    public Jbi getJbiBean() {
        return jbiBean;
    }

    /**
     * @param jbiBean the jbiBean to set
     */
    public void setJbiBean(Jbi jbiBean) {
        this.jbiBean = jbiBean;
    }
    
}
