/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: PetalsTreeParent.java,v 1.3 2007/04/11 13:34:07 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.views;

import java.util.ArrayList;
import java.util.List;

/**
 * @author LAM
 */
public class PetalsTreeParent extends PetalsTreeObject {

    private List<PetalsTreeObject> children;

    public PetalsTreeParent(String name) {
        super(name);
        children = new ArrayList<PetalsTreeObject>();
    }

    public void addChild(PetalsTreeObject child) {
        children.add(child);
        child.setParent(this);
    }

    public void removeChild(PetalsTreeObject child) {
        children.remove(child);
        child.setParent(null);
    }

    public PetalsTreeObject[] getChildren() {
        return (PetalsTreeObject[]) children
                .toArray(new PetalsTreeObject[children.size()]);
    }

    public boolean hasChildren() {
        return children.size() > 0;
    }

}
