/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizard.su.filetransfer.customization;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.development.wizard.su.filetransfer.beans.ProvidedSuBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.NamespaceBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.ProvidedSuBeans;

/**
 * @author alouis
 */
public class ExtensionComposite extends Composite {
    
    private static final int TABLE_HEIGHT = 150;
    private static final int TABLE_COLUMN_WIDTH = 450;
    private static final int IMG_SIZE = 19;
    private static final int HORIZ_SPAN = 4;
    
    private static final String IMAGE_CLEAR_PATH = "/icons/rem.gif"; //$NON-NLS-1$
    private static final String NEW = Messages.ExtensionComposite_1;
    
    // TODO : propose a mean to correctly define the namespace 
	protected static final QName PETALS_NAMESPACE_URI = new QName ("http://petals.objectweb.org", Messages.ExtensionComposite_3);  //  @jve:decl-index=0: //$NON-NLS-1$
    
    private Group groupConsumes = null;
    private Label labelSelectSu = null;
    private Table tableSuList = null;
    private Label labelConsumesServiceName = null;
    private Text textServiceName = null;
    private Label labelInterfaceName = null;
    private Text textInterfaceName = null;
    private Label labelEndpointName = null;
    private Text textEndpointName = null;
    private Label labelLinkType = null;
    private Combo comboLinkType = null;
    private Label labelAddress = null;
    private Text directoryName = null;
    private Button buttonEraseServiceName = null;
    private Button buttonEndpoint = null;
    private int suListIndex = -1;
    private List<ProvidedSuBean> suList;  //  @jve:decl-index=0:
    private Button buttonAddNew = null;
    private Label filler3 = null;
  	private Label typeLabel = null;
	private Label consumesLabel = null;
	private Button consumesButton = null;
	private Label providesLabel = null;
	private Button providesButton = null;
	private ProvidedSuBeans suBean = new ProvidedSuBeans();  //  @jve:decl-index=0:
 
    /**
     * @param parent
     * @param style
     */
    public ExtensionComposite(Composite parent, int style) {
        super(parent, style);
        initialize();
    }
    
    /**
     * This method initializes this
     */
    private void initialize() {
        GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        this.setLayout(gridLayout);
        createGroupConsumes();
    }
    
    /**
     * This method initializes groupConsumes
     */
    private void createGroupConsumes() {
        GridData gridData21 = new GridData();
        gridData21.heightHint = 35;
        GridData gridData11 = new GridData();
        gridData11.horizontalSpan = 3;
        gridData11.verticalAlignment = GridData.END;
        gridData11.horizontalAlignment = GridData.BEGINNING;
        GridData gridData9 = new GridData();
        GridData gridData8 = new GridData();
        gridData8.horizontalSpan = 2;
        GridData gridData7 = new GridData();
        gridData7.horizontalSpan = 2;
        GridData gridData6 = new GridData();
        gridData6.horizontalSpan = 2;
        GridData gridData = new GridData();
        gridData.horizontalSpan = 2;
        GridData gridData5 = new GridData();
        gridData5.heightHint = IMG_SIZE;
        gridData5.widthHint = IMG_SIZE;
        GridData gridData4 = new GridData();
        gridData4.verticalAlignment = GridData.CENTER;
        gridData4.grabExcessHorizontalSpace = true;
        gridData4.horizontalAlignment = GridData.FILL;
        GridLayout gridLayout1 = new GridLayout();
        gridLayout1.numColumns = 5;
        GridData gridData1 = new GridData();
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        gridData1.horizontalSpan = 2;
        gridData1.verticalAlignment = GridData.CENTER;
        groupConsumes = new Group(this, SWT.NONE);
        groupConsumes.setText(Messages.ExtensionComposite_4);
        groupConsumes.setLayout(gridLayout1);
        groupConsumes.setLayoutData(gridData1);
        
        GridData gridData3 = new GridData();
        gridData3.heightHint = TABLE_HEIGHT;
        gridData3.horizontalAlignment = GridData.FILL;
        gridData3.verticalAlignment = GridData.FILL;
        gridData3.grabExcessVerticalSpace = true;
        gridData3.horizontalSpan = HORIZ_SPAN;
        GridData gridData2 = new GridData();
        gridData2.horizontalAlignment = GridData.FILL;
        gridData2.grabExcessHorizontalSpace = true;
        gridData2.horizontalSpan = HORIZ_SPAN;
        gridData2.verticalAlignment = GridData.CENTER;
        typeLabel = new Label(groupConsumes, SWT.NONE);
        typeLabel.setText(Messages.ExtensionComposite_5);

        consumesLabel = new Label(groupConsumes, SWT.NONE);
        consumesLabel.setText(Messages.ExtensionComposite_6);
        
        consumesButton = new Button(groupConsumes, SWT.RADIO);
        consumesButton.setSelection(true);
        consumesButton
        		.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
        			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
        				tableSuList.setEnabled(true);
        				comboLinkType.setEnabled(true);
        			}
        		});
        
        Label filler5 = new Label(groupConsumes, SWT.NONE);
        Label filler6 = new Label(groupConsumes, SWT.NONE);
        Label filler7 = new Label(groupConsumes, SWT.NONE);

        providesLabel = new Label(groupConsumes, SWT.NONE);
        providesLabel.setText(Messages.ExtensionComposite_7);
        
        providesButton = new Button(groupConsumes, SWT.RADIO);
        providesButton
        		.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
        			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
        				tableSuList.setEnabled(false);
        				comboLinkType.setEnabled(false);
        			}
        		});
        
        Label filler16 = new Label(groupConsumes, SWT.NONE);
        Label filler17 = new Label(groupConsumes, SWT.NONE);
        
        labelSelectSu = new Label(groupConsumes, SWT.NONE);
        labelSelectSu.setText(Messages.ExtensionComposite_8);
        labelSelectSu.setLayoutData(gridData2);
        Label filler14 = new Label(groupConsumes, SWT.NONE);
        tableSuList = new Table(groupConsumes, SWT.BORDER 
                | SWT.V_SCROLL | SWT.H_SCROLL | SWT.CHECK);
        tableSuList.setLayoutData(gridData3);
        tableSuList.setHeaderVisible(false);
        tableSuList.setLinesVisible(false);
        Label filler13 = new Label(groupConsumes, SWT.NONE);
        tableSuList.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(SelectionEvent e) { }
            public void widgetSelected(SelectionEvent e) {
                suListIndex = tableSuList.getSelectionIndex();
                
                if (suListIndex == -1) {
                    int i = 0;
                    for (TableItem current : tableSuList.getItems()) {
                        if (current == e.item) {
                            suListIndex = i;
                        }
                        i++;
                    }
                }
                
                textServiceName.setText(
                        suList.get(suListIndex).getProvidedBean().
                        getServiceName().getValue());
                textInterfaceName.setText(
                        suList.get(suListIndex).getProvidedBean().
                        getInterfaceName().getValue());
                textEndpointName.setText(
                        suList.get(suListIndex).getProvidedBean().getEndpointName());
                comboLinkType.setText(
                        suList.get(suListIndex).getProvidedBean().getLinkType());
            }
        });
        
        labelConsumesServiceName = new Label(groupConsumes, SWT.NONE);
        labelConsumesServiceName.setText(Messages.ExtensionComposite_9);
        labelConsumesServiceName.setLayoutData(gridData8);
        textServiceName = new Text(groupConsumes, SWT.BORDER);
        textServiceName.setLayoutData(gridData4);
        textServiceName.addModifyListener(new ModifyListener() {

            public void modifyText(ModifyEvent e) {
            	if (suListIndex!=-1){
            		suList.get(suListIndex).getProvidedBean().getServiceName().setValue(
	                        textServiceName.getText());
	                suList.get(suListIndex).setUrl(textServiceName.getText());
            	}
                suBean.getServiceName().setValue(textServiceName.getText());
                suBean.getServiceName().setNamespaceUri(PETALS_NAMESPACE_URI);
//                refreshTable();
            }
            
        });
        
        buttonEraseServiceName = new Button(groupConsumes, SWT.NONE);
        buttonEraseServiceName.setImage(
                new Image(
                        Display.getCurrent(), 
                        getClass().getResourceAsStream(IMAGE_CLEAR_PATH)));
        buttonEraseServiceName.setLayoutData(gridData5);
        buttonEraseServiceName.setToolTipText(Messages.ExtensionComposite_10);
        Label filler12 = new Label(groupConsumes, SWT.NONE);
        buttonEraseServiceName.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(SelectionEvent e) { }

            public void widgetSelected(SelectionEvent e) {
                textServiceName.setText(""); //$NON-NLS-1$
            }
            
        });
        
        labelInterfaceName = new Label(groupConsumes, SWT.NONE);
        labelInterfaceName.setText(Messages.ExtensionComposite_12);
        labelInterfaceName.setLayoutData(gridData7);
        textInterfaceName = new Text(groupConsumes, SWT.BORDER);
        textInterfaceName.setLayoutData(gridData4);
        textInterfaceName.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
            	if (suListIndex!=-1){
	                suList.get(suListIndex).getProvidedBean().getInterfaceName().setValue(
	                        textInterfaceName.getText());
            	}
                suBean.getInterfaceName().setValue(textInterfaceName.getText());
                suBean.getInterfaceName().setNamespaceUri(PETALS_NAMESPACE_URI);
            }
            
        });
        
        Label filler2 = new Label(groupConsumes, SWT.NONE);
        Label filler11 = new Label(groupConsumes, SWT.NONE);
        labelEndpointName = new Label(groupConsumes, SWT.NONE);
        labelEndpointName.setText(Messages.ExtensionComposite_13);
        labelEndpointName.setLayoutData(gridData6);
        textEndpointName = new Text(groupConsumes, SWT.BORDER);
        textEndpointName.setLayoutData(gridData4);
        textEndpointName.addModifyListener(new ModifyListener() {

            public void modifyText(ModifyEvent e) {
            	if (suListIndex!=-1){
	                suList.get(suListIndex).getProvidedBean().setEndpointName(
	                        textEndpointName.getText());
            	}
                suBean.setEndpointName(textEndpointName.getText());
            }
            
        });
        
        buttonEndpoint = new Button(groupConsumes, SWT.NONE);
        buttonEndpoint.setImage(
                new Image(
                        Display.getCurrent(), 
                        getClass().getResourceAsStream(IMAGE_CLEAR_PATH)));
        buttonEndpoint.setLayoutData(gridData5);
        buttonEndpoint.setToolTipText(Messages.ExtensionComposite_14);
        Label filler10 = new Label(groupConsumes, SWT.NONE);
        buttonEndpoint.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(SelectionEvent e) { }

            public void widgetSelected(SelectionEvent e) {
                textEndpointName.setText(""); //$NON-NLS-1$
            }
            
        });
        
        labelLinkType = new Label(groupConsumes, SWT.NONE);
        labelLinkType.setText(Messages.ExtensionComposite_16);
        labelLinkType.setLayoutData(gridData);
        comboLinkType = new Combo(groupConsumes, SWT.BORDER);
        comboLinkType.setLayoutData(gridData4);
        comboLinkType.addModifyListener(new ModifyListener() {

            public void modifyText(ModifyEvent e) {
            	if (suListIndex!=-1){
	                suList.get(suListIndex).getProvidedBean().setLinkType(
	                        comboLinkType.getText());
            	}
            }
            
        });
        comboLinkType.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(SelectionEvent e) { }

            public void widgetSelected(SelectionEvent e) {
            	if (suListIndex!=-1){
	                suList.get(suListIndex).getProvidedBean().setLinkType(
	                        comboLinkType.getItem(comboLinkType.getSelectionIndex()));
            	}
                suBean.setLinkType(comboLinkType.getItem(comboLinkType.getSelectionIndex()));
            }
            
        });
        initializeCombo();
        
        Label filler = new Label(groupConsumes, SWT.NONE);
        Label filler9 = new Label(groupConsumes, SWT.NONE);
        labelAddress = new Label(groupConsumes, SWT.NONE);
        labelAddress.setText(Messages.ExtensionComposite_17);
        labelAddress.setLayoutData(gridData9);
        Label filler4 = new Label(groupConsumes, SWT.NONE);
        directoryName = new Text(groupConsumes, SWT.BORDER);
        directoryName.setLayoutData(gridData4);
        Label filler1 = new Label(groupConsumes, SWT.NONE);
        Label filler8 = new Label(groupConsumes, SWT.NONE);
        buttonAddNew = new Button(groupConsumes, SWT.NONE);
        buttonAddNew.setText(Messages.ExtensionComposite_18);
        buttonAddNew.setLayoutData(gridData11);
        buttonAddNew.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(SelectionEvent e) { }
            public void widgetSelected(SelectionEvent e) {
                ProvidedSuBean newServiceBean = new ProvidedSuBean();
                ProvidedSuBeans newProvidedSuBeans = new ProvidedSuBeans();
                NamespaceBean newServiceNs = new NamespaceBean();
                QName newServiceQn = new QName(NEW, NEW);
                newServiceNs.setNamespaceUri(newServiceQn);
                newServiceNs.setValue(NEW);
                NamespaceBean newInterfaceNs = new NamespaceBean();
                QName newInterfaceQn = new QName(NEW, NEW);
                newInterfaceNs.setNamespaceUri(newInterfaceQn);
                newInterfaceNs.setValue(NEW);
                newProvidedSuBeans.setServiceName(newServiceNs);
                newProvidedSuBeans.setInterfaceName(newInterfaceNs);
                newProvidedSuBeans.setEndpointName(NEW);
                newServiceBean.setUrl(NEW);
                newServiceBean.setProvidedBean(newProvidedSuBeans);
                suList.add(newServiceBean);
                refreshTable();
            }
        });
        
        filler3 = new Label(groupConsumes, SWT.NONE);
        filler3.setLayoutData(gridData21);
        
        TableColumn colonne1 = new TableColumn(tableSuList, SWT.LEFT);
        colonne1.setWidth(TABLE_COLUMN_WIDTH);
    }

    public Combo getComboLinkType() {
        return comboLinkType;
    }

    public Text getTextServiceName() {
        return textServiceName;
    }

    public Text getTextEndpointName() {
        return textEndpointName;
    }

    public Text getTextInterfaceName() {
        return textInterfaceName;
    }
    
    /**
     * Refresh the table
     */
    private void fillSuTable() {
        tableSuList.removeAll();
        
        for (ProvidedSuBean current : suList) {
            TableItem line = new TableItem(tableSuList, SWT.NONE);
            line.setText(current.getProvidedBean().getServiceName().getValue());
        }
    }
    
    private void refreshTable() {
        List<Integer> checkedLines = new ArrayList<Integer>();
        
        // Saves the checked positions
        int i = 0;
        for (TableItem current : tableSuList.getItems()) {
            if (current.getChecked()) {
                checkedLines.add(new Integer(i));
            }
            i++;
        }
        
        // refresh the table
        fillSuTable();
        
        // get the checked positions back
        for (Integer currentInt : checkedLines) {
            tableSuList.getItem(currentInt.intValue()).setChecked(true);
        }
    }

    public Text getDirectoryName() {
        return directoryName;
    }

    public void setSuList(List<ProvidedSuBeans> suList) {
        suListIndex = -1;
        this.suList = new ArrayList<ProvidedSuBean>();

        for (ProvidedSuBeans current : suList) {
            ProvidedSuBean newProvidedBean = new ProvidedSuBean();
            newProvidedBean.setProvidedBean(current);
            newProvidedBean.setUrl(current.getServiceName().getValue());
            this.suList.add(newProvidedBean);
        }
        
        fillSuTable();
    }

    public List<ProvidedSuBean> getSuList() {
        List<ProvidedSuBean> selectedSuList = new ArrayList<ProvidedSuBean>();
        
        int i = 0;
        for (TableItem current : tableSuList.getItems()) {
            if (current.getChecked()) {
                selectedSuList.add(suList.get(i));
            }
            i++;
        }
        
        return selectedSuList;
    }
    

    
    private void initializeCombo() {
        comboLinkType.add(""); //$NON-NLS-1$
        comboLinkType.add(Messages.ExtensionComposite_20);
        comboLinkType.add(Messages.ExtensionComposite_21);
        comboLinkType.add(Messages.ExtensionComposite_22);
    }

	public Button getConsumesButton() {
		return consumesButton;
	}

	public Button getProvidesButton() {
		return providesButton;
	}

	public ProvidedSuBeans getSuBean() {
		return suBean;
	}

}
