/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.wizard.su.filetransfer.customization;

import java.util.List;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.wizard.IWizardPage;
import org.objectweb.petals.tools.plugin.development.wizard.su.filetransfer.beans.ProvidedSuBean;
import org.objectweb.petals.tools.plugin.development.wizard.su.filetransfer.business.ProjectUtils;
import org.objectweb.petals.tools.plugin.development.wizards.interfaces.IWizardCustomization;
import org.objectweb.petals.tools.plugin.development.wizards.models.ProvidedSuBeans;

/**
 * @author alouis
 */
public class FileTransferWizardCustomization implements IWizardCustomization {

    private static List<ProvidedSuBean> suList;

    private static ProvidedSuBeans suBean;

    private static String directoryName;

    private static Boolean consumes;

    private static String componentVersion;
    
    private ExtensionsWizardPage extensionPage;

    /**
     * 
     * Creates a new instance of {@link FileTransferWizardCustomization}
     *
     */
    public FileTransferWizardCustomization() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.tools.plugin.development.wizards.interfaces.IWizardCustomization#addSpecificRessourcesToProject(org.eclipse.core.resources.IProject)
     */
    public void addSpecificRessourcesToProject(IProject project, IProgressMonitor monitor)
            throws CoreException {

        monitor.worked(13);
        monitor.subTask(Messages.FileTransferWizardCustomization_0);

        ProjectUtils.processJbi(project, Constants.RESSOURCE_JBI_CONSUMES, consumes.booleanValue(),
                suList, suBean, directoryName);

        Version componentVersion = Version
                .getVersion(FileTransferWizardCustomization.componentVersion);
        if (componentVersion == null) {
            componentVersion = Version.getVersion(Version.DEFAULT);
        }
        ProjectUtils.processPom(project, componentVersion);

        // Output source directories and ClassPath clean
        ProjectUtils.processCleanClasspath(project);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.tools.plugin.development.wizards.interfaces.IWizardCustomization#getExtensionsWizardPage()
     */
    public IWizardPage getExtensionsWizardPage() {
        if (extensionPage == null) {
            extensionPage = new ExtensionsWizardPage(getExtensionPageName());
        }
        return extensionPage;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.tools.plugin.development.wizards.interfaces.IWizardCustomization#getExtensionPageName()
     */
    public String getExtensionPageName() {
        return ExtensionsWizardPage.NAME;
    }

    public static void setData(boolean consumes, List<ProvidedSuBean> suList,
            ProvidedSuBeans suBean, String directoryName) {
        FileTransferWizardCustomization.consumes = Boolean.valueOf(consumes);
        FileTransferWizardCustomization.suList = suList;
        FileTransferWizardCustomization.suBean = suBean;
        FileTransferWizardCustomization.directoryName = directoryName;
    }

}
