/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.wizard.su.soap.customization;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.development.wizard.su.soap.beans.ProvidedSuBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.NamespaceBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.ProvidedSuBeans;

/**
 * @author LAM
 * @author chamerling - eBM WebSourcing
 */
public class ExtensionComposite extends Composite {

    private static final int TABLE_HEIGHT = 150;

    private static final int TABLE_COLUMN_WIDTH = 450;

    private static final int IMG_SIZE = 19;

    private static final int HORIZ_SPAN = 4;

    private static final String IMAGE_CLEAR_PATH = "/icons/rem.gif"; //$NON-NLS-1$

    private static final String NEW = Messages.ExtensionComposite_1;

    private Group groupConsumes = null;

    private Group groupVersion;

    private Label labelSelectSu = null;

    private Table tableSuList = null;

    private Label labelConsumesServiceName = null;

    private Text textConsumesServiceName = null;

    private Label labelInterfaceName = null;

    private Text textInterfaceName = null;

    private Label labelEndpointName = null;

    private Text textEndpointName = null;

    private Label labelLinkType = null;

    private Combo comboLinkType = null;

    private Label labelAddress = null;

    private Text textUrl = null;

    private Button buttonEraseServiceName = null;

    private Label labelUrlPrefix = null;

    private int suListIndex;

    private List<ProvidedSuBean> suList;

    private Button buttonAddNew = null;

    private Label filler3 = null;

    private Label labelVersion;

    private Combo comboVersion;

    /**
     * @param parent
     * @param style
     */
    public ExtensionComposite(final Composite parent, final int style) {
        super(parent, style);
        this.initialize();
    }

    /**
     * This method initializes groupConsumes
     */
    private void createGroupConsumes() {
        final GridData gridData21 = new GridData();
        gridData21.heightHint = 35;
        final GridData gridData11 = new GridData();
        gridData11.horizontalSpan = 3;
        gridData11.verticalAlignment = GridData.END;
        gridData11.horizontalAlignment = GridData.BEGINNING;
        final GridData gridData10 = new GridData();
        gridData10.horizontalAlignment = GridData.END;
        gridData10.verticalAlignment = GridData.CENTER;
        final GridData gridData9 = new GridData();
        final GridData gridData8 = new GridData();
        gridData8.horizontalSpan = 2;
        final GridData gridData7 = new GridData();
        gridData7.horizontalSpan = 2;
        final GridData gridData = new GridData();
        gridData.horizontalSpan = 2;
        final GridData gridData5 = new GridData();
        gridData5.heightHint = ExtensionComposite.IMG_SIZE;
        gridData5.widthHint = ExtensionComposite.IMG_SIZE;
        final GridData gridData4 = new GridData();
        gridData4.verticalAlignment = GridData.CENTER;
        gridData4.grabExcessHorizontalSpace = true;
        gridData4.horizontalAlignment = GridData.FILL;

        final GridLayout gridLayout1 = new GridLayout();
        gridLayout1.numColumns = ExtensionComposite.HORIZ_SPAN;
        final GridData gridData1 = new GridData();
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        gridData1.horizontalSpan = 2;
        gridData1.verticalAlignment = GridData.CENTER;

        final GridLayout gridLayout2 = new GridLayout();
        gridLayout2.numColumns = ExtensionComposite.HORIZ_SPAN;
        final GridData gridDataVersion = new GridData();
        gridDataVersion.horizontalAlignment = GridData.FILL;
        gridDataVersion.grabExcessHorizontalSpace = true;
        gridDataVersion.horizontalSpan = 2;
        gridDataVersion.verticalAlignment = GridData.CENTER;

        // The SOAP component version
        this.groupVersion = new Group(this, SWT.NONE);
        this.groupVersion.setText(Messages.ExtensionComposite_2);
        this.groupVersion.setLayout(gridLayout2);
        this.groupVersion.setLayoutData(gridDataVersion);
        this.labelVersion = new Label(this.groupVersion, SWT.NONE);
        this.labelVersion.setText(Messages.ExtensionComposite_3);
        this.comboVersion = new Combo(this.groupVersion, SWT.NONE);
        final Version[] versions = Version.values();
        for (final Version version : versions) {
            this.comboVersion.add(version.getVersion());
            if (version.isDefaultVersion()) {
                this.comboVersion.select(comboVersion.getItemCount() -1 );
            }
        }

        // the service to consume
        this.groupConsumes = new Group(this, SWT.NONE);
        this.groupConsumes.setText(Messages.ExtensionComposite_4);
        this.groupConsumes.setLayout(gridLayout1);
        this.groupConsumes.setLayoutData(gridData1);

        final GridData gridData3 = new GridData();
        gridData3.heightHint = ExtensionComposite.TABLE_HEIGHT;
        gridData3.horizontalAlignment = GridData.FILL;
        gridData3.verticalAlignment = GridData.FILL;
        gridData3.grabExcessVerticalSpace = true;
        gridData3.horizontalSpan = ExtensionComposite.HORIZ_SPAN;
        final GridData gridData2 = new GridData();
        gridData2.horizontalAlignment = GridData.FILL;
        gridData2.grabExcessHorizontalSpace = true;
        gridData2.horizontalSpan = ExtensionComposite.HORIZ_SPAN;
        gridData2.verticalAlignment = GridData.CENTER;

        this.labelSelectSu = new Label(this.groupConsumes, SWT.NONE);
        this.labelSelectSu
                .setText(Messages.ExtensionComposite_5);
        this.labelSelectSu.setLayoutData(gridData2);
        this.tableSuList = new Table(this.groupConsumes, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL
                | SWT.CHECK);
        this.tableSuList.setLayoutData(gridData3);
        this.tableSuList.setHeaderVisible(false);
        this.tableSuList.setLinesVisible(false);
        this.tableSuList.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                ExtensionComposite.this.suListIndex = ExtensionComposite.this.tableSuList
                        .getSelectionIndex();

                if (ExtensionComposite.this.suListIndex == -1) {
                    int i = 0;
                    for (final TableItem current : ExtensionComposite.this.tableSuList.getItems()) {
                        if (current == e.item) {
                            ExtensionComposite.this.suListIndex = i;
                        }
                        i++;
                    }
                }

                ExtensionComposite.this.textConsumesServiceName
                        .setText(ExtensionComposite.this.suList.get(
                                ExtensionComposite.this.suListIndex).getProvidedBean()
                                .getServiceName().getValue());
                ExtensionComposite.this.textInterfaceName.setText(ExtensionComposite.this.suList
                        .get(ExtensionComposite.this.suListIndex).getProvidedBean()
                        .getInterfaceName().getValue());
                ExtensionComposite.this.comboLinkType.setText(ExtensionComposite.this.suList.get(
                        ExtensionComposite.this.suListIndex).getProvidedBean().getLinkType());
                ExtensionComposite.this.textUrl.setText(ExtensionComposite.this.suList.get(
                        ExtensionComposite.this.suListIndex).getProvidedBean().getServiceName()
                        .getValue());
            }
        });

        // consumes service
        this.labelConsumesServiceName = new Label(this.groupConsumes, SWT.NONE);
        this.labelConsumesServiceName.setText(Messages.ExtensionComposite_6);
        this.labelConsumesServiceName.setLayoutData(gridData8);
        this.textConsumesServiceName = new Text(this.groupConsumes, SWT.BORDER);
        this.textConsumesServiceName.setLayoutData(gridData4);
        this.textConsumesServiceName.addModifyListener(new ModifyListener() {
            public void modifyText(final ModifyEvent e) {
                ExtensionComposite.this.textUrl
                        .setText(ExtensionComposite.this.textConsumesServiceName.getText());
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex)
                        .getProvidedBean().getServiceName().setValue(
                                ExtensionComposite.this.textConsumesServiceName.getText());
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex).setUrl(
                        ExtensionComposite.this.textConsumesServiceName.getText());
                // refreshTable();
            }
        });

        this.buttonEraseServiceName = new Button(this.groupConsumes, SWT.NONE);
        this.buttonEraseServiceName.setImage(new Image(Display.getCurrent(), this.getClass()
                .getResourceAsStream(ExtensionComposite.IMAGE_CLEAR_PATH)));
        this.buttonEraseServiceName.setLayoutData(gridData5);
        this.buttonEraseServiceName.setToolTipText(Messages.ExtensionComposite_7);
        this.buttonEraseServiceName.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                ExtensionComposite.this.textConsumesServiceName.setText(""); //$NON-NLS-1$
            }
        });

        // consumed interface name
        this.labelInterfaceName = new Label(this.groupConsumes, SWT.NONE);
        this.labelInterfaceName.setText(Messages.ExtensionComposite_9);
        this.labelInterfaceName.setLayoutData(gridData7);
        this.textInterfaceName = new Text(this.groupConsumes, SWT.BORDER);
        this.textInterfaceName.setLayoutData(gridData4);
        this.textInterfaceName.addModifyListener(new ModifyListener() {
            public void modifyText(final ModifyEvent e) {
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex)
                        .getProvidedBean().getInterfaceName().setValue(
                                ExtensionComposite.this.textInterfaceName.getText());
            }
        });

        // consumed endpoint name
        this.labelEndpointName = new Label(this.groupConsumes, SWT.NONE);
        this.labelEndpointName.setText(Messages.ExtensionComposite_10);
        this.labelEndpointName.setLayoutData(gridData7);
        this.textEndpointName = new Text(this.groupConsumes, SWT.BORDER);
        this.textEndpointName.setLayoutData(gridData4);
        this.textEndpointName.addModifyListener(new ModifyListener() {
            public void modifyText(final ModifyEvent e) {
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex)
                        .getProvidedBean().setEndpointName(
                                ExtensionComposite.this.textEndpointName.getText());
            }
        });

        final Label filler2 = new Label(this.groupConsumes, SWT.NONE);
        this.labelLinkType = new Label(this.groupConsumes, SWT.NONE);
        this.labelLinkType.setText(Messages.ExtensionComposite_11);
        this.labelLinkType.setLayoutData(gridData);
        this.comboLinkType = new Combo(this.groupConsumes, SWT.BORDER);
        this.comboLinkType.setLayoutData(gridData4);
        this.comboLinkType.addModifyListener(new ModifyListener() {

            public void modifyText(final ModifyEvent e) {
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex)
                        .getProvidedBean().setLinkType(
                                ExtensionComposite.this.comboLinkType.getText());
            }

        });
        this.comboLinkType.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                ExtensionComposite.this.suList.get(ExtensionComposite.this.suListIndex)
                        .getProvidedBean().setLinkType(
                                ExtensionComposite.this.comboLinkType
                                        .getItem(ExtensionComposite.this.comboLinkType
                                                .getSelectionIndex()));
            }

        });
        this.initializeComboLinkType();

        final Label filler = new Label(this.groupConsumes, SWT.NONE);
        this.labelAddress = new Label(this.groupConsumes, SWT.NONE);
        this.labelAddress.setText(Messages.ExtensionComposite_12);
        this.labelAddress.setLayoutData(gridData9);
        this.labelUrlPrefix = new Label(this.groupConsumes, SWT.NONE);
        this.labelUrlPrefix.setText(Messages.ExtensionComposite_13);
        this.labelUrlPrefix.setLayoutData(gridData10);
        this.textUrl = new Text(this.groupConsumes, SWT.BORDER);
        this.textUrl.setLayoutData(gridData4);
        final Label filler1 = new Label(this.groupConsumes, SWT.NONE);
        this.buttonAddNew = new Button(this.groupConsumes, SWT.NONE);
        this.buttonAddNew.setText(Messages.ExtensionComposite_14);
        this.buttonAddNew.setLayoutData(gridData11);
        this.buttonAddNew.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                final ProvidedSuBean newServiceBean = new ProvidedSuBean();
                final ProvidedSuBeans newProvidedSuBeans = new ProvidedSuBeans();
                final NamespaceBean newServiceNs = new NamespaceBean();
                final QName newServiceQn = new QName(ExtensionComposite.NEW, ExtensionComposite.NEW);
                newServiceNs.setNamespaceUri(newServiceQn);
                newServiceNs.setValue(ExtensionComposite.NEW);
                final NamespaceBean newInterfaceNs = new NamespaceBean();
                final QName newInterfaceQn = new QName(ExtensionComposite.NEW,
                        ExtensionComposite.NEW);
                newInterfaceNs.setNamespaceUri(newInterfaceQn);
                newInterfaceNs.setValue(ExtensionComposite.NEW);
                newProvidedSuBeans.setServiceName(newServiceNs);
                newProvidedSuBeans.setInterfaceName(newInterfaceNs);
                newServiceBean.setUrl(ExtensionComposite.NEW);
                newServiceBean.setProvidedBean(newProvidedSuBeans);
                ExtensionComposite.this.suList.add(newServiceBean);
                ExtensionComposite.this.refreshTable();
            }
        });

        this.filler3 = new Label(this.groupConsumes, SWT.NONE);
        this.filler3.setLayoutData(gridData21);

        final TableColumn colonne1 = new TableColumn(this.tableSuList, SWT.LEFT);
        colonne1.setWidth(ExtensionComposite.TABLE_COLUMN_WIDTH);
    }

    /**
     * Refresh the table
     */
    private void fillSuTable() {
        this.tableSuList.removeAll();

        for (final ProvidedSuBean current : this.suList) {
            final TableItem line = new TableItem(this.tableSuList, SWT.NONE);
            line.setText(current.getProvidedBean().getServiceName().getValue());
        }
    }

    public Combo getComboLinkType() {
        return this.comboLinkType;
    }

    public List<ProvidedSuBean> getSuList() {
        final List<ProvidedSuBean> selectedSuList = new ArrayList<ProvidedSuBean>();

        int i = 0;
        for (final TableItem current : this.tableSuList.getItems()) {
            if (current.getChecked()) {
                selectedSuList.add(this.suList.get(i));
            }
            i++;
        }

        return selectedSuList;
    }

    public Text getTextConsumesServiceName() {
        return this.textConsumesServiceName;
    }

    public Text getTextInterfaceName() {
        return this.textInterfaceName;
    }

    public Text getTextEndpointName() {
        return this.textEndpointName;
    }

    public String getTextComponentVersion() {
        return this.comboVersion.getText();
    }

    public Text getTextUrl() {
        return this.textUrl;
    }

    /**
     * 
     */
    private void initialize() {
        final GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        this.setLayout(gridLayout);
        this.createGroupConsumes();
    }

    /**
     * 
     */
    private void initializeComboLinkType() {
        this.comboLinkType.add(""); //$NON-NLS-1$
        this.comboLinkType.add(Messages.ExtensionComposite_16);
        this.comboLinkType.add(Messages.ExtensionComposite_17);
        this.comboLinkType.add(Messages.ExtensionComposite_18);
    }

    private void refreshTable() {
        final List<Integer> checkedLines = new ArrayList<Integer>();

        // Saves the checked positions
        int i = 0;
        for (final TableItem current : this.tableSuList.getItems()) {
            if (current.getChecked()) {
                checkedLines.add(new Integer(i));
            }
            i++;
        }

        // refresh the table
        this.fillSuTable();

        // get the checked positions back
        for (final Integer currentInt : checkedLines) {
            this.tableSuList.getItem(currentInt.intValue()).setChecked(true);
        }
    }

    public void setSuList(final List<ProvidedSuBeans> suList) {
        this.suListIndex = 0;
        this.suList = new ArrayList<ProvidedSuBean>();

        for (final ProvidedSuBeans current : suList) {
            final ProvidedSuBean newProvidedBean = new ProvidedSuBean();
            newProvidedBean.setProvidedBean(current);
            newProvidedBean.setUrl(current.getServiceName().getValue());
            this.suList.add(newProvidedBean);
        }

        this.fillSuTable();
    }

}
