/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.wizards;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

/**
 * @author LAM
 */
public class MavenIdComposite extends Composite {

    private Group groupMavenId = null;
    private Label labelMavenGroup = null;
    private Text textMavenGroup = null;
    private Label labelMavenVersion = null;
    private Text textMavenVersion = null;

    /**
     * Creates a new instance of {@link MavenIdComposite}
     *
     * @param parent
     * @param style
     */
    public MavenIdComposite(Composite parent, int style) {
        super(parent, style);
        initialize();
    }

    /**
     *
     */
    private void initialize() {
        setLayout(new GridLayout());
        createGroupMavenId();
    }

    /**
     * This method initializes groupMavenId
     *
     */
    private void createGroupMavenId() {
        GridData gridData1 = new GridData();
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        gridData1.verticalAlignment = GridData.CENTER;
        
        GridData gridData2 = new GridData();
        gridData2.horizontalAlignment = GridData.FILL;
        gridData2.grabExcessHorizontalSpace = true;
        gridData2.verticalAlignment = GridData.CENTER;
        
        GridData gridData3 = new GridData();
        gridData3.horizontalAlignment = GridData.FILL;
        gridData3.grabExcessHorizontalSpace = true;
        gridData3.verticalAlignment = GridData.CENTER;
        
        GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        
        groupMavenId = new Group(this, SWT.NONE);
        groupMavenId.setText(Messages.MavenIdComposite_0);
        groupMavenId.setLayoutData(gridData1);
        groupMavenId.setLayout(gridLayout);
        labelMavenGroup = new Label(groupMavenId, SWT.NONE);
        labelMavenGroup.setText(Messages.MavenIdComposite_1);
        textMavenGroup = new Text(groupMavenId, SWT.BORDER);
        textMavenGroup.setLayoutData(gridData3);
        labelMavenVersion = new Label(groupMavenId, SWT.NONE);
        labelMavenVersion.setText(Messages.MavenIdComposite_2);
        textMavenVersion = new Text(groupMavenId, SWT.BORDER);
        textMavenVersion.setText("1.0.0-SNAPSHOT"); //$NON-NLS-1$
        textMavenVersion.setLayoutData(gridData2);
    }

    public String getNamespace() {
        return textMavenGroup.getText();
    }

    public void setNamespace(String text) {
        textMavenGroup.setText(text);
    }

    public String getVersion() {
        return textMavenVersion.getText();
    }

    public void setVersion(String text) {
        textMavenVersion.setText(text);
    }

}
