/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: NewSharedLibraryProjectWizardComposite.java,v 1.5 2007/04/16 14:43:44 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizards;

import org.eclipse.core.runtime.Preferences;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.objectweb.petals.tools.plugin.development.Activator;
import org.objectweb.petals.tools.plugin.development.constants.ESBDevPrefConstants;
import org.objectweb.petals.tools.plugin.development.constants.WizardComposites;

/**
 * @author LAM
 */
public class NewSharedLibraryProjectWizardComposite extends Composite {

    private MavenIdComposite mavenComposite = null;
    
    private Preferences prefs;

    /**
     * @param parent
     * @param style
     */
    public NewSharedLibraryProjectWizardComposite(Composite parent, int style) {
        super(parent, style);
        prefs = Activator.getDefault().getPluginPreferences();
        initialize();
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        GridLayout gridLayout = new GridLayout();
        GridData gridData = new GridData();
        gridData.heightHint = WizardComposites.HEIGHT_HINT;
        gridData.widthHint = WizardComposites.WIDTH_HINT;
        GridData gridData1 = new GridData();
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        
        this.setLayout(new GridLayout());
        this.setSize(new Point(WizardComposites.SIZE, WizardComposites.SIZE));
        
        if (prefs.getBoolean(ESBDevPrefConstants.USE_MAVEN_FOR_BUILDING_NAME)) {
            mavenComposite = new MavenIdComposite(this, SWT.NONE);
            mavenComposite.setLayoutData(gridData1);
            mavenComposite.setLayout(gridLayout);
        }
    }

    public MavenIdComposite getMavenComposite() {
        return mavenComposite;
    }

}
