/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: NewSharedLibraryProjectWizardPage.java,v 1.5 2007/04/16 14:43:44 lam Exp $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizards;

import org.eclipse.core.resources.IProject;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.dialogs.WizardNewProjectCreationPage;

/**
 * @author LAM
 */
public class NewSharedLibraryProjectWizardPage extends
        WizardNewProjectCreationPage {

    /**
     * The SU wizard page Composite
     */
    private NewSharedLibraryProjectWizardComposite slComposite;

    /**
     * @param pageName
     */
    public NewSharedLibraryProjectWizardPage(String pageName) {
        super(pageName);
        setTitle(pageName);
        setDescription(Messages.NewSharedLibraryProjectWizardPage_0);
        setPageComplete(false);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.ui.dialogs.WizardNewProjectCreationPage#createControl(org.eclipse.swt.widgets.Composite)
     */
    @Override
    public void createControl(Composite parent) {
        super.createControl(parent);
        
        GridData gridData = new GridData();
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessHorizontalSpace = true;
        slComposite = new NewSharedLibraryProjectWizardComposite(
                (Composite) getControl(), SWT.NONE);
        slComposite.setLayoutData(gridData);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.ui.dialogs.WizardNewProjectCreationPage#getProjectHandle()
     */
    @Override
    public IProject getProjectHandle() {
        return super.getProjectHandle();
    }

    public NewSharedLibraryProjectWizardComposite getSlComposite() {
        return slComposite;
    }

}
