/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.objectweb.petals.tools.plugin.development.jbieditor.business.WizardsUtils;

/**
 * @author LAM
 */
public class SelectSuListPage extends WizardPage {

    /**
     * The new SA project composite
     */
    private NewServiceAssemblyProjectWizardComposite saComposite;

    /**
     * Creates a new instance of {@link SelectSuListPage}
     * 
     * @param pageName
     */
    protected SelectSuListPage(String pageName) {
        super(pageName);
        setDescription(Messages.SelectSuListPage_0);
        setTitle(Messages.SelectSuListPage_1);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
     */
    public void createControl(Composite pageContainer) {
        GridData gd = new GridData();
        gd.horizontalAlignment = GridData.FILL;
        gd.grabExcessHorizontalSpace = true;
        gd.verticalAlignment = GridData.FILL;
        gd.grabExcessVerticalSpace = true;
        saComposite = new NewServiceAssemblyProjectWizardComposite(
                pageContainer, SWT.NONE);

        saComposite.setLayoutData(gd);
        saComposite.fillSuTable(WizardsUtils.getSuFromWorkspace());

        setControl(saComposite);
    }

    /**
     * @return the saComposite
     */
    public NewServiceAssemblyProjectWizardComposite getSaComposite() {
        return saComposite;
    }
}
