/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.plugin.development.wizards.custom;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.development.Activator;
import org.objectweb.petals.tools.plugin.development.wizards.NewServiceUnitProjectWizard;
import org.objectweb.petals.tools.plugin.development.wizards.models.NamespaceBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.ProvidedSuBean;
import org.objectweb.petals.tools.plugin.development.wizards.models.ProvidedSuBeans;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class ServiceUnitCustomizationComposite extends Composite {
    private static final int TABLE_HEIGHT = 150;

    private static final int TABLE_COLUMN_WIDTH = 450;

    private static final int IMG_SIZE = 19;

    private static final int HORIZ_SPAN = 4;

    private static final String NEW = Messages.ServiceUnitCustomizationComposite_0;

    protected static final QName PETALS_NAMESPACE_URI = new QName(
            Messages.ServiceUnitCustomizationComposite_26, Messages.ServiceUnitCustomizationComposite_2);

    private Group groupConsumesProvides = null;

    private Label labelSelectSu = null;

    private Table tableSuList = null;

    private Label labelConsumesServiceName = null;

    private Text textServiceName = null;

    private Label labelInterfaceName = null;

    private Text textInterfaceName = null;

    private Label labelEndpointName = null;

    private Text textEndpointName = null;

    private Label labelLinkType = null;

    private Combo comboLinkType = null;

    private Label labelNamespace = null;

    private Text textNamespace = null;

    private Button buttonDeleteServiceName = null;

    private Button buttonDeleteEndpoint = null;

    private int suListIndex = -1;

    private List<ProvidedSuBean> suList;

    private Button buttonAddNew = null;

    private Label filler3 = null;

    private Label typeLabel = null;

    private Label consumesLabel = null;

    private Button consumesButton = null;

    private Label providesLabel = null;

    private Button providesButton = null;

    private final ProvidedSuBeans suBean = new ProvidedSuBeans();

    private NewServiceUnitProjectWizard suWizard;

    /**
     * Creates a new instance of {@link ServiceUnitCustomizationComposite}
     * 
     * @param parent
     * @param style
     */
    public ServiceUnitCustomizationComposite(final Composite parent,
            final int style, NewServiceUnitProjectWizard suWizard) {
        super(parent, style);
        this.suWizard = suWizard;
        this.initialize();
    }

    /**
     * This method initializes groupConsumesProvides
     */
    private void createGroupConsumes() {
        final GridData gridData21 = new GridData();
        gridData21.heightHint = 35;
        final GridData gridData11 = new GridData();
        gridData11.horizontalSpan = 3;
        gridData11.verticalAlignment = GridData.END;
        gridData11.horizontalAlignment = GridData.BEGINNING;
        final GridData gridData9 = new GridData();
        final GridData gridData8 = new GridData();
        gridData8.horizontalSpan = 2;
        final GridData gridData7 = new GridData();
        gridData7.horizontalSpan = 2;
        final GridData gridData6 = new GridData();
        gridData6.horizontalSpan = 2;
        final GridData gridData = new GridData();
        gridData.horizontalSpan = 2;
        final GridData gridData5 = new GridData();
        gridData5.heightHint = ServiceUnitCustomizationComposite.IMG_SIZE;
        gridData5.widthHint = ServiceUnitCustomizationComposite.IMG_SIZE;
        final GridData gridData4 = new GridData();
        gridData4.verticalAlignment = GridData.CENTER;
        gridData4.grabExcessHorizontalSpace = true;
        gridData4.horizontalAlignment = GridData.FILL;
        final GridLayout gridLayout1 = new GridLayout();
        gridLayout1.numColumns = 5;
        final GridData gridData1 = new GridData();
        gridData1.horizontalAlignment = GridData.FILL;
        gridData1.grabExcessHorizontalSpace = true;
        gridData1.horizontalSpan = 2;
        gridData1.verticalAlignment = GridData.CENTER;
        this.groupConsumesProvides = new Group(this, SWT.NONE);
        this.groupConsumesProvides.setText(Messages.ServiceUnitCustomizationComposite_3);
        this.groupConsumesProvides.setLayout(gridLayout1);
        this.groupConsumesProvides.setLayoutData(gridData1);

        final GridData gridData3 = new GridData();
        gridData3.heightHint = ServiceUnitCustomizationComposite.TABLE_HEIGHT;
        gridData3.horizontalAlignment = GridData.FILL;
        gridData3.verticalAlignment = GridData.FILL;
        gridData3.grabExcessVerticalSpace = true;
        gridData3.horizontalSpan = ServiceUnitCustomizationComposite.HORIZ_SPAN;
        final GridData gridData2 = new GridData();
        gridData2.horizontalAlignment = GridData.FILL;
        gridData2.grabExcessHorizontalSpace = true;
        gridData2.horizontalSpan = ServiceUnitCustomizationComposite.HORIZ_SPAN;
        gridData2.verticalAlignment = GridData.CENTER;

        this.typeLabel = new Label(this.groupConsumesProvides, SWT.NONE);
        this.typeLabel.setText(Messages.ServiceUnitCustomizationComposite_4);

        this.consumesLabel = new Label(this.groupConsumesProvides, SWT.NONE);
        this.consumesLabel.setText(Messages.ServiceUnitCustomizationComposite_5);

        this.consumesButton = new Button(this.groupConsumesProvides, SWT.RADIO);
        this.consumesButton.setSelection(true);
        this.consumesButton
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    @Override
                    public void widgetSelected(
                            final org.eclipse.swt.events.SelectionEvent e) {
                        ServiceUnitCustomizationComposite.this.tableSuList
                                .setEnabled(true);
                        ServiceUnitCustomizationComposite.this.comboLinkType
                                .setEnabled(true);
                    }
                });

        final Label filler5 = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler6 = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler7 = new Label(this.groupConsumesProvides, SWT.NONE);

        this.providesLabel = new Label(this.groupConsumesProvides, SWT.NONE);
        this.providesLabel.setText(Messages.ServiceUnitCustomizationComposite_6);

        this.providesButton = new Button(this.groupConsumesProvides, SWT.RADIO);
        this.providesButton
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    @Override
                    public void widgetSelected(
                            final org.eclipse.swt.events.SelectionEvent e) {
                        ServiceUnitCustomizationComposite.this.tableSuList
                                .setEnabled(false);
                        ServiceUnitCustomizationComposite.this.comboLinkType
                                .setEnabled(false);
                    }
                });

        final Label filler16 = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler17 = new Label(this.groupConsumesProvides, SWT.NONE);

        this.labelSelectSu = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelSelectSu.setText(Messages.ServiceUnitCustomizationComposite_7);
        this.labelSelectSu.setLayoutData(gridData2);
        final Label filler14 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.tableSuList = new Table(this.groupConsumesProvides, SWT.BORDER
                | SWT.V_SCROLL | SWT.H_SCROLL | SWT.CHECK);
        this.tableSuList.setLayoutData(gridData3);
        this.tableSuList.setHeaderVisible(false);
        this.tableSuList.setLinesVisible(false);
        final Label filler13 = new Label(this.groupConsumesProvides, SWT.NONE);

        this.tableSuList.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                ServiceUnitCustomizationComposite.this.suListIndex = ServiceUnitCustomizationComposite.this.tableSuList
                        .getSelectionIndex();

                if (ServiceUnitCustomizationComposite.this.suListIndex == -1) {
                    int i = 0;
                    for (final TableItem current : ServiceUnitCustomizationComposite.this.tableSuList
                            .getItems()) {
                        if (current == e.item) {
                            ServiceUnitCustomizationComposite.this.suListIndex = i;
                        }
                        i++;
                    }
                }

                ServiceUnitCustomizationComposite.this.textServiceName
                        .setText(ServiceUnitCustomizationComposite.this.suList
                                .get(
                                        ServiceUnitCustomizationComposite.this.suListIndex)
                                .getProvidedBean().getServiceName().getValue());
                ServiceUnitCustomizationComposite.this.textInterfaceName
                        .setText(ServiceUnitCustomizationComposite.this.suList
                                .get(
                                        ServiceUnitCustomizationComposite.this.suListIndex)
                                .getProvidedBean().getInterfaceName()
                                .getValue());
                ServiceUnitCustomizationComposite.this.textEndpointName
                        .setText(ServiceUnitCustomizationComposite.this.suList
                                .get(
                                        ServiceUnitCustomizationComposite.this.suListIndex)
                                .getProvidedBean().getEndpointName());
                ServiceUnitCustomizationComposite.this.comboLinkType
                        .setText(ServiceUnitCustomizationComposite.this.suList
                                .get(
                                        ServiceUnitCustomizationComposite.this.suListIndex)
                                .getProvidedBean().getLinkType());
            }
        });

        this.labelConsumesServiceName = new Label(this.groupConsumesProvides,
                SWT.NONE);
        this.labelConsumesServiceName.setText(Messages.ServiceUnitCustomizationComposite_8);
        this.labelConsumesServiceName.setLayoutData(gridData8);
        this.textServiceName = new Text(this.groupConsumesProvides, SWT.BORDER);
        this.textServiceName.setLayoutData(gridData4);
        this.textServiceName.addModifyListener(new ModifyListener() {

            public void modifyText(final ModifyEvent e) {
                if (ServiceUnitCustomizationComposite.this.suListIndex != -1) {
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .getProvidedBean()
                            .getServiceName()
                            .setValue(
                                    ServiceUnitCustomizationComposite.this.textServiceName
                                            .getText());
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .setUrl(
                                    ServiceUnitCustomizationComposite.this.textServiceName
                                            .getText());
                }
                ServiceUnitCustomizationComposite.this.suBean
                        .getServiceName()
                        .setValue(
                                ServiceUnitCustomizationComposite.this.textServiceName
                                        .getText());
                ServiceUnitCustomizationComposite.this.suBean
                        .getServiceName()
                        .setNamespaceUri(
                                ServiceUnitCustomizationComposite.PETALS_NAMESPACE_URI);
                // refreshTable();
            }

        });

        this.buttonDeleteServiceName = new Button(this.groupConsumesProvides,
                SWT.NONE);
        this.buttonDeleteServiceName.setImage(AbstractUIPlugin
                .imageDescriptorFromPlugin(Activator.PLUGIN_ID,
                        Messages.ServiceUnitCustomizationComposite_9).createImage());
        this.buttonDeleteServiceName.setLayoutData(gridData5);
        this.buttonDeleteServiceName.setToolTipText(Messages.ServiceUnitCustomizationComposite_10);
        final Label filler12 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.buttonDeleteServiceName
                .addSelectionListener(new SelectionListener() {

                    public void widgetDefaultSelected(final SelectionEvent e) {
                    }

                    public void widgetSelected(final SelectionEvent e) {
                        ServiceUnitCustomizationComposite.this.textServiceName
                                .setText(""); //$NON-NLS-1$
                    }

                });

        this.labelInterfaceName = new Label(this.groupConsumesProvides,
                SWT.NONE);
        this.labelInterfaceName.setText(Messages.ServiceUnitCustomizationComposite_12);
        this.labelInterfaceName.setLayoutData(gridData7);
        this.textInterfaceName = new Text(this.groupConsumesProvides,
                SWT.BORDER);
        this.textInterfaceName.setLayoutData(gridData4);
        this.textInterfaceName.addModifyListener(new ModifyListener() {
            public void modifyText(final ModifyEvent e) {
                if (ServiceUnitCustomizationComposite.this.suListIndex != -1) {
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .getProvidedBean()
                            .getInterfaceName()
                            .setValue(
                                    ServiceUnitCustomizationComposite.this.textInterfaceName
                                            .getText());
                }
                ServiceUnitCustomizationComposite.this.suBean
                        .getInterfaceName()
                        .setValue(
                                ServiceUnitCustomizationComposite.this.textInterfaceName
                                        .getText());
                ServiceUnitCustomizationComposite.this.suBean
                        .getInterfaceName()
                        .setNamespaceUri(
                                ServiceUnitCustomizationComposite.PETALS_NAMESPACE_URI);
            }

        });

        final Label filler2 = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler11 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelEndpointName = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelEndpointName.setText(Messages.ServiceUnitCustomizationComposite_13);
        this.labelEndpointName.setLayoutData(gridData6);
        this.textEndpointName = new Text(this.groupConsumesProvides, SWT.BORDER);
        this.textEndpointName.setLayoutData(gridData4);
        this.textEndpointName.addModifyListener(new ModifyListener() {

            public void modifyText(final ModifyEvent e) {
                if (ServiceUnitCustomizationComposite.this.suListIndex != -1) {
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .getProvidedBean()
                            .setEndpointName(
                                    ServiceUnitCustomizationComposite.this.textEndpointName
                                            .getText());
                }
                ServiceUnitCustomizationComposite.this.suBean
                        .setEndpointName(ServiceUnitCustomizationComposite.this.textEndpointName
                                .getText());
            }

        });

        this.buttonDeleteEndpoint = new Button(this.groupConsumesProvides,
                SWT.NONE);
        this.buttonDeleteEndpoint.setImage(AbstractUIPlugin
                .imageDescriptorFromPlugin(Activator.PLUGIN_ID,
                        Messages.ServiceUnitCustomizationComposite_14).createImage());
        this.buttonDeleteEndpoint.setLayoutData(gridData5);
        this.buttonDeleteEndpoint.setToolTipText(Messages.ServiceUnitCustomizationComposite_15);
        final Label filler10 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.buttonDeleteEndpoint.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                ServiceUnitCustomizationComposite.this.textEndpointName
                        .setText(""); //$NON-NLS-1$
            }

        });

        this.labelLinkType = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelLinkType.setText(Messages.ServiceUnitCustomizationComposite_17);
        this.labelLinkType.setLayoutData(gridData);
        this.comboLinkType = new Combo(this.groupConsumesProvides, SWT.BORDER
                | SWT.READ_ONLY);
        this.comboLinkType.setLayoutData(gridData4);
        this.comboLinkType.addModifyListener(new ModifyListener() {

            public void modifyText(final ModifyEvent e) {
                if (ServiceUnitCustomizationComposite.this.suListIndex != -1) {
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .getProvidedBean()
                            .setLinkType(
                                    ServiceUnitCustomizationComposite.this.comboLinkType
                                            .getText());
                }
            }

        });
        this.comboLinkType.addSelectionListener(new SelectionListener() {

            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                if (ServiceUnitCustomizationComposite.this.suListIndex != -1) {
                    ServiceUnitCustomizationComposite.this.suList
                            .get(
                                    ServiceUnitCustomizationComposite.this.suListIndex)
                            .getProvidedBean()
                            .setLinkType(
                                    ServiceUnitCustomizationComposite.this.comboLinkType
                                            .getItem(ServiceUnitCustomizationComposite.this.comboLinkType
                                                    .getSelectionIndex()));
                }
                ServiceUnitCustomizationComposite.this.suBean
                        .setLinkType(ServiceUnitCustomizationComposite.this.comboLinkType
                                .getItem(ServiceUnitCustomizationComposite.this.comboLinkType
                                        .getSelectionIndex()));
            }

        });
        this.initializeLinkTypeCombo();

        final Label filler = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler9 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelNamespace = new Label(this.groupConsumesProvides, SWT.NONE);
        this.labelNamespace.setText(Messages.ServiceUnitCustomizationComposite_18);
        this.labelNamespace.setLayoutData(gridData9);
        final Label filler4 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.textNamespace = new Text(this.groupConsumesProvides, SWT.BORDER);
        this.textNamespace.setLayoutData(gridData4);
        final Label filler1 = new Label(this.groupConsumesProvides, SWT.NONE);
        final Label filler8 = new Label(this.groupConsumesProvides, SWT.NONE);

        this.buttonAddNew = new Button(this.groupConsumesProvides, SWT.NONE);
        this.buttonAddNew.setText(Messages.ServiceUnitCustomizationComposite_19);
        this.buttonAddNew.setLayoutData(gridData11);
        this.buttonAddNew.addSelectionListener(new SelectionListener() {
            public void widgetDefaultSelected(final SelectionEvent e) {
            }

            public void widgetSelected(final SelectionEvent e) {
                final ProvidedSuBean newServiceBean = new ProvidedSuBean();
                final ProvidedSuBeans newProvidedSuBeans = new ProvidedSuBeans();
                final NamespaceBean newServiceNs = new NamespaceBean();
                final QName newServiceQn = new QName(
                        ServiceUnitCustomizationComposite.NEW,
                        ServiceUnitCustomizationComposite.NEW);
                newServiceNs.setNamespaceUri(newServiceQn);
                newServiceNs.setValue(ServiceUnitCustomizationComposite.NEW);
                final NamespaceBean newInterfaceNs = new NamespaceBean();
                final QName newInterfaceQn = new QName(
                        ServiceUnitCustomizationComposite.NEW,
                        ServiceUnitCustomizationComposite.NEW);
                newInterfaceNs.setNamespaceUri(newInterfaceQn);
                newInterfaceNs.setValue(ServiceUnitCustomizationComposite.NEW);
                newProvidedSuBeans.setServiceName(newServiceNs);
                newProvidedSuBeans.setInterfaceName(newInterfaceNs);
                newProvidedSuBeans
                        .setEndpointName(ServiceUnitCustomizationComposite.NEW);
                newServiceBean.setUrl(ServiceUnitCustomizationComposite.NEW);
                newServiceBean.setProvidedBean(newProvidedSuBeans);
                ServiceUnitCustomizationComposite.this.suList
                        .add(newServiceBean);
                ServiceUnitCustomizationComposite.this.refreshTable();
            }
        });

        this.filler3 = new Label(this.groupConsumesProvides, SWT.NONE);
        this.filler3.setLayoutData(gridData21);

        final TableColumn colonne1 = new TableColumn(this.tableSuList, SWT.LEFT);
        colonne1.setWidth(ServiceUnitCustomizationComposite.TABLE_COLUMN_WIDTH);
    }

    /**
     * Refresh the table
     */
    private void fillSuTable() {
        this.tableSuList.removeAll();

        for (final ProvidedSuBean current : this.suList) {
            final TableItem line = new TableItem(this.tableSuList, SWT.NONE);
            line.setText(current.getProvidedBean().getServiceName().getValue());
        }
    }

    public Combo getComboLinkType() {
        return this.comboLinkType;
    }

    public Button getConsumesButton() {
        return this.consumesButton;
    }

    // public Text getExtensions() {
    // return this.extensions;
    // }

    public Button getProvidesButton() {
        return this.providesButton;
    }

    public ProvidedSuBeans getSuBean() {
        return this.suBean;
    }

    public List<ProvidedSuBean> getSuList() {
        final List<ProvidedSuBean> selectedSuList = new ArrayList<ProvidedSuBean>();

        int i = 0;
        for (final TableItem current : this.tableSuList.getItems()) {
            if (current.getChecked()) {
                selectedSuList.add(this.suList.get(i));
            }
            i++;
        }
        return selectedSuList;
    }

    /**
     * 
     * @return
     */
    public List<ProvidedSuBean> getCurrentSuBeans() {
        final List<ProvidedSuBean> list = new ArrayList<ProvidedSuBean>();
        ProvidedSuBeans bean = new ProvidedSuBeans();
        ProvidedSuBean result = new ProvidedSuBean();

        String namespace = getTextNamespace().getText();
        if (namespace == null) {
            namespace = Messages.ServiceUnitCustomizationComposite_25;
        }

        bean.setEndpointName(getTextEndpointName().getText());

        final NamespaceBean interfaceNs = new NamespaceBean();
        final QName itfQName = PETALS_NAMESPACE_URI;
        interfaceNs.setNamespaceUri(itfQName);
        interfaceNs.setValue(getTextInterfaceName().getText().trim());
        bean.setInterfaceName(interfaceNs);

        final NamespaceBean serviceNs = new NamespaceBean();
        final QName srvQName = PETALS_NAMESPACE_URI;
        serviceNs.setNamespaceUri(srvQName);
        serviceNs.setValue(getTextServiceName().getText().trim());
        bean.setServiceName(serviceNs);
        result.setProvidedBean(bean);
        
        list.add(result);
        
        return list;
    }

    public Text getTextEndpointName() {
        return this.textEndpointName;
    }

    public Text getTextInterfaceName() {
        return this.textInterfaceName;
    }

    public Text getTextServiceName() {
        return this.textServiceName;
    }

    /**
     * This method initializes this
     */
    private void initialize() {
        final GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        this.setLayout(gridLayout);
        this.createGroupConsumes();
    }

    /**
     * 
     */
    private void initializeLinkTypeCombo() {
        this.comboLinkType.add(""); //$NON-NLS-1$
        this.comboLinkType.add(Messages.ServiceUnitCustomizationComposite_22);
        this.comboLinkType.add(Messages.ServiceUnitCustomizationComposite_23);
        this.comboLinkType.add(Messages.ServiceUnitCustomizationComposite_24);
        this.comboLinkType.select(0);
    }

    private void refreshTable() {
        final List<Integer> checkedLines = new ArrayList<Integer>();

        // Saves the checked positions
        int i = 0;
        for (final TableItem current : this.tableSuList.getItems()) {
            if (current.getChecked()) {
                checkedLines.add(new Integer(i));
            }
            i++;
        }

        // refresh the table
        this.fillSuTable();

        // get the checked positions back
        for (final Integer currentInt : checkedLines) {
            this.tableSuList.getItem(currentInt.intValue()).setChecked(true);
        }
    }

    public void setSuList(final List<ProvidedSuBeans> suList) {
        this.suListIndex = -1;
        this.suList = new ArrayList<ProvidedSuBean>();

        for (final ProvidedSuBeans current : suList) {
            final ProvidedSuBean newProvidedBean = new ProvidedSuBean();
            newProvidedBean.setProvidedBean(current);
            newProvidedBean.setUrl(current.getServiceName().getValue());
            this.suList.add(newProvidedBean);
        }

        this.fillSuTable();
    }

    /**
     * @return the textNamespace
     */
    public Text getTextNamespace() {
        return this.textNamespace;
    }
}
