/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizards.models;

import java.io.File;

/**
 * @author LA
 *
 */
public class MavenCommandBean {

    /**
     * The Maven command arguments.
     * Ex: "install, clean install, etc.
     */
    private String commandArgs;
    
    /**
     * The directory where to execute the Maven command
     */
    private File directory;
    
    /**
     * @param commandArgs
     * @param directory
     */
    public MavenCommandBean(String commandArgs, File directory) {
        this.commandArgs = commandArgs;
        this.directory = directory;
    }    
    
    /**
     * @return the commandArgs
     */
    public String getCommandArgs() {
        return commandArgs;
    }
    
    /**
     * @param commandArgs the commandArgs to set
     */
    public void setCommandArgs(String commandArgs) {
        this.commandArgs = commandArgs;
    }
    
    /**
     * @return the directory
     */
    public File getDirectory() {
        return directory;
    }
    
    /**
     * @param directory the directory to set
     */
    public void setDirectory(File directory) {
        this.directory = directory;
    }
    
}
