/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizards.models;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * Represents the Maven informations of a JBI component about to be compiled
 * 
 * @author LA
 */
public class MavenSaBean {
    
    private String projectName;
    private File projectDirectory;
    private List<File> suProjectDirectories;
    
    private String artifactId;
    private String version;
    
    /**
     * @return the artifactId
     */
    public String getArtifactId() {
        return artifactId;
    }

    /**
     * @param artifactId the artifactId to set
     */
    public void setArtifactId(String artifactId) {
        this.artifactId = artifactId;
    }

    /**
     * @return the version
     */
    public String getVersion() {
        return version;
    }

    /**
     * @param version the version to set
     */
    public void setVersion(String version) {
        this.version = version;
    }

    public MavenSaBean() {
        suProjectDirectories = new ArrayList<File>();
    }

    /**
     * @return The Eclipse project directory
     */
    public File getProjectDirectory() {
        return projectDirectory;
    }

    /**
     * @param projectDirectory The Eclipse project directory
     */
    public void setProjectDirectory(File projectDirectory) {
        this.projectDirectory = projectDirectory;
    }

    /**
     * @return The SU project directories
     */
    public List<File> getSuProjectDirectories() {
        return suProjectDirectories;
    }

    /**
     * @return the projectName
     */
    public String getProjectName() {
        return projectName;
    }

    /**
     * @param projectName the projectName to set
     */
    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
    
}
