package org.objectweb.petals.tools.plugin.development.wizards.utils;

import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.swt.widgets.Shell;
import org.objectweb.petals.tools.plugin.development.actions.JobMavenRule;
import org.objectweb.petals.tools.plugin.development.actions.MavenJob;
import org.objectweb.petals.tools.plugin.development.wizards.models.MavenCommandBean;

/**
 * @author LA
 *
 */
public class MavenJobUtils {
    
    /**
     * Creates a new MavenJob
     * 
     * @param shell The shell
     * @return The created Job
     */
    public static Job createNewMavenJob(Shell shell) {
        return new MavenJob(shell);
    }
    
    /**
     * Starts the MavenJob
     * 
     * @param job The MavenJob
     */
    public static void startJob(Job job) {
        if (job instanceof MavenJob) {
            job.setRule(new JobMavenRule());
            job.setUser(true);
            job.schedule();
        }
    }
    
    /**
     * Adds a command to the job's list
     * 
     * @param commandBean The command bean to add
     * @param job The job
     */
    public static void addCommandToJob(MavenCommandBean commandBean, Job job) {
        if (job instanceof MavenJob) {
            ((MavenJob) job).getMavenCommandList().add(commandBean);
        }
    }

}
