/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.development.wizards.utils;

import org.eclipse.core.runtime.Preferences;
import org.objectweb.petals.tools.plugin.development.Activator;
import org.objectweb.petals.tools.plugin.development.constants.ESBDevPrefConstants;

/**
 * This class is useful for contributor plugins to get the development
 * plugin preferences.
 * 
 * @author LA
 *
 */
public class PreferencesUtils {

    /**
     * Gets the Maven command
     * 
     * @return The Maven command
     */
    public static String getMavenCommand() {
        // Get the Maven command
        final Preferences prefs = Activator.getDefault().getPluginPreferences();
        final String mavenCmd = prefs.getString(ESBDevPrefConstants.MAVEN_CMD_NAME);

        return mavenCmd;
    }
    
}
