package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.wizards.NewPetalsServerWizard;


public class AddPetalsServerAction extends ViewerAction {

	private IViewSite site;
	
	public AddPetalsServerAction(TreeViewer viewer, IViewSite site) {
		super(viewer);
		setText("Ajouter un serveur");
		setToolTipText("Ajoute un serveur PETALS au monitoring");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/addserver.gif"));
		this.site = site; 
	}

	public void run() {		
		NewPetalsServerWizard wizard = new NewPetalsServerWizard();
		wizard.init(site.getWorkbenchWindow().getWorkbench(),(IStructuredSelection)viewer.getSelection());
		WizardDialog dialog = new WizardDialog(site.getShell(), wizard);
		dialog.create();
		dialog.open();		
		refreshViewer();
	}

}
