package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.properties.PetalsComponentComposite;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 */
public class ClearAllComponentsAction extends ViewerAction {
	
	public ClearAllComponentsAction(TreeViewer viewer) {
		super(viewer);
		setText("Nettoyer");
		setDescription("D\u00e9charge tous les composants de ce serveur");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));

	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof PetalsServer) {
				PetalsServer ps = (PetalsServer) too;
				ps.clearAllComponents();
				if (PetalsComponentComposite.getInstance() != null) {
					PetalsComponentComposite.getInstance().refresh();
				}
			} 
		}
		refreshViewer();
	}

}
