/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.nmr.MessagesCollector;
import org.objectweb.petals.tools.plugin.monitor.views.MonitoringView;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class ClearAllMonitoredServersAction extends Action {

	public ClearAllMonitoredServersAction() {
		super("Vider la liste de tous les serveurs monitor\u00e9s", Action.AS_PUSH_BUTTON);
		setDescription("Vider la liste de tous les serveurs monitor\u00e9s");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/clear_all.gif"));
	}

	public void run() {
        if (PetalsServersView.getInstance() != null) {
            // Recuperation de la liste complete des serveurs
            Object[] listeRoot = PetalsServersView.getInstance().getProvider().getElements(null);
            for (int i = 0; i < listeRoot.length; i++) {
                if (((PetalsServer) listeRoot[i]).isMonitored()) {
                    ((PetalsServer) listeRoot[i]).setMessagesCollector(new MessagesCollector());
                }
            }
            // refresh to MonitoringView
            if (MonitoringView.getInstance() != null) {
                MonitoringView.getInstance().refreshViewer();
            }
        }
	}
	
}
