package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;


public class ClearNotificationsAction extends Action {
	
	private PetalsComponent petalsComponent;

	public ClearNotificationsAction(PetalsComponent petalsComponent) {
		super("Vider", Action.AS_PUSH_BUTTON);
		this.petalsComponent = petalsComponent;
		setDescription("Vide la liste des notifications");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/clear_notifications.gif"));
	}

	public void run() {
		if (petalsComponent != null) {
			petalsComponent.clearNotifications();
		}
		
	}

	public void setPetalsComponent(PetalsComponent petalsComponent) {
		this.petalsComponent = petalsComponent;
	}
	
}
