package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.views.PerformanceNotifierView;


public class ClearPerfNotifAction extends Action {

	public ClearPerfNotifAction() {
		setDescription("Vide la liste des notifications de performances");
        setToolTipText("Vide la liste des notifications de performances");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/clear_notifications.gif"));
	}

	public void run() {
	    if (PerformanceNotifierView.getInstance() != null) {
	        new Thread(new Runnable() {
	            public void run() {
	                Display.getDefault().asyncExec(new Runnable() {
	                    public void run() {
                            PerformanceNotifierView.getInstance().getUserData().clear();
                            PerformanceNotifierView.getInstance().setUserDataPrintedIndex(0);
	                        PerformanceNotifierView.getInstance().clearTableList();
	                    }
	                });
	            }
	        }).start();  
	    }
	}
	
}
