package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeParent;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;


public class ClearPetalsServersAction extends ViewerAction {

	private ViewContentProvider provider;
	
	public ClearPetalsServersAction(TreeViewer viewer, ViewContentProvider provider) {
		super(viewer);
		setText("Vider");
		setToolTipText("D\u00e9connecte et supprime tous les serveurs PETALS");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/clear.gif"));
		this.provider = provider;
	}

	public void run() {
		for (TreeObject tpo : provider.getChildren(null)) {
			Object object = (TreeParent)tpo;
			if (object instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer)object);
				if (ps.isConnected()) {
					ps.disconnect();
				}
			}
			provider.remove(tpo);
		}
		refreshViewer();
	}

}
