package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.configure.PetalsComponentInput;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


public class ConfigureComponentAction extends ViewerAction {

	private IViewSite site;
	
	public ConfigureComponentAction(TreeViewer viewer, IViewSite site) {
		super(viewer);
		setText("Configurer");
		setDescription("Configure le composant s\u00e9lectionn\u00e9");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/config.gif"));
		this.site = site;
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof PetalsComponent) {
				try {
					PetalsComponent component = (PetalsComponent)too;
					IEditorPart editor = site.getPage().openEditor(new PetalsComponentInput(component), "org.objectweb.petals.tools.plugin.monitor.componentConfigurationEditor", false);
					component.setEditor(editor);
				} catch (PartInitException e) {
					MessageDialog.openError(site.getShell(), "Configuration composant", "Impossible d'ouvrir la vue de configuration du composant");
				}
			} 
		}
	}

}
