package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeParent;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class ConnectPetalsServerAction extends ViewerAction {

	public ConnectPetalsServerAction(TreeViewer viewer) {
		super(viewer);
		setText("Connecter");
		setDescription("Connecte le serveur Petals s\u00e9lectionn\u00e9");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(
				Activator.PLUGIN_ID, "icons/connectedserver.gif"));
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeParent object = ((TreeParent) obj);
			if (object instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer) object);
				ps.connect();
				PetalsServersView.getInstance().connect(ps);
			}
		}
	}

}
