package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeParent;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class DisconnectPetalsServerAction extends ViewerAction {

	public DisconnectPetalsServerAction(TreeViewer viewer) {
		super(viewer);
		setText("D\u00e9connecter");
		setDescription("D\u00e9connecte le serveur Petals s\u00e9lectionn\u00e9");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/disconnectedserver.gif"));
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj: ((IStructuredSelection)selection).toList()) {
			TreeParent tpo = (TreeParent)obj;
			Object object = (TreeParent)tpo;
			if (object instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer)object);
				ps.disconnect();
				PetalsServersView.getInstance().disconnect(ps);
			}
		}
	}

}
