package org.objectweb.petals.tools.plugin.monitor.actions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;
import org.objectweb.petals.tools.plugin.monitor.wizards.ExportWizard;


public class ExportUrlsAction extends ViewerAction {
	
	private IViewSite site;
	private ViewContentProvider provider;
		
	public ExportUrlsAction(TreeViewer viewer, IViewSite site, ViewContentProvider provider) {
		super(viewer);
		setText("Exporter");
		setToolTipText("Exporte la liste des URLs JMX vers un fichier XML");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/export.gif"));
		this.site = site;
		this.provider = provider;
	}

	public void run() {
		List<PetalsServer> servers = new ArrayList<PetalsServer>();
		// Recuperation de la liste complete des serveurs
		Object[] listeRoot = provider.getElements(null);
		for (int i=0; i<listeRoot.length; i++) {
			servers.add((PetalsServer)listeRoot[i]);
		}
		
		if (!servers.isEmpty()) {
			ExportWizard wizard = new ExportWizard();
			wizard.init(site.getWorkbenchWindow().getWorkbench(),(IStructuredSelection)viewer.getSelection());
			wizard.setProvider(provider);
			// Sauvegarde de la liste des serveurs dans le wizard
			wizard.setPetalsServerList(servers);
			WizardDialog dialog = new WizardDialog(site.getShell(), wizard);
			dialog.create();
			dialog.open();
		}
		else {
			MessageDialog.openError(site.getShell(), "Exportation impossible", "Au moins un serveur PETALS doit \u00eatre s\u00e9lectionn\u00e9.");
		}
	}

}
