package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;
import org.objectweb.petals.tools.plugin.monitor.wizards.ImportWizard;


public class ImportUrlsAction extends ViewerAction {
	
	private IViewSite site;
	private ViewContentProvider provider;
	
	public ImportUrlsAction(TreeViewer viewer, IViewSite site, ViewContentProvider provider) {
		super(viewer);
		setText("Importer");
		setToolTipText("Importe une liste d'URLs depuis un fichier XML");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/import.gif"));
		this.site = site;
		this.provider = provider;
	}

	public void run() {
		ImportWizard wizard = new ImportWizard();
		wizard.init(site.getWorkbenchWindow().getWorkbench(), null);
		wizard.setProvider(provider);
		WizardDialog dialog = new WizardDialog(site.getShell(), wizard);
		dialog.create();
		dialog.open();
	}

}
