package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.core.runtime.Preferences;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.preferences.PreferenceConstants;
import org.objectweb.petals.tools.plugin.monitor.properties.PetalsComponentComposite;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 */
public class InstallComponentAction extends ViewerAction {

	private Preferences prefs; 
	
	public InstallComponentAction(TreeViewer viewer) {
		super(viewer);
		setText("Installer");
		setDescription("Installe le composant s\u00e9lectionn\u00e9");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));
		prefs = Activator.getDefault().getPluginPreferences();
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof PetalsComponent) {
				PetalsComponent pc = (PetalsComponent) too;
				pc.install();
				if (prefs.getBoolean(PreferenceConstants.START_INSTALLED_COMPONENTS) && !pc.isStarted()) {
					pc.start();
				}
				pc.getServer().add(pc);
				if (PetalsComponentComposite.getInstance() != null) {
					PetalsComponentComposite.getInstance().refresh();
				}
			} 
		}
		//refreshViewer();
	}

}
