package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.nmr.PetalsServerInput;


public class NMRofServerAction extends ViewerAction {

	private IViewSite site;
	
	public NMRofServerAction(TreeViewer viewer, IViewSite site) {
		super(viewer);
		setText("Client NMR");
		setDescription("Permet d'invoquer un service disponible sur le NMR");
		this.site = site;
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj: ((IStructuredSelection)selection).toList()) {
			if (obj instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer)obj);
				try {
					site.getPage().openEditor(new PetalsServerInput(ps), "org.objectweb.petals.tools.plugin.monitor.nmrServerEditor", false);
				} catch (PartInitException e) {
					MessageDialog.openError(site.getShell(), "Client NMR", "Impossible d'ouvrir le client NMR (" + e.getMessage() + ")");
				}
			}
		}
	}

}
