package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.program.Program;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.internal.browser.WebBrowserView;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 */
public class OpenJmxBrowserAction extends ViewerAction {

	public final static String BROWSER_PATHNAME = "c:\\program files\\Internet Explorer\\iexplore.exe";
	private IViewSite site;
	
	
	public OpenJmxBrowserAction(TreeViewer viewer, IViewSite site) {
		super(viewer);
		setText("Console Web");
		setToolTipText("Ouvrir la console HTTP JMX dans un navigateur web");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));
		this.site = site;
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj: ((IStructuredSelection)selection).toList()) {
			TreeObject tpo = (TreeObject)obj;
			Object object = (TreeObject)tpo;
			if (object instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer)object);
				if (ps.isConnected() && ps.getHttpUrl() != null) {					
					if (site != null) {
						try {
							// ouvre la vue Navigateur web interne et force l'affichage de celle-ci sur 
							// l'URL de la console HTTP JMX
							((WebBrowserView)site.getPage().showView(WebBrowserView.WEB_BROWSER_VIEW_ID)).setURL(ps.getHttpUrl());
						} catch (PartInitException e) {
							if (!Program.launch(ps.getHttpUrl())) {
								MessageDialog.openError(null, "Ouverture navigateur web", "Impossible d'ouvrir l'URL  '" +  ps.getHttpUrl() + "' avec un navigateur web");
							}
						}	
					}
				}
			}
		}
	}

}
