package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;


/**
 * @author JR (RAVOIRE Julien - Intervenant CAPGEMINI au CNIR/SUD)
 * 
 */
public class PropertiesAction extends ViewerAction {

	private IViewSite site;
	
	public PropertiesAction(TreeViewer viewer, IViewSite site) {
		super(viewer);
		setText("Rafraichir");		
		setText("Propri\u00e9t\u00e9s");
		setToolTipText("Acc\u00e8de aux propri\u00e9t\u00e9s du composant");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/properties.gif"));
		this.site = site;
	}

	public void run() {
		try {
			if (site != null) {
				site.getPage().showView(IPageLayout.ID_PROP_SHEET);	
			}
		} catch (PartInitException e) {
			System.err.println("Unable to open properties view (" + e.getMessage() + ")");
			e.printStackTrace();
		}				
	}

	
}
