package org.objectweb.petals.tools.plugin.monitor.actions;

import java.util.List;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.BindingComponent;
import org.objectweb.petals.tools.plugin.monitor.model.FolderComponent;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceEngine;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceUnit;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeParent;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;
import org.objectweb.petals.tools.plugin.monitor.utils.StringUtils;


public class ReachSUContainerAction extends ViewerAction {
	
	private ViewContentProvider provider;
	
	public ReachSUContainerAction(TreeViewer viewer, ViewContentProvider provider) {
		super(viewer);
		setText("Atteindre");
		setDescription("Atteindre le container de ce SA");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));
		this.provider = provider;
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof ServiceUnit) {
				// Nom du BC auquel appartient le SA trouv\u00e9
				String nomBcToo = ((ServiceUnit)too).getComponentName();
				
				// D\u00e9termination du PetalsServer contenant le SA
				PetalsServer ps = null;
				Object[] listeRoot = provider.getElements(null);
				for (int i=0; i<listeRoot.length; i++) {
					if (((PetalsServer)listeRoot[i]).containsServiceUnit((ServiceUnit)too)) {
						ps = (PetalsServer)listeRoot[0];
					}
				}
				
				// D\u00e9termination du folder
				FolderComponent folder = null;
				TreeObject[] listeFolders = ps.getChildren();
				for (int i=0; i<listeFolders.length; i++) {
					if (PetalsServer.BC_TEXT.equals(listeFolders[i].getName())) {
						folder = (FolderComponent)listeFolders[i];
					}
				}
				
				// D\u00e9termination du BC...
				PetalsComponent pc = null;
				List<BindingComponent> bcContenus = ps.getBindingComponents();
				for (BindingComponent bcCourant : bcContenus) {
					// Nom du BC courant
					String nomBcTrouve = bcCourant.getName();
					if (StringUtils.isNotEmpty(nomBcTrouve) 
							&& StringUtils.isNotEmpty(nomBcToo)
							&& nomBcTrouve.equals(nomBcToo)) {
						
						pc = bcCourant;
					}
				}
				// ...ou du SE
				List<ServiceEngine> seContenus = ps.getEngineComponents();
				for (ServiceEngine seCourant : seContenus) {
					// Nom du SE courant
					String nomSeTrouve = seCourant.getName();
					if (StringUtils.isNotEmpty(nomSeTrouve) 
							&& StringUtils.isNotEmpty(nomBcToo)
							&& nomSeTrouve.equals(nomBcToo)) {
						
						pc = seCourant;
					}
				}
				
				// S\u00e9lection du Container dans le TreeView
				if (ps!=null && folder!=null && pc!=null) {
					TreeParent[] objectPath = { ps, folder, pc };
					viewer.setSelection(new TreeSelection(new TreePath(objectPath)));
				}
			}
		}
	}
}
