package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 */
public class RefreshAction extends ViewerAction {
	
	public RefreshAction(TreeViewer viewer) {
		super(viewer);
		setText("Rafraichir");
		setToolTipText("Rafraichit la liste des serveurs PETALS");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(
				Activator.PLUGIN_ID, "icons/refresh.gif"));
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj: ((IStructuredSelection)selection).toList()) {
			if (obj instanceof PetalsServer) {
				((PetalsServer)obj).refreshTags();
			}
		}		
		//TODO: refresh only selected level
		refreshViewer();
	}

}
