package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 */
public class RemovePetalsServerAction extends ViewerAction {

	private ViewContentProvider provider;
	
	public RemovePetalsServerAction(TreeViewer viewer, ViewContentProvider provider) {
		super(viewer);
		setText("Supprimer");
		setToolTipText("Supprime le serveur PETALS s\u00e9lectionn\u00e9");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/delete.gif"));
		this.provider = provider;
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj: ((IStructuredSelection)selection).toList()) {
			TreeObject tpo = (TreeObject)obj;
			Object object = (TreeObject)tpo;
			if (object instanceof PetalsServer) {
				PetalsServer ps = ((PetalsServer)object);
				if (ps.isConnected()) {
					ps.disconnect();
				}
			}
			provider.remove(tpo);
		}
		refreshViewer();
	}

}
