/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.utils.NumberInputValidator;
import org.objectweb.petals.tools.plugin.monitor.views.MonitoringView;


public class SetMessagesThresholdAction extends Action {
    
    private Shell parent;
    private NumberInputValidator numberInputValidator;

	public SetMessagesThresholdAction(Shell parent) {
		super("Param\u00e9trer le seuil d'envoi par messages", Action.AS_PUSH_BUTTON);
        this.parent = parent;
		setDescription("Param\u00e9trer le seuil d'envoi par messages");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/messages_threshold.gif"));
        numberInputValidator = new NumberInputValidator();
	}

	public void run() {
        MonitoringView mView = MonitoringView.getInstance();
        String initialValue = String.valueOf(mView.getPetalsServer().getMonitoringMessagesThreshold());
        InputDialog inputDialog = new InputDialog(
                parent, 
                "Intervalle d'envoi pour les messages NMR", 
                "Saisir un nombre de messages : ", 
                initialValue, 
                numberInputValidator);
        inputDialog.open();
        
        if (inputDialog.getReturnCode() == InputDialog.OK) {
            mView.getPetalsServer().setMonitoringMessagesThreshold(Integer.parseInt(inputDialog.getValue()));
        }
	}
	
}
