package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceInterface;
import org.objectweb.petals.tools.plugin.monitor.properties.PetalsComponentComposite;
import org.objectweb.petals.tools.plugin.monitor.properties.ServiceAssemblyComposite;
import org.objectweb.petals.tools.plugin.monitor.properties.ServiceUnitComposite;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


public class StopComponentAction extends ViewerAction {

	public StopComponentAction(TreeViewer viewer) {
		super(viewer);
		setText("Stopper");
		setDescription("Stoppe le composant s\u00e9lectionn\u00e9");
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof PetalsComponent) {
				PetalsComponent component = ((PetalsComponent)too);
				component.stop();
				if (PetalsComponentComposite.getInstance() != null) {
					PetalsComponentComposite.getInstance().refresh();
				}
			} else if (too instanceof ServiceInterface) {
				((ServiceInterface)too).stop();
				if (ServiceAssemblyComposite.getInstance() != null) {
					ServiceAssemblyComposite.getInstance().refresh();
				}
				if (ServiceUnitComposite.getInstance() != null) {
					ServiceUnitComposite.getInstance().refresh();
				}
			}
			refresh();
		}
	}

}
