package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.properties.PetalsComponentComposite;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;


public class SubscribeComponentNotificationsAction extends ViewerAction {
	


	public SubscribeComponentNotificationsAction(TreeViewer viewer) {
		super(viewer, Action.AS_CHECK_BOX);
		setText("Abonnement aux notifications de changement d'\u00e9tat");
		setDescription("(D\u00e9)Abonne le composant aux notifications");
		setChecked(false);
		//setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/refresh.gif"));
	}

	public void run() {
		ISelection selection = viewer.getSelection();
		for (Object obj : ((IStructuredSelection) selection).toList()) {
			TreeObject too = (TreeObject) obj;
			if (too instanceof PetalsComponent) {
				PetalsComponent pc = (PetalsComponent) too;
				if (pc.isSubscribed()) {
					pc.unsubscribe();	
				} else {
					pc.subscribe();
				}
				if (PetalsComponentComposite.getInstance() != null) {
					PetalsComponentComposite.getInstance().refresh();
				}
			} 
		}
	}
	
}
