package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.widgets.Display;

public abstract class ViewerAction extends Action {

	protected TreeViewer viewer;
	
	public ViewerAction(TreeViewer viewer) {
		this.viewer = viewer;
	}
	
	public ViewerAction(TreeViewer viewer, int checked) {
		super(null, Action.AS_CHECK_BOX);
		this.viewer = viewer;
	}
	
	public ViewerAction() {
		
	}
	
	protected void refreshViewer() {
		if (viewer != null) {
			new Thread(new Runnable() {
			      public void run() {
		            Display.getDefault().asyncExec(new Runnable() {
		               public void run() {
		            	   Object[] expandedElements = viewer.getExpandedElements();
		            	   viewer.refresh();
		            	   viewer.setExpandedElements(expandedElements);
		               }
		            });
			      }
			   }).start();	
		}
	}
	
	protected void refresh() {
		if (viewer != null) {
			new Thread(new Runnable() {
			      public void run() {
		            Display.getDefault().syncExec(new Runnable() {
		               public void run() {
		            	   Object[] expandedElements = viewer.getExpandedElements();
		            	   viewer.refresh();
		            	   viewer.setExpandedElements(expandedElements);
		               }
		            });
			      }
			   }).start();	
		}
	}
	
}
