/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.monitor.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.nmr.Message;
import org.objectweb.petals.tools.plugin.monitor.nmr.NMRMessageEditor;
import org.objectweb.petals.tools.plugin.monitor.nmr.NMRMessageInput;
import org.objectweb.petals.tools.plugin.monitor.views.MonitoringView;


public class WatchNMRMessageAction extends Action {
    
    private Message nmrMessage;

	public WatchNMRMessageAction() {
		super("Ouvrir le message NMR dans un l'\u00e9diteur de texte par d\u00e9faut", Action.AS_PUSH_BUTTON);
		setDescription("Ouvrir le message NMR dans un l'\u00e9diteur de texte par d\u00e9faut");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/watch_nmr_message.gif"));
	}

	public void run() {
	    MonitoringView mView = MonitoringView.getInstance();
	    if ((mView != null) && (nmrMessage != null)) {
	        try {
	            NMRMessageInput nmrMessageInput = new NMRMessageInput(nmrMessage);                    
	            mView.getSite().getPage().openEditor(nmrMessageInput, NMRMessageEditor.ID , true);
	        } catch (PartInitException e) {
	            MessageDialog.openError(
	                    mView.getViewSite().getShell(), 
	                    "Ouverture du message NMR dans l'\u00e9diteur",
	            "Erreur dans l'ouverture du message NMR dans l'\u00e9diteur de texte par d\u00e9faut");
	        }
	    }
	}

    /**
     * @param nmrMessage the nmrMessage to set
     */
    public void setNmrMessage(Message nmrMessage) {
        this.nmrMessage = nmrMessage;
    }
	
}
