package org.objectweb.petals.tools.plugin.monitor.ant;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.objectweb.petals.tools.plugin.monitor.model.ComponentAnalyzer;
import org.objectweb.petals.tools.plugin.monitor.model.ComponentType;


/**
 * @author JR (RAVOIRE Julien - Intervenant CAPGEMINI au CNIR/SUD)
 * Classe pour utiliser le code de gestion des entit\u00e9s depuis la
 * tche ANT associ\u00e9e
 */
public class MonitorTask extends Task {

	private String action;
	private String url;
	private String componentName;

	@Override
	public void execute() throws BuildException {
		if (action != null) {
			if (action.equals("")) {
				log("You must specify an action between {install, uninstall}");
				return;
			}
			
			if (action.equalsIgnoreCase("install")) {
				if (url == null || url.equals("")) {
					log("You must specify a component url");
					return;
				}
				ComponentAnalyzer analyzer = new ComponentAnalyzer(url);
				ComponentType type = analyzer.getType();
				//TODO: detect service assembly
				switch(type) {
					case serviceEngine:
					case bindingComponent:
						//TODO
						System.out.println("Installing component " + url);	
						break;
					case sharedLibrary:
						//TODO
						System.out.println("Loading component " + url);
						break;
					}
				return;
			}
			if (action.equalsIgnoreCase("uninstall")) {
				if (componentName == null || componentName.equals("")) {
					log("You must specify a component name");
					return;
				}
				//TODO
				System.out.println("Uninstalling " + componentName);				
			}
		}
	}

	@Override
	public String getDescription() {
		return "ANT deployer for Petals Components";
	}

	@Override
	public String getTaskName() {
		return "petalsMonitor";
	}

	public void setComponentName(String componentName) {
		this.componentName = componentName;
	}
	
	public void setAction(String action) {
		this.action = action;
	}

	public void setUrl(String url) {
		this.url = url;
	}
	
	
}
