package org.objectweb.petals.tools.plugin.monitor.configure;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;


public class AttributesPage extends CommonPage {
	
	private ScrolledAttributesBlock block;
	
	public AttributesPage(FormEditor formEditor) {
		super(formEditor, "attributes", "Attributs");
		block = new ScrolledAttributesBlock(this);
	}

	@Override
	protected void createFormContent(IManagedForm managedForm) {
		super.createFormContent(managedForm);
		form.setBackgroundImage(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/form_banner.gif").createImage());
		block.createContent(managedForm);
		updatePage();
	}

	@Override
	public void updatePage() {		
		form.setText("Attributs de " + component.getName());
		block.update();
	}
	
	public void refresh() {
		block.refresh();
	}

	@Override
	public boolean isDirty() {
		// TODO Raccord de m\u00e9thode auto-g\u00e9n\u00e9r\u00e9
		return block.isDirty();
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		block.doSave(monitor);
	}
		
} 
