package org.objectweb.petals.tools.plugin.monitor.configure;

import javax.management.MBeanInfo;
import javax.management.MBeanServerConnection;

import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.editor.FormPage;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.nmr.PetalsServerInput;


public abstract class CommonPage extends FormPage {

	protected PetalsComponent component;
	public PetalsServer server;
	protected ScrolledForm form;
	transient protected MBeanInfo mBeanInfo;
	transient protected MBeanServerConnection connection; 
	
	
	public CommonPage(FormEditor formEditor, String id, String title) {
		super(formEditor, id, title);
	}

	@Override
	protected void createFormContent(IManagedForm managedForm) {
		form = managedForm.getForm();
	}
	
	@Override
	public void initialize(FormEditor editor) {
		super.initialize(editor);	
		if (editor.getEditorInput() instanceof PetalsComponentInput) {
			PetalsComponentInput pci = (PetalsComponentInput)editor.getEditorInput();
			this.component = pci.getComponent();
			this.mBeanInfo = component.getConfigurationMBean();
			this.connection = component.getConnection();
		} else if (editor.getEditorInput() instanceof PetalsServerInput) {
			PetalsServerInput psi = (PetalsServerInput)editor.getEditorInput();
			this.server = psi.getServer();
		}
	}
	
	public abstract void updatePage();
	
	public boolean isSaveOnCloseNeeded() {
		return true;
	}
	
	@Override
	public boolean isSaveAsAllowed() {
		return true;
	}
	
	
} 
