package org.objectweb.petals.tools.plugin.monitor.configure;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;


public class MethodsPage extends CommonPage {
	
	private ScrolledMethodsBlock block;
	
	public MethodsPage(FormEditor formEditor) {
		super(formEditor, "methods", "M\u00e9thodes");
		block = new ScrolledMethodsBlock(this);
	}

	@Override
	protected void createFormContent(IManagedForm managedForm) {
		super.createFormContent(managedForm);
		form.setBackgroundImage(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/form_banner.gif").createImage());
		block.createContent(managedForm);
		updatePage();
	}

	@Override
	public void updatePage() {
		form.setText("M\u00e9thodes de " + component.getName());
		block.update();
	}
	
	public void refresh() {
		block.refresh();
	}

	@Override
	public boolean isDirty() {
		return block.isDirty();
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		block.doSave(monitor);
	}

	public ScrolledMethodsBlock getBlock() {
		return block;
	}
	
} 
