package org.objectweb.petals.tools.plugin.monitor.model;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;


public enum ComponentType {
	   serviceEngine("Service Engine"),
	   bindingComponent("Binding Component"), 
	   sharedLibrary("Shared Library"),
	   serviceAssembly("Service Assembly"),
	   unknown("Unknown");
	   ;

	   protected String label;
	   private final static Image SE_IMAGE = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/se.gif").createImage();
	   private final static Image BC_IMAGE = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/bc.gif").createImage();
	   private final static Image SL_IMAGE = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/sl.gif").createImage();
	   private final static Image SA_IMAGE = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/sa.gif").createImage();
	   private final static Image NO_IMAGE = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/no.gif").createImage();

	   /** Constructeur */
	   ComponentType(String pLabel) {
	      this.label = pLabel;
	   }

	   public String toString() {
	      return this.label;
	   }
	   
	   public Image getImage() {
		      switch(this) {
		      	case bindingComponent: return BC_IMAGE;
		      	case serviceEngine: return SE_IMAGE;
		      	case sharedLibrary: return SL_IMAGE;
		      	case serviceAssembly: return SA_IMAGE;
		      	default: 
		      	case unknown: return NO_IMAGE;
		      }
	   }
	   
	}