package org.objectweb.petals.tools.plugin.monitor.model;

import javax.jbi.management.InstallationServiceMBean;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.views.properties.IPropertySource;
import org.objectweb.petals.tools.plugin.monitor.properties.SharedLibraryPropertySource;


/**
 * @author JR (RAVOIRE Julien - CAPGEMINI)
 * 
 * 13 mars 07
 * 
 * Mod\u00e8le pour une Shared Library (SL)
 */
public class SharedLibrary extends ComponentParent {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3700004833762858218L;
	transient protected InstallationServiceMBean install;
	private SharedLibraryPropertySource properties;
	
	/**
	 * Passe l'installateur par d\u00e9faut \u00e0 cette librairie
	 * @param install Installateur par d\u00e9faut
	 */
	public void setInstall(InstallationServiceMBean install) {
		this.install = install;
	}

	/**
	 * Construit une librairie de nom name
	 * @param name Nom de la librairie partag\u00e9e
	 */
	public SharedLibrary(String name) {
		super(name);
	}

	@Override
	public String getType() {
		return "shared library";
	}

	/**
	 * D\u00e9charge la librarie partag\u00e9e du serveur Petals
	 */
	public void unload() {
		if (install != null) {
			if (!install.uninstallSharedLibrary(name)) {
				MessageDialog.openError(null, "D\u00e9chargement d'une librairie partag\u00e9e", "Impossible de d\u00e9charger la " + getType() + " '" + getName() + "'");
			}
		}
	}
		
	/* (non-Javadoc)
	 * @see org.objectweb.petals.tools.plugin.monitor.providers.TreeObject#getAdapter(java.lang.Class)
	 */
	@Override
	public Object getAdapter(Class key) {
		if (key == IPropertySource.class) {
			if (properties == null) {
				properties = new SharedLibraryPropertySource(this);
			}
			return properties;
		}
		return super.getAdapter(key);
	}
}
