/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.monitor.nmr;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.configure.CommonPage;


public class NMRPage extends CommonPage {
	
	private ScrolledEndpointBlock block;
	
	public NMRPage(FormEditor formEditor) {
		super(formEditor, "nmrClient", "NMR");
		block = new ScrolledEndpointBlock(this);
	}

	@Override
	protected void createFormContent(IManagedForm managedForm) {
		super.createFormContent(managedForm);
		form.setBackgroundImage(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/form_banner.gif").createImage());
		block.createContent(managedForm);
		updatePage();
	}

	@Override
	public void updatePage() {		
		form.setText("Client NMR du serveur " + server.getName());
		block.update();
	}
	
	public void refresh() {
		block.refresh();
	}

	@Override
	public boolean isDirty() {
		return block.isDirty();
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		block.doSave(monitor);
	}
		
} 
