/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.plugin.monitor.nmr;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;


public class PetalsServerInput implements IEditorInput {
		
	private PetalsServer server;
	
	public PetalsServerInput(PetalsServer server) {
		this.server = server;
	}
	
	public boolean exists() {
		return false;
	}

	public String getName() {
		return "NMR du serveur " + server.getName();
	}

	public IPersistableElement getPersistable() {
		return null;
	}

	public Object getAdapter(Class adapter) {
		return null;
	}
	
	public String getToolTipText() {
		return getName();
	}

	public ImageDescriptor getImageDescriptor() {
		return null;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof PetalsServerInput) {
			return server.equals(((PetalsServerInput)obj).getServer());
		}
		return false;
	}

	public PetalsServer getServer() {
		return server;
	}

}
