package org.objectweb.petals.tools.plugin.monitor.perspective;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.internal.browser.WebBrowserView;
import org.objectweb.petals.tools.plugin.monitor.views.MonitoringView;
import org.objectweb.petals.tools.plugin.monitor.views.NotificationsView;
import org.objectweb.petals.tools.plugin.monitor.views.PerformanceNotifierView;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;
import org.objectweb.petals.tools.plugin.monitor.wizards.NewComponentWizard;
import org.objectweb.petals.tools.plugin.monitor.wizards.NewPetalsServerWizard;


public class ESBPerspectiveFactory implements IPerspectiveFactory {

	public final static String ID = "org.objectweb.petals.tools.plugin.monitor.esbperspective";
	
	@SuppressWarnings("restriction")
	public void createInitialLayout(IPageLayout layout) {
		String editorArea = layout.getEditorArea();
		layout.setEditorAreaVisible(true);
		
		IFolderLayout bottom = layout.createFolder("bottom", IPageLayout.BOTTOM, 0.6f, editorArea);
		bottom.addView(IPageLayout.ID_PROP_SHEET);
		layout.getViewLayout(IPageLayout.ID_PROP_SHEET).setCloseable(true);
		bottom.addView(NotificationsView.ID);
		layout.getViewLayout(NotificationsView.ID).setCloseable(true);
		bottom.addView(WebBrowserView.WEB_BROWSER_VIEW_ID);
		layout.getViewLayout(WebBrowserView.WEB_BROWSER_VIEW_ID).setCloseable(true);
        bottom.addView(MonitoringView.ID);
        layout.getViewLayout(MonitoringView.ID).setCloseable(true);
		
		IFolderLayout left = layout.createFolder("left", IPageLayout.LEFT, 0.3f, editorArea);		
		left.addView(PetalsServersView.ID);	
		layout.getViewLayout(PetalsServersView.ID).setCloseable(true);
		
		layout.addPerspectiveShortcut(ID);
		layout.addNewWizardShortcut(NewPetalsServerWizard.ID);
		layout.addNewWizardShortcut(NewComponentWizard.ID);

		layout.addShowViewShortcut(PetalsServersView.ID);
		layout.addShowViewShortcut(NotificationsView.ID);
		layout.addShowViewShortcut(IPageLayout.ID_PROP_SHEET);
		layout.addShowViewShortcut(WebBrowserView.WEB_BROWSER_VIEW_ID);
        layout.addShowViewShortcut(PerformanceNotifierView.ID);
        layout.addShowViewShortcut(MonitoringView.ID);
	}
}

