package org.objectweb.petals.tools.plugin.monitor.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.DirectoryFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;

public class ESBPreferencePage
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {

	public ESBPreferencePage() {
		super(GRID);
		setPreferenceStore(Activator.getDefault().getPreferenceStore());
		setDescription("Param\u00e8tres d'administration des serveurs Petals:");
	}
	
	public void createFieldEditors() {
		addField(new BooleanFieldEditor(PreferenceConstants.STOP_TRANSPORT_LAYER,"Arr\u00eater la couche &transport lors de l'arr\u00eat d'un serveur (arr\u00eat complet)",getFieldEditorParent()));
		
		FileFieldEditor ffe = new FileFieldEditor(PreferenceConstants.DEFAULT_SERVERS_URL,"&URL des serveurs par d\u00e9faut:", getFieldEditorParent());
		ffe.setChangeButtonText("Parcourir");
		ffe.setFileExtensions(new String[] {"*.xml"});
		addField(ffe);
		
		addField(new BooleanFieldEditor(PreferenceConstants.DISCOVER_ONLY_STARTED_SERVERS,"Ne d\u00e9couvrir que les serveurs d\u00e9j\u00e0 &d\u00e9marr\u00e9s",getFieldEditorParent()));		
		addField(new BooleanFieldEditor(PreferenceConstants.AUTO_ADD_DISCOVERED_SERVERS,"&Ajouter automatiquement les serveurs d\u00e9couverts",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.AUTO_CONNECT_ADDED_SERVERS,"&Connecter automatiquement les serveurs ajout\u00e9s",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.AUTO_MONITOR_CONNECTED_SERVERS,"&Monitorer automatiquement les serveurs connect\u00e9s",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.AUTO_SUBSCRIBE_COMPONENTS,"&Abonner automatiquement les composants aux notifications",getFieldEditorParent()));
		addField(new DirectoryFieldEditor(PreferenceConstants.COMPONENTS_DIRECTORY,"R\u00e9pertoire des &composants:",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.PARTIAL_UNINSTALL,"Autoriser la d\u00e9sinstallation &partielle des composants",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.DELETE_FILES_OF_UNINSTALLED_COMPONENT,"&Supprimer les fichiers distants du composant lors de sa d\u00e9sinstallation",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.START_INSTALLED_COMPONENTS,"&D\u00e9marrer les composants install\u00e9s",getFieldEditorParent()));
		
		addField(new BooleanFieldEditor(PreferenceConstants.SHOW_BC,"Afficher les &Binding Components",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.SHOW_SE,"Afficher les Service &Engines",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.SHOW_SL,"Afficher les Shared &Librairies",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.SHOW_SA,"Afficher les Service &Assemblies",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.SHOW_SU,"Afficher les Service &Units",getFieldEditorParent()));
		
		addField(new BooleanFieldEditor(PreferenceConstants.START_ALL_EXPANDED_NODES,"D\u00e9ployer compl\u00e8tement les composantes du serveur",getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.AUTO_REPLACE_COMPONENTS,"Replacer automatiquement les composants par leur nouvelle version",getFieldEditorParent()));
		
	}

	public void init(IWorkbench workbench) {
		
	}

	@Override
	public boolean performOk() {
		PetalsServersView.refresh();
		return super.performOk();
	}
	
}