package org.objectweb.petals.tools.plugin.monitor.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.objectweb.petals.tools.plugin.monitor.Activator;


/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.STOP_TRANSPORT_LAYER, true);
		store.setDefault(PreferenceConstants.DEFAULT_SERVERS_URL, "");
		store.setDefault(PreferenceConstants.DISCOVER_ONLY_STARTED_SERVERS, false);
		store.setDefault(PreferenceConstants.AUTO_ADD_DISCOVERED_SERVERS, false);
		store.setDefault(PreferenceConstants.AUTO_CONNECT_ADDED_SERVERS, true);
		store.setDefault(PreferenceConstants.AUTO_MONITOR_CONNECTED_SERVERS, false);
		store.setDefault(PreferenceConstants.SHOW_BC, true);
		store.setDefault(PreferenceConstants.SHOW_SE, true);
		store.setDefault(PreferenceConstants.SHOW_SA, true);
		store.setDefault(PreferenceConstants.SHOW_SL, true);
		store.setDefault(PreferenceConstants.SHOW_SU, true);
	}

}
