package org.objectweb.petals.tools.plugin.monitor.properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.monitor.actions.ConfigureComponentAction;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewLabelProvider;
import org.objectweb.petals.tools.plugin.monitor.utils.StringUtils;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class PetalsComponentComposite extends Composite {
	
	private Link restartLink = null;
	private Link uninstallLink = null;
	private Link refreshLink = null;
	private Label sepLabel = null;
	private Label sepLabel1 = null;
	private Label componentTypeImage = null;
	private Label componentTypeLabel = null;
	private Label sepLabel11 = null;
	private Link configureLink = null;
	private Button suscribeCheckBox = null;
	private Label runningStateLabel = null;
	private Link startLink = null;
	private Label sepLabel2 = null;
	private Link reinstallLink = null;
	private Text descriptionTextArea = null;
	
	protected PetalsComponent petalsComponent;  //  @jve:decl-index=0:
	private Label componentNameText = null;
	
	private static PetalsComponentComposite instance;
	
	public static PetalsComponentComposite getInstance() {
		return instance;
	}
	
	public void setPetalsComponent(PetalsComponent petalsComponent) {
		this.petalsComponent = petalsComponent;
	}
	
	public PetalsComponentComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
		instance = this;
	}

	private void initialize() {
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.verticalAlignment = GridData.CENTER;
		gridData12.horizontalSpan = 14;
		gridData12.grabExcessHorizontalSpace = true;
		GridData gridData42 = new GridData();
		gridData42.horizontalAlignment = GridData.CENTER;
		gridData42.verticalAlignment = GridData.CENTER;
		GridData gridData41 = new GridData();
		gridData41.horizontalAlignment = GridData.CENTER;
		gridData41.verticalAlignment = GridData.CENTER;
		GridData gridData40 = new GridData();
		gridData40.horizontalAlignment = GridData.CENTER;
		gridData40.verticalAlignment = GridData.CENTER;
		GridData gridData39 = new GridData();
		gridData39.horizontalAlignment = GridData.CENTER;
		gridData39.verticalAlignment = GridData.CENTER;
		GridData gridData38 = new GridData();
		gridData38.verticalAlignment = GridData.CENTER;
		gridData38.horizontalSpan = 2;
		gridData38.horizontalAlignment = GridData.END;
		GridData gridData37 = new GridData();
		gridData37.verticalAlignment = GridData.CENTER;
		gridData37.horizontalAlignment = GridData.CENTER;
		GridData gridData15 = new GridData();
		gridData15.horizontalAlignment = GridData.CENTER;
		gridData15.verticalAlignment = GridData.CENTER;
		gridData15.grabExcessHorizontalSpace = false;
		GridData gridData6 = new GridData();
		gridData6.verticalAlignment = GridData.CENTER;
		gridData6.widthHint = -1;
		gridData6.heightHint = -1;
		gridData6.horizontalSpan = 5;
		gridData6.horizontalAlignment = GridData.CENTER;
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.CENTER;
		gridData11.heightHint = -1;
		gridData11.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.verticalAlignment = GridData.BEGINNING;
		gridData2.grabExcessHorizontalSpace = false;
		gridData2.horizontalSpan = 14;
		gridData2.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.verticalSpan = 2;
		gridData1.horizontalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 16;
		gridLayout.makeColumnsEqualWidth = false;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessVerticalSpace = true;
		gridData3.horizontalSpan = 16;
		gridData3.verticalAlignment = GridData.FILL;
		componentNameText = new Label(this, SWT.NONE);
		componentNameText.setFont(new Font(Display.getDefault(), "Arial Rounded MT Bold", 14, SWT.ITALIC));
		componentNameText.setText("Nom du composant inconnu");
		componentNameText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentNameText.setLayoutData(gridData12);
		runningStateLabel = new Label(this, SWT.NONE);
		componentTypeImage = new Label(this, SWT.NONE);
		componentTypeLabel = new Label(this, SWT.NONE);
		componentTypeLabel.setText("Type du composant inconnu");
		componentTypeLabel.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		componentTypeLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeLabel.setLayoutData(gridData2);
		runningStateLabel.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/invalid_build_tool.gif")));
		runningStateLabel.setLayoutData(gridData11);
		runningStateLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		descriptionTextArea = new Text(this, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		descriptionTextArea.setToolTipText("Description du composant");
		descriptionTextArea.setLayoutData(gridData3);
		descriptionTextArea.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		startLink = new Link(this, SWT.NONE);
		startLink.setText("<a>D\u00e9marrer</a>");
		startLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		startLink.setLayoutData(gridData6);
		startLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsComponent != null) {
					if (petalsComponent.isStarted()) {
						petalsComponent.stop();
						configureLink.setEnabled(false);
					} else {
						petalsComponent.start();
						configureLink.setEnabled(true);
					}
					uninstallLink.setEnabled(false);
					reinstallLink.setEnabled(false);
					refresh();
					PetalsServersView.refresh();
				}
			}
		});
		sepLabel11 = new Label(this, SWT.NONE);
		sepLabel11.setText("|");
		sepLabel11.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		restartLink = new Link(this, SWT.NONE);
		restartLink.setText("<a>Red\u00e9marrer</a>");
		restartLink.setLayoutData(gridData39);
		restartLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		restartLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsComponent!=null && petalsComponent.isStarted()) {
					petalsComponent.stop();
					petalsComponent.start();
					uninstallLink.setEnabled(false);
					reinstallLink.setEnabled(false);
				}
				else {
					petalsComponent.shutdown();
					uninstallLink.setEnabled(true);
					reinstallLink.setEnabled(true);
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel = new Label(this, SWT.NONE);
		sepLabel.setText("|");
		sepLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		uninstallLink = new Link(this, SWT.NONE);
		uninstallLink.setText("<a>D\u00e9sinstaller</a>");
		uninstallLink.setLayoutData(gridData40);
		uninstallLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		uninstallLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsComponent!=null && petalsComponent.isInstalled()) {
					// Tests sur l'\u00e9tat du composant dans le cycle de vie
					if (petalsComponent.isStarted()) {
						petalsComponent.stop();
						petalsComponent.shutdown();
						petalsComponent.uninstall();
					}
					else if (petalsComponent.isStopped()) {
						petalsComponent.shutdown();
						petalsComponent.uninstall();
					}
					else if (petalsComponent.isShutdown()) {
						petalsComponent.uninstall();
					}
				} else {
					petalsComponent.install();
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel1 = new Label(this, SWT.NONE);
		sepLabel1.setText("|");
		sepLabel1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		reinstallLink = new Link(this, SWT.NONE);
		reinstallLink.setText("<a>R\u00e9installer</a>");
		reinstallLink.setToolTipText("");
		reinstallLink.setLayoutData(gridData37);
		reinstallLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		reinstallLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsComponent!=null && petalsComponent.isInstalled()) {
					// Tests sur l'\u00e9tat du composant dans le cycle de vie
					if (petalsComponent.isStarted()) {
						petalsComponent.stop();
						petalsComponent.shutdown();
						petalsComponent.uninstall();
					}
					else if (petalsComponent.isStopped()) {
						petalsComponent.shutdown();
						petalsComponent.uninstall();
					}
					else if (petalsComponent.isShutdown()) {
						petalsComponent.uninstall();
					}
				}
				petalsComponent.install();
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel2 = new Label(this, SWT.NONE);
		sepLabel2.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel2.setText("|");
		configureLink = new Link(this, SWT.NONE);
		configureLink.setText("<a>Configurer</a>");
		configureLink.setLayoutData(gridData41);
		configureLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		configureLink.setEnabled(false);
		suscribeCheckBox = new Button(this, SWT.CHECK | SWT.FLAT);
		suscribeCheckBox.setText("Abonnement");
		suscribeCheckBox.setLayoutData(gridData15);
		suscribeCheckBox.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		configureLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				ConfigureComponentAction configureComponentAction = new ConfigureComponentAction(PetalsServersView.getViewer(), PetalsServersView.getInstance().getViewSite());
				configureComponentAction.run();
			}
		});	
		refreshLink = new Link(this, SWT.NONE);
		refreshLink.setText("<a>Rafrachir</a>");
		refreshLink.setLayoutData(gridData38);
		refreshLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		suscribeCheckBox.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsComponent != null) {
					if (suscribeCheckBox.getSelection()) {
						petalsComponent.subscribe();
					}
					else {
						petalsComponent.unsubscribe();
					}
				}
			}
		});
		refreshLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				refresh();
				PetalsServersView.refresh();
			}
		});
		componentTypeImage.setLayoutData(gridData1);
		componentTypeImage.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeImage.setText("Label");
		this.setLayout(gridLayout);
		this.setLayout(gridLayout);
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		this.setToolTipText("Type du composant");
		this.setSize(new Point(650, 204));
	}
	
	public void fillFields() {
		if (petalsComponent != null) {
			StringBuffer componentDescription = new StringBuffer();
			Image statusImg = null;
			ViewLabelProvider imagesProvider = new ViewLabelProvider();
			
			componentNameText.setText(petalsComponent.getName());
			componentTypeLabel.setText(petalsComponent.getType());
			
			if (StringUtils.isNotEmpty(petalsComponent.getUrl())) {
				componentDescription.append("URL d'installation : ");
				componentDescription.append(petalsComponent.getUrl());
				componentDescription.append("\n");
			}
			
			if (petalsComponent.isEngine()) {
				componentTypeImage.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/newexprj_wiz.png")));
				statusImg = ViewLabelProvider.SE_IMAGE;
			}
			else {
				componentTypeImage.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/newconnector_wiz.png")));
				statusImg = ViewLabelProvider.BC_IMAGE;
			}
			
			runningStateLabel.setImage(imagesProvider.decorateImage(statusImg, petalsComponent));
			
			// Etat dans le cycle de vie du composant
			if (petalsComponent.isInstalled()) {
				startLink.setText("<a>" + (petalsComponent.isStarted() ? "Arr\u00eater" : "D\u00e9marrer") + "</a>");
				restartLink.setText("<a>" + (petalsComponent.isStarted() ? "Red\u00e9marrer" : "Eteindre") + "</a>");
				configureLink.setEnabled(petalsComponent.isShutdown() ? true : false);
				uninstallLink.setText("<a>D\u00e9sinstaller</a>");
				uninstallLink.setEnabled(petalsComponent.isShutdown() ? true : false);
				reinstallLink.setEnabled(petalsComponent.isShutdown() ? true : false);
				startLink.setEnabled(true);
				restartLink.setEnabled(petalsComponent.isShutdown() ? false : true);
			}
			else {
				uninstallLink.setText("<a>Installer</a>");
				startLink.setEnabled(false);
				restartLink.setEnabled(false);
			}
			
			suscribeCheckBox.setSelection(petalsComponent.isSubscribed());
			
			if (StringUtils.isNotEmpty(componentDescription.toString())) {
				descriptionTextArea.setText(componentDescription.toString());
			}
			else {
				descriptionTextArea.setText("Description indisponible");
			}
			
			layout();
		}
	}
	
	public void refresh() {
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						fillFields();
					}
				});
			}
		}).start();
	}
	
	public void apply() {
		if (petalsComponent != null) {
			petalsComponent.setName(componentNameText.getText());
			refresh();
		}
	}
	
}  //  @jve:decl-index=0:visual-constraint="61,43"
