package org.objectweb.petals.tools.plugin.monitor.properties;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.views.properties.tabbed.AbstractPropertySection;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;


public class PetalsComponentPropertySection extends AbstractPropertySection {

	private PetalsComponentComposite bcc;
	
	@Override
	public void aboutToBeHidden() {
		super.aboutToBeHidden();
	}

	@Override
	public void aboutToBeShown() {
		if (bcc != null) {
			bcc.fillFields();
		}
	}

	@Override
	public void createControls(Composite parent, TabbedPropertySheetPage aTabbedPropertySheetPage) {
		bcc = new PetalsComponentComposite(parent, SWT.NONE);
	}

	@Override
	public void dispose() {
		// TODO Raccord de m\u00e9thode auto-g\u00e9n\u00e9r\u00e9
		super.dispose();
	}

	@Override
	public void setInput(IWorkbenchPart part, ISelection selection) {
		PetalsComponent ps = (PetalsComponent)((TreeSelection)selection).getFirstElement();
		bcc.setPetalsComponent(ps);
		refresh();
	}

	@Override
	public void refresh() {
		if (bcc != null) {
			bcc.refresh();
		}
	}

	@Override
	public boolean shouldUseExtraSpace() {
		return true;
	}

}
