package org.objectweb.petals.tools.plugin.monitor.properties;


import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;


public class PetalsComponentPropertySource implements IPropertySource {

	protected PetalsComponent petalsComponent;
	
	private static final String PROPERTY_INSTANCE = "petalsComponent.instance";
	private static final String PROPERTY_NAME = "petalsComponent.name";
	private static final String PROPERTY_TYPE = "petalsComponent.type";
	
	private IPropertyDescriptor[] descriptors;
	
	public PetalsComponentPropertySource(PetalsComponent petalsComponent) {
		super();
		this.petalsComponent = petalsComponent;
	}

	public Object getEditableValue() {
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		if (descriptors == null) {
			PropertyDescriptor nameDescriptor = new PropertyDescriptor(PROPERTY_NAME, "Nom");
			nameDescriptor.setCategory("G\u00e9n\u00e9ral");
			PropertyDescriptor typeDescriptor = new PropertyDescriptor(PROPERTY_TYPE, "Type du composant");
			typeDescriptor.setCategory("G\u00e9n\u00e9ral");
			descriptors = new IPropertyDescriptor[] {nameDescriptor, typeDescriptor};
		}
		return descriptors;
	}

	public Object getPropertyValue(Object id) {
		if (id != null) {
			if (id.equals(PROPERTY_NAME)) {
				return petalsComponent.getName();
			} else if (id.equals(PROPERTY_TYPE)) {
				return petalsComponent.getType();
			} else if (id.equals(PROPERTY_INSTANCE)) {
				return petalsComponent;
			}
		}
		return null;
	}

	public boolean isPropertySet(Object id) {
		if (id == null) {
			return false;
		}
		return id.equals(PROPERTY_NAME) || id.equals(PROPERTY_TYPE);
	}

	public void resetPropertyValue(Object id) {
		
	}

	public void setPropertyValue(Object id, Object value) {
		if (value != null) {
			if (id.equals(PROPERTY_NAME)) {
				petalsComponent.setName(value.toString());
			} else if (id.equals(PROPERTY_TYPE)) {
				petalsComponent.setDescription(value.toString());
			}
		}
	}
}
