package org.objectweb.petals.tools.plugin.monitor.properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.monitor.actions.NewComponentAction;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewLabelProvider;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class PetalsServerComposite extends Composite {
	
	private NewComponentAction newComponentAction;
	
	private Link addComponentLink = null;
	private Link refreshLink = null;
	private Label sepLabel1 = null;
	private Label componentTypeImage = null;
	private Label componentTypeLabel = null;
	private Text descriptionTextArea = null;
	private Link applyLink = null;
	private Label sepLabel11 = null;
	private Label connectionStatusIcon = null;
	private Label sepLabel12 = null;
	private Link consoleLink = null;
	private Button monitorCheckBox = null;
	private Link connectLink = null;
	private Label hostLabel = null;
	private Label sepLabel2 = null;
	private Link shutdownLink = null;
	
	protected PetalsServer petalsServer;  //  @jve:decl-index=0:
	private Text serverNameText = null;
	
	private static PetalsServerComposite instance;
	public static PetalsServerComposite getInstance() {
		return instance;
	}
	
	public void setPetalsServer(PetalsServer petalsServer) {
		this.petalsServer = petalsServer;
	}
	
	public PetalsServerComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
		instance = this;
	}

	private void initialize() {
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.verticalAlignment = GridData.CENTER;
		gridData12.horizontalSpan = 23;
		gridData12.grabExcessHorizontalSpace = true;
		GridData gridData42 = new GridData();
		gridData42.horizontalAlignment = GridData.END;
		gridData42.verticalAlignment = GridData.CENTER;
		GridData gridData41 = new GridData();
		gridData41.horizontalAlignment = GridData.CENTER;
		gridData41.verticalAlignment = GridData.CENTER;
		GridData gridData39 = new GridData();
		gridData39.horizontalAlignment = GridData.CENTER;
		gridData39.verticalAlignment = GridData.CENTER;
		GridData gridData38 = new GridData();
		gridData38.verticalAlignment = GridData.CENTER;
		gridData38.grabExcessHorizontalSpace = false;
		gridData38.horizontalSpan = 6;
		gridData38.horizontalAlignment = GridData.BEGINNING;
		GridData gridData37 = new GridData();
		gridData37.horizontalSpan = 2;
		gridData37.verticalAlignment = GridData.CENTER;
		gridData37.horizontalAlignment = GridData.CENTER;
		GridData gridData36 = new GridData();
		gridData36.verticalAlignment = GridData.CENTER;
		gridData36.grabExcessHorizontalSpace = true;
		gridData36.horizontalSpan = 24;
		gridData36.horizontalAlignment = GridData.FILL;
		GridData gridData15 = new GridData();
		gridData15.horizontalSpan = 13;
		gridData15.horizontalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		gridData15.verticalAlignment = GridData.CENTER;
		gridData15.grabExcessHorizontalSpace = true;
		GridData gridData7 = new GridData();
		gridData7.horizontalAlignment = GridData.END;
		gridData7.grabExcessHorizontalSpace = false;
		gridData7.verticalAlignment = GridData.CENTER;
		GridData gridData6 = new GridData();
		gridData6.horizontalSpan = 4;
		gridData6.verticalAlignment = GridData.CENTER;
		gridData6.horizontalAlignment = GridData.CENTER;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessVerticalSpace = true;
		gridData3.horizontalSpan = 32;
		gridData3.verticalAlignment = GridData.FILL;
		GridData gridData2 = new GridData();
		gridData2.verticalAlignment = GridData.BEGINNING;
		gridData2.horizontalSpan = 24;
		gridData2.grabExcessHorizontalSpace = false;
		gridData2.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.verticalSpan = 3;
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.horizontalSpan = 8;
		gridData1.horizontalAlignment = GridData.END;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 32;
		serverNameText = new Text(this, SWT.NONE);
		serverNameText.setFont(new Font(Display.getDefault(), "Arial Rounded MT Bold", 14, SWT.ITALIC));
		serverNameText.setText("Server Name");
		serverNameText.setLayoutData(gridData12);
		connectionStatusIcon = new Label(this, SWT.NONE);
		componentTypeImage = new Label(this, SWT.NONE);
		componentTypeLabel = new Label(this, SWT.NONE);
		componentTypeLabel.setText("PETALS Server");
		componentTypeLabel.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		componentTypeLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeLabel.setLayoutData(gridData2);
		connectionStatusIcon.setText("Label");
		connectionStatusIcon.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		connectionStatusIcon.setLayoutData(gridData7);
		connectionStatusIcon.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/connectedserver.gif")));
		hostLabel = new Label(this, SWT.NONE);
		hostLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		hostLabel.setToolTipText("server ID at host and jmx port");
		hostLabel.setLayoutData(gridData36);
		hostLabel.setText("ID@hostname:port");
		descriptionTextArea = new Text(this, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		descriptionTextArea.setToolTipText("Component description");
		descriptionTextArea.setLayoutData(gridData3);
		descriptionTextArea.setText("description");
		descriptionTextArea.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		connectLink = new Link(this, SWT.NONE);
		connectLink.setText("<a>Connecter</a>");
		connectLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		connectLink.setLayoutData(gridData6);
		connectLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsServer != null) {
					if (petalsServer.isConnected()) {
						disconnect();
					} else {
						connect();
					}
					refresh();
				}
			}
		});
		sepLabel11 = new Label(this, SWT.NONE);
		sepLabel11.setText("|");
		sepLabel11.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		newComponentAction = new NewComponentAction(PetalsServersView.getViewer(), PetalsServersView.getInstance().getViewSite());
		addComponentLink = new Link(this, SWT.NONE);
		addComponentLink.setText("<a>Ajouter un composant</a>");
		addComponentLink.setEnabled(true);
		addComponentLink.setLayoutData(gridData39);
		addComponentLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		addComponentLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (petalsServer != null) {
					newComponentAction.run();
				}
			}
		});
		sepLabel1 = new Label(this, SWT.NONE);
		sepLabel1.setText("|");
		sepLabel1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		shutdownLink = new Link(this, SWT.NONE);
		shutdownLink.setText("<a>Eteindre</a>");
		shutdownLink.setToolTipText("");
		shutdownLink.setLayoutData(gridData37);
		shutdownLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		shutdownLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (petalsServer != null) {
							petalsServer.shutdown(false);
						}
					}
				});
		sepLabel2 = new Label(this, SWT.NONE);
		sepLabel2.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel2.setText("|");
		consoleLink = new Link(this, SWT.NONE);
		consoleLink.setText("<a>Console</a>");
		consoleLink.setLayoutData(gridData41);
		consoleLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		monitorCheckBox = new Button(this, SWT.CHECK | SWT.FLAT);
		monitorCheckBox.setText("Monitor\u00e9");
		monitorCheckBox.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		monitorCheckBox.setLayoutData(gridData15);
		monitorCheckBox
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (petalsServer != null) {
							petalsServer.setMonitoring(monitorCheckBox.getSelection());
						}
					}
				});
		applyLink = new Link(this, SWT.NONE);
		applyLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				apply();
			}
		});
		applyLink.setText("<a>Appliquer</a>");
		applyLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		applyLink.setLayoutData(gridData42);
		sepLabel12 = new Label(this, SWT.NONE);
		sepLabel12.setText("|");
		sepLabel12.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink = new Link(this, SWT.NONE);
		refreshLink.setText("<a>Rafraichir</a>");
		refreshLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink.setLayoutData(gridData38);
		refreshLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				refresh();
			}
		});
		componentTypeImage.setText("Label");
		componentTypeImage.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeImage.setLayoutData(gridData1);
		componentTypeImage.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/newconnector_wiz.png")));
		this.setLayout(gridLayout);
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		this.setToolTipText("Component type");
		this.setSize(new Point(650, 204));
	}
	
	public void fillFields() {
		if (petalsServer != null) {
			serverNameText.setText(petalsServer.getName());
			componentTypeLabel.setText(petalsServer.getType());
			descriptionTextArea.setText(petalsServer.getDescription() != null ? petalsServer.getDescription() : "");
			hostLabel.setText(petalsServer.isConnected() ? "Connect\u00e9 sur " + (petalsServer.getName() != null && !petalsServer.getName().equals("") ? petalsServer.getName() + (petalsServer.getHost() != null && petalsServer.getJmxPort() != null ? "@" + petalsServer.getHost() + ":" + petalsServer.getJmxPort() : "") : petalsServer.getJmxUrl()) : "D\u00e9connect\u00e9");
			connectLink.setText("<a>" + (petalsServer.isConnected() ? "D\u00e9connecter" : "Connecter") + "</a>");
			consoleLink.setEnabled(petalsServer.getHttpUrl() != null);
			monitorCheckBox.setSelection(petalsServer.isMonitored());
			connectionStatusIcon.setImage(petalsServer.isConnected() ? ViewLabelProvider.CONNECTED_PETALS_SERVER_IMAGE : ViewLabelProvider.DISCONNECTED_PETALS_SERVER_IMAGE);
			isEnabled(petalsServer.isConnected(), petalsServer);
			layout();
		}
	}
	
	public void refresh() {
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						fillFields();
					}
				});
		}
		}).start();
		PetalsServersView.refresh();
	}
	
	public void apply() {
		if (petalsServer != null) {
			petalsServer.setDescription(descriptionTextArea.getText());
			petalsServer.setName(serverNameText.getText());
			refresh();
		}
	}
	
	public void connect() {
		if (petalsServer != null) {
			petalsServer.connect();
			PetalsServersView.getInstance().connect(petalsServer);
			isEnabled(true, petalsServer);
		}
	}
	
	public void disconnect() {
		if (petalsServer != null) {
			isEnabled(false, petalsServer);
			PetalsServersView.getInstance().disconnect(petalsServer);
			petalsServer.disconnect();
		}
	}
	
	void isEnabled(boolean enabled, PetalsServer ps) {
		shutdownLink.setEnabled(enabled);
		monitorCheckBox.setEnabled(enabled);
		addComponentLink.setEnabled(enabled);
		applyLink.setEnabled(enabled);
		refreshLink.setEnabled(enabled);
		consoleLink.setEnabled(ps.getHttpUrl() != null);
	}
	
}  //  @jve:decl-index=0:visual-constraint="59,52"
