package org.objectweb.petals.tools.plugin.monitor.properties;



import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;


public class PetalsServerPropertySource implements IPropertySource {

	protected PetalsServer petalsServer;
	
	private static final String PROPERTY_INSTANCE = "petalsServer.instance";
	private static final String PROPERTY_NAME = "petalsServer.name";
	private static final String PROPERTY_DESCRIPTION = "petalsServer.description";
	
	private IPropertyDescriptor[] descriptors;
	
	public PetalsServerPropertySource(PetalsServer petalsServer) {
		super();
		this.petalsServer = petalsServer;
	}

	public Object getEditableValue() {
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		if (descriptors == null) {
			PropertyDescriptor nameDescriptor = new PropertyDescriptor(PROPERTY_NAME, "Nom");
			nameDescriptor.setCategory("G\u00e9n\u00e9ral");
			TextPropertyDescriptor descriptionDescriptor = new TextPropertyDescriptor(PROPERTY_DESCRIPTION, "Description");
			descriptionDescriptor.setCategory("Divers");
			//TextPropertyDescriptor instanceDescriptor = new TextPropertyDescriptor(PROPERTY_INSTANCE, "Instance");
			descriptors = new IPropertyDescriptor[] {nameDescriptor, descriptionDescriptor};
		}
		return descriptors;
	}

	public Object getPropertyValue(Object id) {
		if (id != null) {
			if (id.equals(PROPERTY_NAME)) {
				return petalsServer.getName();
			} else if (id.equals(PROPERTY_DESCRIPTION)) {
				return petalsServer.getDescription();
			} else if (id.equals(PROPERTY_INSTANCE)) {
				return petalsServer;
			}
		}
		return null;
	}

	public boolean isPropertySet(Object id) {
		if (id == null) {
			return false;
		}
		return id.equals(PROPERTY_NAME) || id.equals(PROPERTY_DESCRIPTION);
	}

	public void resetPropertyValue(Object id) {
		
	}

	public void setPropertyValue(Object id, Object value) {
		if (value != null) {
			if (id.equals(PROPERTY_NAME)) {
				petalsServer.setName(value.toString());
			} else if (id.equals(PROPERTY_DESCRIPTION)) {
				petalsServer.setDescription(value.toString());
			}
		}
	}

}
