package org.objectweb.petals.tools.plugin.monitor.properties;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceAssembly;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewLabelProvider;
import org.objectweb.petals.tools.plugin.monitor.utils.StringUtils;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class ServiceAssemblyComposite extends Composite {
	
	private Link restartLink = null;
	private Link undeployLink = null;
	private Link refreshLink = null;
	private Label sepLabel = null;
	private Label componentTypeImage = null;
	private Label componentTypeLabel = null;
	private Label sepLabel11 = null;
	private Label runningStateLabel = null;
	private Link startLink = null;
	private Text descriptionTextArea = null;
	
	protected ServiceAssembly serviceAssembly;  //  @jve:decl-index=0:
	private Label componentNameText = null;
	
	private static ServiceAssemblyComposite instance;
	
	public static ServiceAssemblyComposite getInstance() {
		return instance;
	}
	
	public void setServiceUnit(ServiceAssembly serviceAssembly) {
		this.serviceAssembly = serviceAssembly;
	}
	
	public ServiceAssemblyComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
		instance = this;
	}

	private void initialize() {
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.verticalAlignment = GridData.CENTER;
		gridData12.horizontalSpan = 10;
		gridData12.grabExcessHorizontalSpace = true;
		GridData gridData42 = new GridData();
		gridData42.horizontalAlignment = GridData.CENTER;
		gridData42.verticalAlignment = GridData.CENTER;
		GridData gridData40 = new GridData();
		gridData40.horizontalAlignment = GridData.BEGINNING;
		gridData40.horizontalSpan = 7;
		gridData40.verticalAlignment = GridData.CENTER;
		GridData gridData39 = new GridData();
		gridData39.horizontalAlignment = GridData.CENTER;
		gridData39.verticalAlignment = GridData.CENTER;
		GridData gridData38 = new GridData();
		gridData38.verticalAlignment = GridData.CENTER;
		gridData38.horizontalAlignment = GridData.END;
		GridData gridData6 = new GridData();
		gridData6.verticalAlignment = GridData.CENTER;
		gridData6.horizontalAlignment = GridData.CENTER;
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.CENTER;
		gridData11.heightHint = -1;
		gridData11.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.verticalAlignment = GridData.BEGINNING;
		gridData2.horizontalSpan = 10;
		gridData2.grabExcessHorizontalSpace = false;
		gridData2.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.verticalSpan = 2;
		gridData1.horizontalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 12;
		gridLayout.makeColumnsEqualWidth = false;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessVerticalSpace = true;
		gridData3.horizontalSpan = 12;
		gridData3.verticalAlignment = GridData.FILL;
		componentNameText = new Label(this, SWT.NONE);
		componentNameText.setFont(new Font(Display.getDefault(), "Arial Rounded MT Bold", 14, SWT.ITALIC));
		componentNameText.setText("Nom du composant inconnu");
		componentNameText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentNameText.setLayoutData(gridData12);
		runningStateLabel = new Label(this, SWT.NONE);
		componentTypeImage = new Label(this, SWT.NONE);
		componentTypeImage.setLayoutData(gridData1);
		componentTypeImage.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeImage.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/sa_ban.png")));
		componentTypeLabel = new Label(this, SWT.NONE);
		componentTypeLabel.setText("Type du composant inconnu");
		componentTypeLabel.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		componentTypeLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeLabel.setLayoutData(gridData2);
		runningStateLabel.setLayoutData(gridData11);
		runningStateLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		runningStateLabel.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/invalid_build_tool.gif")));
		descriptionTextArea = new Text(this, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		descriptionTextArea.setToolTipText("Description du composant");
		descriptionTextArea.setLayoutData(gridData3);
		descriptionTextArea.setText("Description indisponible");
		descriptionTextArea.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		startLink = new Link(this, SWT.NONE);
		startLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceAssembly != null) {
					if (serviceAssembly.isStarted()) {
						serviceAssembly.stop();
					} else {
						serviceAssembly.start();
					}
					refresh();
					PetalsServersView.refresh();
				}
			}
		});
		sepLabel = new Label(this, SWT.NONE);
		restartLink = new Link(this, SWT.NONE);
		restartLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceAssembly!=null && serviceAssembly.isStarted()) {
					serviceAssembly.stop();
					serviceAssembly.start();
				}
				else {
					serviceAssembly.shutdown();
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel11 = new Label(this, SWT.NONE);
		undeployLink = new Link(this, SWT.NONE);
		undeployLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceAssembly!=null && serviceAssembly.isDeployed()) {
					// Tests sur l'\u00e9tat du composant dans le cycle de vie
					try {
						if (serviceAssembly.isStarted()) {
							serviceAssembly.stop();
							serviceAssembly.shutdown();
							serviceAssembly.undeploy();
						}
						else if (serviceAssembly.isStopped()) {
							serviceAssembly.shutdown();
							serviceAssembly.undeploy();
						}
						else if (serviceAssembly.isShutdown()) {
							serviceAssembly.undeploy();
						}
					} catch(Exception e1) {
						MessageDialog.openError(null,"Repliement", "Impossible de replier le SA " + serviceAssembly.getName() + "(" + e1.getMessage() + ")");
					}
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		startLink.setText("<a>D\u00e9marrer</a>");
		startLink.setLayoutData(gridData6);
		startLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel11.setText("|");
		sepLabel11.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		restartLink.setLayoutData(gridData39);
		restartLink.setText("<a>Red\u00e9marrer</a>");
		restartLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel.setText("|");
		sepLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		undeployLink.setLayoutData(gridData40);
		undeployLink.setText("<a>Replier</a>");
		undeployLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink = new Link(this, SWT.NONE);
		refreshLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink.setLayoutData(gridData38);
		refreshLink.setText("<a>Rafrachir</a>");
		refreshLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				refresh();
				PetalsServersView.refresh();
			}
		});
		this.setLayout(gridLayout);
		this.setLayout(gridLayout);
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		this.setToolTipText("Type du composant");
		this.setSize(new Point(650, 204));
	}
	
	public void fillFields() {
		if (serviceAssembly != null) {
			StringBuffer saDescription = new StringBuffer();
			Image statusImg = ViewLabelProvider.SA_IMAGE;
			ViewLabelProvider imagesProvider = new ViewLabelProvider();
			runningStateLabel.setImage(imagesProvider.decorateImage(statusImg, serviceAssembly));
			
			if (StringUtils.isNotEmpty(serviceAssembly.getName())) {
				componentNameText.setText(serviceAssembly.getName());
			}
			if (StringUtils.isNotEmpty(serviceAssembly.getType())) {
				componentTypeLabel.setText(serviceAssembly.getType());
			}
			if (StringUtils.isNotEmpty(serviceAssembly.getComponentName())) {
				saDescription.append("Nom du conteneur : ");
				saDescription.append(serviceAssembly.getComponentName());
				saDescription.append("\n");
			}
			if (StringUtils.isNotEmpty(serviceAssembly.getDescription())) {
				saDescription.append(serviceAssembly.getDescription());
				saDescription.append("\n");
			}
			
			// Etat dans le cycle de vie du composant
			if (serviceAssembly.isDeployed()) {
				startLink.setText("<a>" + (serviceAssembly.isStarted() ? "Arr\u00eater" : "D\u00e9marrer") + "</a>");
				restartLink.setText("<a>" + (serviceAssembly.isStarted() ? "Red\u00e9marrer" : "Eteindre") + "</a>");
				undeployLink.setText("<a>Replier</a>");
				startLink.setEnabled(true);
				restartLink.setEnabled(true);
			}
			else {
				undeployLink.setText("<a>D\u00e9ployer</a>");
				startLink.setEnabled(false);
				restartLink.setEnabled(false);
			}
			
			if (StringUtils.isNotEmpty(saDescription.toString())) {
				descriptionTextArea.setText(saDescription.toString());
			}
			
			layout();
		}
	}
	
	public void refresh() {
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						fillFields();
					}
				});
			}
		}).start();
	}
	
	public void apply() {
		if (serviceAssembly != null) {
			serviceAssembly.setName(componentNameText.getText());
			refresh();
		}
	}
	
}  //  @jve:decl-index=0:visual-constraint="61,43"
