package org.objectweb.petals.tools.plugin.monitor.properties;

import java.util.List;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.objectweb.petals.tools.plugin.monitor.model.BindingComponent;
import org.objectweb.petals.tools.plugin.monitor.model.FolderComponent;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsComponent;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceEngine;
import org.objectweb.petals.tools.plugin.monitor.model.ServiceUnit;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeObject;
import org.objectweb.petals.tools.plugin.monitor.providers.TreeParent;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewLabelProvider;
import org.objectweb.petals.tools.plugin.monitor.utils.StringUtils;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class ServiceUnitComposite extends Composite {
	
	private Link restartLink = null;
	private Link undeployLink = null;
	private Link refreshLink = null;
	private Label sepLabel = null;
	private Label sepLabel1 = null;
	private Label componentTypeImage = null;
	private Label componentTypeLabel = null;
	private Label sepLabel11 = null;
	private Link reachLink = null;
	private Label runningStateLabel = null;
	private Link startLink = null;
	private Text descriptionTextArea = null;
	
	protected ServiceUnit serviceUnit;  //  @jve:decl-index=0:
	private Label componentNameText = null;
	
	private static ServiceUnitComposite instance;
	
	public static ServiceUnitComposite getInstance() {
		return instance;
	}
	
	public void setServiceUnit(ServiceUnit serviceUnit) {
		this.serviceUnit = serviceUnit;
	}
	
	public ServiceUnitComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
		instance = this;
	}

	private void initialize() {
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.verticalAlignment = GridData.CENTER;
		gridData12.horizontalSpan = 10;
		gridData12.grabExcessHorizontalSpace = true;
		GridData gridData42 = new GridData();
		gridData42.horizontalAlignment = GridData.CENTER;
		gridData42.verticalAlignment = GridData.CENTER;
		GridData gridData41 = new GridData();
		gridData41.horizontalAlignment = GridData.BEGINNING;
		gridData41.horizontalSpan = 5;
		gridData41.verticalAlignment = GridData.CENTER;
		GridData gridData40 = new GridData();
		gridData40.horizontalAlignment = GridData.CENTER;
		gridData40.verticalAlignment = GridData.CENTER;
		GridData gridData39 = new GridData();
		gridData39.horizontalAlignment = GridData.CENTER;
		gridData39.verticalAlignment = GridData.CENTER;
		GridData gridData38 = new GridData();
		gridData38.verticalAlignment = GridData.CENTER;
		gridData38.horizontalAlignment = GridData.END;
		GridData gridData6 = new GridData();
		gridData6.verticalAlignment = GridData.CENTER;
		gridData6.horizontalAlignment = GridData.CENTER;
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.CENTER;
		gridData11.heightHint = -1;
		gridData11.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.verticalAlignment = GridData.BEGINNING;
		gridData2.horizontalSpan = 10;
		gridData2.grabExcessHorizontalSpace = false;
		gridData2.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.verticalSpan = 2;
		gridData1.horizontalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 12;
		gridLayout.makeColumnsEqualWidth = false;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessVerticalSpace = true;
		gridData3.horizontalSpan = 12;
		gridData3.verticalAlignment = GridData.FILL;
		componentNameText = new Label(this, SWT.NONE);
		componentNameText.setFont(new Font(Display.getDefault(), "Arial Rounded MT Bold", 14, SWT.ITALIC));
		componentNameText.setText("Nom du composant inconnu");
		componentNameText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentNameText.setLayoutData(gridData12);
		runningStateLabel = new Label(this, SWT.NONE);
		componentTypeImage = new Label(this, SWT.NONE);
		componentTypeImage.setLayoutData(gridData1);
		componentTypeImage.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeImage.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/su_ban.png")));
		componentTypeLabel = new Label(this, SWT.NONE);
		componentTypeLabel.setText("Type du composant inconnu");
		componentTypeLabel.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		componentTypeLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		componentTypeLabel.setLayoutData(gridData2);
		runningStateLabel.setLayoutData(gridData11);
		runningStateLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		runningStateLabel.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/invalid_build_tool.gif")));
		descriptionTextArea = new Text(this, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		descriptionTextArea.setToolTipText("Description du composant");
		descriptionTextArea.setLayoutData(gridData3);
		descriptionTextArea.setText("Description indisponible");
		descriptionTextArea.setFont(new Font(Display.getDefault(), "Segoe UI", 8, SWT.ITALIC));
		startLink = new Link(this, SWT.NONE);
		startLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceUnit != null) {
					if (serviceUnit.isStarted()) {
						serviceUnit.stop();
					} else {
						serviceUnit.start();
					}
					refresh();
					PetalsServersView.refresh();
				}
			}
		});
		sepLabel = new Label(this, SWT.NONE);
		restartLink = new Link(this, SWT.NONE);
		restartLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceUnit!=null && serviceUnit.isStarted()) {
					serviceUnit.stop();
					serviceUnit.start();
				}
				else {
					serviceUnit.shutdown();
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel11 = new Label(this, SWT.NONE);
		undeployLink = new Link(this, SWT.NONE);
		undeployLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (serviceUnit!=null && serviceUnit.isDeployed()) {
					// Tests sur l'\u00e9tat du composant dans le cycle de vie
					try {
						if (serviceUnit.isStarted()) {
							serviceUnit.stop();
							serviceUnit.shutdown();
							serviceUnit.undeploy();
						}
						else if (serviceUnit.isStopped()) {
							serviceUnit.shutdown();
							serviceUnit.undeploy();
						}
						else if (serviceUnit.isShutdown()) {
							serviceUnit.undeploy();
						}
					} catch(Exception e1) {
						MessageDialog.openError(null,"Repliement", "Impossible de replier le SA " + serviceUnit.getName() + "(" + e1.getMessage() + ")");
					}
				}
				refresh();
				PetalsServersView.refresh();
			}
		});
		sepLabel1 = new Label(this, SWT.NONE);
		reachLink = new Link(this, SWT.NONE);
		reachLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				// D\u00e9termination du PetalsServer contenant le SA
				PetalsServer ps = null;
				Object[] listeRoot = PetalsServersView.getInstance().getProvider().getElements(null);
				for (int i=0; i<listeRoot.length; i++) {
					if (((PetalsServer)listeRoot[i]).containsServiceUnit(serviceUnit)) {
						ps = (PetalsServer)listeRoot[0];
					}
				}
				
				// D\u00e9termination du folder
				FolderComponent folder = null;
				TreeObject[] listeFolders = ps.getChildren();
				for (int i=0; i<listeFolders.length; i++) {
					if (PetalsServer.BC_TEXT.equals(listeFolders[i].getName())) {
						folder = (FolderComponent)listeFolders[i];
					}
				}
				
				// D\u00e9termination du BC...
				PetalsComponent pc = null;
				List<BindingComponent> bcContenus = ps.getBindingComponents();
				for (BindingComponent bcCourant : bcContenus) {
					// Nom du BC courant
					String nomBcTrouve = bcCourant.getName();
					if (StringUtils.isNotEmpty(nomBcTrouve) 
							&& StringUtils.isNotEmpty(serviceUnit.getComponentName())
							&& nomBcTrouve.equals(serviceUnit.getComponentName())) {
						
						pc = bcCourant;
					}
				}
				// ...ou du SE
				List<ServiceEngine> seContenus = ps.getEngineComponents();
				for (ServiceEngine seCourant : seContenus) {
					// Nom du SE courant
					String nomSeTrouve = seCourant.getName();
					if (StringUtils.isNotEmpty(nomSeTrouve) 
							&& StringUtils.isNotEmpty(serviceUnit.getComponentName())
							&& nomSeTrouve.equals(serviceUnit.getComponentName())) {
						
						pc = seCourant;
					}
				}
				
				// S\u00e9lection du Container dans le TreeView
				if (ps!=null && folder!=null && pc!=null) {
					TreeParent[] objectPath = { ps, folder, pc };
					PetalsServersView.getViewer().setSelection(new TreeSelection(new TreePath(objectPath)));
				}
			}
		});	
		startLink.setText("<a>D\u00e9marrer</a>");
		startLink.setLayoutData(gridData6);
		startLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel11.setText("|");
		sepLabel11.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		restartLink.setLayoutData(gridData39);
		restartLink.setText("<a>Red\u00e9marrer</a>");
		restartLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel.setText("|");
		sepLabel.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		undeployLink.setLayoutData(gridData40);
		undeployLink.setText("<a>Replier</a>");
		undeployLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		sepLabel1.setText("|");
		sepLabel1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		reachLink.setLayoutData(gridData41);
		reachLink.setText("<a>Atteindre</a>");
		reachLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink = new Link(this, SWT.NONE);
		refreshLink.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		refreshLink.setText("<a>Rafrachir</a>");
		refreshLink.setLayoutData(gridData38);
		refreshLink.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				refresh();
				PetalsServersView.refresh();
			}
		});
		this.setLayout(gridLayout);
		this.setLayout(gridLayout);
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		this.setToolTipText("Type du composant");
		this.setSize(new Point(650, 204));
	}
	
	public void fillFields() {
		if (serviceUnit != null) {
			StringBuffer suDescription = new StringBuffer();
			Image statusImg = ViewLabelProvider.SU_IMAGE;
			ViewLabelProvider imagesProvider = new ViewLabelProvider();
			
			if (StringUtils.isNotEmpty(serviceUnit.getName())) {
				componentNameText.setText(serviceUnit.getName());
			}
			if (StringUtils.isNotEmpty(serviceUnit.getType())) {
				componentTypeLabel.setText(serviceUnit.getType());
			}
			if (StringUtils.isNotEmpty(serviceUnit.getComponentName())) {
				suDescription.append("Nom du conteneur : ");
				suDescription.append(serviceUnit.getComponentName());
				suDescription.append("\n");
			}
			if (StringUtils.isNotEmpty(serviceUnit.getDescription())) {
				suDescription.append(serviceUnit.getDescription());
				suDescription.append("\n");
			}
			
			// Etat dans le cycle de vie du composant
			if (serviceUnit.isDeployed()) {
				startLink.setText("<a>" + (serviceUnit.isStarted() ? "Arr\u00eater" : "D\u00e9marrer") + "</a>");
				restartLink.setText("<a>" + (serviceUnit.isStarted() ? "Red\u00e9marrer" : "Eteindre") + "</a>");
				undeployLink.setText("<a>Replier</a>");
				startLink.setEnabled(true);
				restartLink.setEnabled(true);
			}
			else {
				undeployLink.setText("<a>D\u00e9ployer</a>");
				startLink.setEnabled(false);
				restartLink.setEnabled(false);
			}
			
			runningStateLabel.setImage(imagesProvider.decorateImage(statusImg, serviceUnit));
			
			if (StringUtils.isNotEmpty(suDescription.toString())) {
				descriptionTextArea.setText(suDescription.toString());
			}
			
			layout();
		}
	}
	
	public void refresh() {
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						fillFields();
					}
				});
			}
		}).start();
	}
	
	public void apply() {
		if (serviceUnit != null) {
			serviceUnit.setName(componentNameText.getText());
			refresh();
		}
	}
	
}  //  @jve:decl-index=0:visual-constraint="61,43"
