package org.objectweb.petals.tools.plugin.monitor.properties;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.views.properties.tabbed.AbstractPropertySection;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.objectweb.petals.tools.plugin.monitor.model.SharedLibrary;


public class SharedLibraryPropertySection extends AbstractPropertySection {

	private SharedLibraryComposite slc;
	
	@Override
	public void aboutToBeHidden() {
		// TODO Raccord de m\u00e9thode auto-g\u00e9n\u00e9r\u00e9
		super.aboutToBeHidden();
	}

	@Override
	public void aboutToBeShown() {
		if (slc != null) {
			slc.fillFields();
		}
	}

	@Override
	public void createControls(Composite parent, TabbedPropertySheetPage aTabbedPropertySheetPage) {
		slc = new SharedLibraryComposite(parent, SWT.NONE);
	}

	@Override
	public void dispose() {
		// TODO Raccord de m\u00e9thode auto-g\u00e9n\u00e9r\u00e9
		super.dispose();
	}

	@Override
	public void setInput(IWorkbenchPart part, ISelection selection) {
		SharedLibrary sl = (SharedLibrary)((TreeSelection)selection).getFirstElement();
		slc.setSharedLibrary(sl);
		refresh();
	}

	@Override
	public void refresh() {
		if (slc != null) {
			slc.refresh();
		}
	}

	@Override
	public boolean shouldUseExtraSpace() {
		return true;
	}

}
