package org.objectweb.petals.tools.plugin.monitor.providers;

import java.util.ArrayList;

public class TreeParent extends TreeObject {

	/**
	 * 
	 */
	private static final long serialVersionUID = -106343654067299966L;
	protected ArrayList<TreeObject> children;

	public TreeParent() {
		children = new ArrayList<TreeObject>();
	}

	public void addChild(TreeObject child) {
		children.add(child);
		child.setParent(this);
	}

	public void removeChild(TreeObject child) {
		children.remove(child);
		child.setParent(null);
	}

	public TreeObject[] getChildren() {
		return (TreeObject[]) children.toArray(new TreeObject[children.size()]);
	}

	public boolean hasChildren() {
		return children.size() > 0;
	}

	public void clearChildren() {
		children.clear();
	}

	public String toString() {
		return super.toString() + " (" + children.size() + ")";
	}

	public void addChildren(TreeObject[] children) {
		for (TreeObject to: children) {
			addChild(to);
		}
	}
	
}
