package org.objectweb.petals.tools.plugin.monitor.providers;

import java.io.Serializable;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;

public class ViewContentProvider implements IStructuredContentProvider, ITreeContentProvider, Serializable {
	
	private static final long serialVersionUID = 2200682405716384259L;
	private TreeParent root = new TreeParent();
	
	public void inputChanged(Viewer v, Object oldInput, Object newInput) {
	}

	public void dispose() {
	}

	public Object[] getElements(Object parent) {
		if (!(parent instanceof TreeObject)) {
			if (!root.hasChildren()) {
				initialize();
			}
			return getChildren(root);
		}
		return getChildren(parent);
	}

	public Object getParent(Object child) {
		if (child instanceof TreeObject) {
			return ((TreeObject) child).getParent();
		}
		return null;
	}

	public TreeObject[] getChildren(Object parent) {
		if (parent == null) {
			return root.getChildren();
		} else if (parent instanceof TreeParent) {
			return ((TreeParent) parent).getChildren();
		}
		return new TreeObject[0];
	}

	public boolean hasChildren(Object parent) {
		if (parent == null) {
			return root.hasChildren();
		} else if (parent instanceof TreeParent)
			return ((TreeParent) parent).hasChildren();
		return false;
	}

	private void initialize() {

		// PetalsServer ps = new PetalsServer(jmxAddress);
		// addPetalsServer(ps);

	}

	public void add(TreeObject treeObject) {
		root.addChild(treeObject);
	}

	public void remove(TreeObject treeObject) {
		root.removeChild(treeObject);
	}

	public boolean isEmpty() {
		return !root.hasChildren();
	}
	
	public boolean contains(TreeObject treeObject) {
		for (TreeObject to: root.children) {
			if (to instanceof PetalsServer && treeObject instanceof PetalsServer) {
				if ( ((PetalsServer)to).getJmxUrl().equals(((PetalsServer)treeObject).getJmxUrl())) {
					return true;
				}
			}
		}
		return false;
	}
}