package org.objectweb.petals.tools.plugin.monitor.utils;

import java.io.File;

public class StringUtils {
	
	/**
	 * Teste si la chane est vide ou nulle
	 * 
	 * @param chaine Chane \u00e0 tester
	 * 
	 * @return true si la chane est nulle ou vide, false sinon
	 */
	public static boolean isEmpty(String chaine) {
		boolean reponse = true;
		if (chaine!=null && chaine.length()>0) {
			reponse = false;
		}
		return reponse;
	}
	
	/**
	 * Teste si la chaine est non nulle et non vide
	 * 
	 * @param chaine La chaine \u00e0 tester
	 * 
	 * @return flase si la chaine est non nulle ou non vide, false sinon
	 */
	public static boolean isNotEmpty(String chaine) {
		return !isEmpty(chaine);
	}
	
	/**
	 * Teste si la chaine saisie n'est pas une url.
	 * Si tel est le cas, adapte le chemin du fichier en file:/// etc...
	 * 
	 * @param chaine La chaine \u00e0 tester
	 * 
	 * @return Le chaine adapt\u00e9e
	 */
	public static String miseEnFormeUrl(String chaine) {
		String chaineEnForme = chaine;
		
		// Tant que le nom saisi ne se termine pas par ".xml", on annule la suite du traitement
		if (chaine.endsWith(".xml")) {
			// Si la chaine ne contient pas "http", c'est une ressource locale
			if (chaine.indexOf("http://") == -1) {
				File fileTemp = new File(chaine);
				if (fileTemp.exists() && fileTemp.isFile()) {
					chaineEnForme = fileTemp.toURI().toString();
				}
			}
		}
		else {
			chaineEnForme = "";
		}
		
		return chaineEnForme;
	}
	
	/**
	 * V\u00e9rifie si le path du fichier saisi se termine par ".xml"
	 * Le rajoute en cas de besoin
	 * 
	 * @param path Le path \u00e0 tester
	 * 
	 * @return Le path avec l'extension ".xml"
	 */
	public static String checkXmlExtension(String path) {
		String pathFile = path;
		
		if (!path.toLowerCase().endsWith(".xml")) {
			pathFile = pathFile + ".xml";
		}
		
		return pathFile;
	}
}