package org.objectweb.petals.tools.plugin.monitor.wizards;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.widgets.Composite;

public class CommonComposite extends Composite {

	List<ChangedWizardInterface> listeners;
		
	public CommonComposite(Composite parent, int style) {
		super(parent, style);
		listeners = new ArrayList<ChangedWizardInterface>();
	}
	
	public void changedWizard() {
		for (ChangedWizardInterface listener: listeners) {
			listener.dialogChanged();
		}
	}
	
	public void addChangedWizardListener(ChangedWizardInterface listener) {
		if (listener != null) {
			listeners.add(listener);
		}
	}
	
	public void removeChangedWizardListener(ChangedWizardInterface listener) {
		if (listener != null) {
			listeners.remove(listener);
		}
	}
	
	public void clearChangedWizardListeners() {
		listeners.clear();
	}
	
	
	
}
