package org.objectweb.petals.tools.plugin.monitor.wizards;

import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.objectweb.petals.tools.plugin.monitor.views.widgets.PetalsServersCheckTable;


/**
 * Container pour les \u00e9l\u00e9ments graphique de l'assitant d'exportation
 * 
 * @author LA
 *
 */
public class ExportWizardComposite extends Composite {
	private FileFieldEditor editor;
	private PetalsServersCheckTable table = null;
	
	/**
	 * Constructeur
	 * 
	 * @param parent
	 * @param style
	 */
	public ExportWizardComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
	}
	
	/**
	 * This method initializes this
	 */
	private void initialize() {
		GridData fileSelectionData = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		this.setLayoutData(fileSelectionData);

		GridLayout fileSelectionLayout = new GridLayout();
		fileSelectionLayout.numColumns = 3;
		fileSelectionLayout.makeColumnsEqualWidth = false;
		fileSelectionLayout.marginWidth = 0;
		fileSelectionLayout.marginHeight = 0;
		this.setLayout(fileSelectionLayout);

		editor = new FileFieldEditor("fileSelect","Fichier annuaire : ", this);
		editor.setFileExtensions(new String[] {"*.xml"});
		
		table = new PetalsServersCheckTable(this);
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.verticalAlignment = GridData.FILL;
		gridData2.horizontalSpan = 3;
		gridData2.heightHint = 200;
		table.getPetalsServersCheckTable().setLayoutData(gridData2);
	}

	/**
	 * Getter
	 * 
	 * @return Le FileFieldEditor
	 */
	public FileFieldEditor getEditor() {
		return editor;
	}

	/**
	 * Getter
	 * 
	 * @return La table des serveurs \u00e0 s\u00e9lectionner
	 */
	public PetalsServersCheckTable getTable() {
		return table;
	}
}
