package org.objectweb.petals.tools.plugin.monitor.wizards;

import java.util.List;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Composite;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;



public class ExportWizardPage extends WizardPage {
	/**
	 * Container des \u00e9l\u00e9ments graphiques de la page
	 */
	private ExportWizardComposite exportWizardComposite;
	List<PetalsServer> petalsServerList;
	
	public ExportWizardPage(String pageName) {
		super(pageName);
		setTitle(pageName);
		setDescription("Exporte la liste des URLs JMX des serveurs Petals monitor\u00e9s");
		setPageComplete(false);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.WizardNewFileCreationPage#createAdvancedControls(org.eclipse.swt.widgets.Composite)
	 */	
	public void createControl(Composite parent) {
		exportWizardComposite = new ExportWizardComposite(parent, SWT.NONE);
		if (petalsServerList!=null) {
			exportWizardComposite.getTable().setPetalsServerBeanList(petalsServerList);
		}
		
		exportWizardComposite.getEditor().getTextControl(exportWizardComposite).addModifyListener(new ModifyListener(){
			public void modifyText(ModifyEvent e) {
				if (exportWizardComposite.getEditor().getStringValue().equals("")) {
					setErrorMessage("Vous devez renseigner un fichier");
				} else {
					setPageComplete(true);
					setErrorMessage(null);
				}
			}
		});
		setControl(exportWizardComposite);
	}

	public ExportWizardComposite getExportWizardComposite() {
		return exportWizardComposite;
	}

	public void setPetalsServerList(List<PetalsServer> petalsServerList) {
		this.petalsServerList = petalsServerList;
	}

}
