/*******************************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.objectweb.petals.tools.plugin.monitor.wizards;

import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IImportWizard;
import org.eclipse.ui.IWorkbench;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.providers.ViewContentProvider;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;


public class ImportWizard extends Wizard implements IImportWizard {
	
	ImportWizardPage mainPage;
	ViewContentProvider provider;
	
	public ImportWizard() {
		super();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	public boolean performFinish() {		
		importerServeurs();
        return true;
	}
	 
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		setWindowTitle("Assistant d'importation"); //NON-NLS-1
		setNeedsProgressMonitor(true);
		mainPage = new ImportWizardPage("Importer une liste de serveurs PETALS"); //NON-NLS-1
	}
	
	/* (non-Javadoc)
     * @see org.eclipse.jface.wizard.IWizard#addPages()
     */
    public void addPages() {
        super.addPages();
        addPage(mainPage);
    }

	public void setProvider(ViewContentProvider provider) {
		this.provider = provider;
	}
	
	/**
	 * Parcourt du tableau et ajout des serveurs coch\u00e9s
	 */
	public void importerServeurs() {
		List<PetalsServer> checkedServers = mainPage.getImportWizardComposite().getTable().getCheckedServers();
		PetalsServersView instance = PetalsServersView.getInstance();
		if (instance != null && !checkedServers.isEmpty()) {
			for (PetalsServer ps : checkedServers) {
				instance.addPetalsServer(ps);
			}
		}
	}
}
