package org.objectweb.petals.tools.plugin.monitor.wizards;


import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.objectweb.petals.tools.plugin.monitor.utils.DomUtils;
import org.objectweb.petals.tools.plugin.monitor.views.PetalsServersView;
import org.objectweb.petals.tools.plugin.monitor.views.widgets.PetalsServersCheckTable;
import org.w3c.dom.Document;


public class ImportWizardComposite extends Composite {
	private FileFieldEditor editor;  //  @jve:decl-index=0:
	private PetalsServersCheckTable table = null;
	private Label label = null;
	
	public ImportWizardComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		GridData fileSelectionData = new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		this.setLayoutData(fileSelectionData);

		GridLayout fileSelectionLayout = new GridLayout();
		fileSelectionLayout.numColumns = 3;
		fileSelectionLayout.makeColumnsEqualWidth = false;
		fileSelectionLayout.marginWidth = 0;
		fileSelectionLayout.marginHeight = 0;
		this.setLayout(fileSelectionLayout);
		
		editor = new FileFieldEditor("fileSelect","Fichier annuaire : ", this);
		editor.setFileExtensions(new String[] {"*.xml"});
		
		new Label(this, SWT.NONE).setText(" ");
		
		label = new Label(this, SWT.NONE);
		label.setText("Serveurs r\u00e9f\u00e9renc\u00e9s dans le fichier annuaire :");
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.verticalAlignment = GridData.CENTER;
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalSpan = 3;
		label.setLayoutData(gridData);
		
		table = new PetalsServersCheckTable(this);
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.verticalAlignment = GridData.FILL;
		gridData2.horizontalSpan = 3;
		gridData2.heightHint = 200;
		table.getPetalsServersCheckTable().setLayoutData(gridData2);
	}
	
	/**
	 * Parcourt du Document et ajout des serveurs trouv\u00e9s dans la grille
	 * de cases \u00e0 cocher.
	 * En parall\u00e8le, on rempli la liste des PetalsServer trouv\u00e9s
	 * 
	 * @param annuaire Le Document contenant la liste des serveurs Petals
	 */
	public void addServerLines(Document annuaire) {
		PetalsServersView instance = PetalsServersView.getInstance();
		
		if (instance != null && annuaire!=null) {			
			table.setPetalsServerBeanList(DomUtils.populateServersListFromDom(annuaire));
		}
	}
	
	public FileFieldEditor getEditor() {
		return editor;
	}

	/**
	 * Getter
	 * 
	 * @return La table \u00e0 cocher des Beans PetalsServer
	 */
	public PetalsServersCheckTable getTable() {
		return table;
	}

}
