package org.objectweb.petals.tools.plugin.monitor.wizards;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.ComponentType;


public class NewComponentMainPage extends WizardPage implements ChangedWizardInterface {
	
	private NewComponentComposite newComponentComposite;

	public NewComponentMainPage(ISelection selection) {
		super("wizardPage");
		setTitle("Nouveau composant");
		setDescription("Cet assistant permet d'ajouter un nouveau service engine, business component ou shared library");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/newcomponent_wiz.png"));
	}

	public void createControl(Composite parent) {
		newComponentComposite = new NewComponentComposite(parent, SWT.NONE);
		newComponentComposite.addChangedWizardListener(this);
		dialogChanged();
		setControl(newComponentComposite);
	}

	public void dialogChanged() {
		String serviceUrl = newComponentComposite.getUrl();
		if (serviceUrl.length() == 0) {
			updateStatus("L'URL du ZIP du composant \u00e0 cr\u00e9er doit \u00eatre sp\u00e9cifi\u00e9e");
			return;
		}
		ComponentType type = newComponentComposite.getType();
		if (type == ComponentType.unknown) {
			updateStatus("Le type du ZIP (service engine, binding component ou shared library) ne peut \u00eatre d\u00e9termin\u00e9");
			return;
		}
		updateStatus(null);
	}

	private void updateStatus(String message) {
		setErrorMessage(message);
		setPageComplete(message == null);
	}
	
	public String getUrl() {
		return newComponentComposite.getUrl();
	}
	
	public ComponentType getType() {
		return newComponentComposite.getType();
	}
	
	public void setComponentsFilenames(String[] componentsFilenames) {
		newComponentComposite.setComponentsFilenames(componentsFilenames);
	}

}