package org.objectweb.petals.tools.plugin.monitor.wizards;

import java.util.List;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.objectweb.petals.tools.plugin.monitor.Activator;
import org.objectweb.petals.tools.plugin.monitor.model.PetalsServer;
import org.objectweb.petals.tools.plugin.monitor.views.widgets.PetalsServersCheckTable;


public class NewComponentServersPage extends WizardPage implements ChangedWizardInterface {
	
	private PetalsServersCheckTable table;

	public NewComponentServersPage(ISelection selection) {
		super("wizardPage");
		setTitle("Serveurs cibles");
		setDescription("Cet assistant permet de s\u00e9lectionner sur quel(s) serveurs les composants seront d\u00e9ploy\u00e9s");
		setImageDescriptor(AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "icons/newserver_wiz.gif"));
	}

	public void createControl(Composite parent) {
		table = new PetalsServersCheckTable(parent);
		table.addChangedWizardListener(this);
		setControl(table.getPetalsServersCheckTable());
	}

	public void dialogChanged() {
		if (getServers().size() == 0) {
			updateStatus("Vous devez s\u00e9lectionner au moins un serveur cible");
			return;
		}
		updateStatus(null);
	}

	private void updateStatus(String message) {
		setErrorMessage(message);
		setPageComplete(message == null);
	}
	
	public List<PetalsServer> getServers() {
		return table.getCheckedServers();
	}
		
	public void setServers(List<PetalsServer> servers) {
		table.setPetalsServerBeanList(servers);
		dialogChanged();
	}

}