package org.objectweb.petals.tools.plugin.monitor.wizards;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class NewPetalsServerComposite extends CommonComposite {

	private final static String PREFIX_JMX_URL = "service:jmx:";  //  @jve:decl-index=0:
	
	private final static String[] PROTOCOLS = new String[] {"rmi:///jndi/rmi://"};
	
	private Label protocolLabel = null;
	private Combo protocolsCombo = null;
	private Label hostLabel = null;
	private Text hostText = null;
	private Label portLabel = null;
	private Text portText = null;
	private Label pathLabel = null;
	private Text pathText = null;
	private Label urlLabel = null;
	private Text urlText = null;
	private Button modifyCheckBox = null;

	private Label userLabel = null;

	private Text userText = null;

	private Label passwordLabel = null;

	private Text passwordText = null;

	private Label nameLabel = null;

	private Text name_text = null;

	private Label descriptionLabel = null;

	private Text descriptionTextArea = null;

	private Button advancedWizardCheckBox = null;

	private Label sepLabel = null;

	public NewPetalsServerComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		GridData gridData20 = new GridData();
		gridData20.horizontalSpan = 6;
		gridData20.verticalAlignment = GridData.END;
		gridData20.heightHint = 12;
		gridData20.horizontalAlignment = GridData.FILL;
		GridData gridData19 = new GridData();
		gridData19.horizontalAlignment = GridData.FILL;
		gridData19.verticalAlignment = GridData.FILL;
		GridData gridData18 = new GridData();
		gridData18.horizontalAlignment = GridData.FILL;
		gridData18.verticalAlignment = GridData.FILL;
		GridData gridData17 = new GridData();
		gridData17.horizontalAlignment = GridData.FILL;
		gridData17.verticalAlignment = GridData.FILL;
		GridData gridData16 = new GridData();
		gridData16.horizontalAlignment = GridData.FILL;
		gridData16.verticalAlignment = GridData.FILL;
		GridData gridData15 = new GridData();
		gridData15.horizontalAlignment = GridData.FILL;
		gridData15.verticalAlignment = GridData.FILL;
		GridData gridData14 = new GridData();
		gridData14.horizontalAlignment = GridData.FILL;
		gridData14.verticalAlignment = GridData.FILL;
		GridData gridData13 = new GridData();
		gridData13.horizontalAlignment = GridData.FILL;
		gridData13.verticalAlignment = GridData.FILL;
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.verticalAlignment = GridData.FILL;
		GridData gridData11 = new GridData();
		gridData11.horizontalSpan = 6;
		gridData11.horizontalAlignment = GridData.FILL;
		gridData11.verticalAlignment = GridData.BEGINNING;
		gridData11.heightHint = 24;
		GridData gridData10 = new GridData();
		gridData10.horizontalSpan = 5;
		gridData10.verticalAlignment = GridData.FILL;
		gridData10.heightHint = 45;
		gridData10.grabExcessVerticalSpace = false;
		gridData10.horizontalAlignment = GridData.FILL;
		GridData gridData9 = new GridData();
		gridData9.horizontalSpan = 5;
		gridData9.verticalAlignment = GridData.FILL;
		gridData9.horizontalAlignment = GridData.FILL;
		nameLabel = new Label(this, SWT.NONE);
		nameLabel.setText("Nom :");
		nameLabel.setLayoutData(gridData19);
		GridData gridData8 = new GridData();
		gridData8.grabExcessHorizontalSpace = false;
		gridData8.verticalAlignment = GridData.FILL;
		gridData8.heightHint = -1;
		gridData8.widthHint = -1;
		gridData8.horizontalAlignment = GridData.FILL;
		GridData gridData7 = new GridData();
		gridData7.horizontalAlignment = GridData.FILL;
		gridData7.verticalAlignment = GridData.FILL;
		GridData gridData6 = new GridData();
		gridData6.horizontalAlignment = GridData.FILL;
		gridData6.verticalAlignment = GridData.FILL;
		GridData gridData5 = new GridData();
		gridData5.widthHint = -1;
		gridData5.horizontalAlignment = GridData.FILL;
		gridData5.verticalAlignment = GridData.FILL;
		gridData5.horizontalSpan = 3;
		gridData5.grabExcessHorizontalSpace = true;
		GridData gridData4 = new GridData();
		gridData4.grabExcessHorizontalSpace = false;
		gridData4.verticalAlignment = GridData.FILL;
		gridData4.widthHint = -1;
		gridData4.horizontalSpan = 2;
		gridData4.horizontalAlignment = GridData.FILL;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.horizontalSpan = 5;
		gridData3.grabExcessVerticalSpace = false;
		gridData3.verticalAlignment = GridData.FILL;
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.verticalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.horizontalSpan = 3;
		gridData1.grabExcessVerticalSpace = false;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 6;
		gridLayout.verticalSpacing = 2;
		gridLayout.marginWidth = 3;
		gridLayout.marginHeight = 3;
		gridLayout.horizontalSpacing = 4;
		name_text = new Text(this, SWT.BORDER);
		name_text.setLayoutData(gridData9);
		descriptionLabel = new Label(this, SWT.NONE);
		descriptionLabel.setText("Description :");
		descriptionLabel.setLayoutData(gridData12);
		descriptionTextArea = new Text(this, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		descriptionTextArea.setLayoutData(gridData10);
		protocolLabel = new Label(this, SWT.NONE);
		protocolLabel.setText("Protocole :");
		protocolLabel.setLayoutData(gridData17);
		this.setLayout(gridLayout);
		createProtocolsCombo();
		setSize(new Point(558, 254));
		hostLabel = new Label(this, SWT.NONE);
		hostLabel.setText("H\u00f4te :");
		hostLabel.setLayoutData(gridData16);
		hostText = new Text(this, SWT.BORDER);
		hostText.setLayoutData(gridData1);
		hostText.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				updateURL();
			}
		});
		hostText.setText("localhost");
		portLabel = new Label(this, SWT.NONE);
		portLabel.setText("Port :");
		portLabel.setLayoutData(gridData18);
		portText = new Text(this, SWT.BORDER);
		portText.setText("7700");
		portText.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				updateURL();
			}
		});
		portText.setLayoutData(gridData2);
		pathLabel = new Label(this, SWT.NONE);
		pathLabel.setText("Chemin :");
		pathLabel.setVisible(true);
		pathLabel.setLayoutData(gridData15);
		pathText = new Text(this, SWT.BORDER);
		pathText.setVisible(true);
		pathText.setLayoutData(gridData3);
		pathText.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				updateURL();
			}
		});
		pathText.setText("/management/rmi-jmx-connector");
		userLabel = new Label(this, SWT.NONE);
		userLabel.setText("Utilisateur :");
		userLabel.setLayoutData(gridData13);
		userText = new Text(this, SWT.BORDER);
		userText.setLayoutData(gridData7);
		passwordLabel = new Label(this, SWT.NONE);
		passwordLabel.setText("Mot de passe :");
		passwordLabel.setLayoutData(gridData8);
		passwordText = new Text(this, SWT.BORDER | SWT.PASSWORD);
		passwordText.setLayoutData(gridData6);
		@SuppressWarnings("unused")
		Label filler6 = new Label(this, SWT.NONE);
		@SuppressWarnings("unused")
		Label filler7 = new Label(this, SWT.NONE);
		
		urlLabel = new Label(this, SWT.NONE);
		urlLabel.setText("URL :");
		urlLabel.setLayoutData(gridData14);
		urlText = new Text(this, SWT.BORDER);
		urlText.setEnabled(false);
		urlText.setLayoutData(gridData5);
		modifyCheckBox = new Button(this, SWT.CHECK);
		modifyCheckBox.setText("Modifiable");
		modifyCheckBox.setLayoutData(gridData4);
		modifyCheckBox.setSelection(false);
		sepLabel = new Label(this, SWT.SEPARATOR | SWT.HORIZONTAL);
		sepLabel.setText("Label");
		sepLabel.setVisible(true);
		sepLabel.setLayoutData(gridData20);
		advancedWizardCheckBox = new Button(this, SWT.CHECK);
		advancedWizardCheckBox.setText("Assistant avanc\u00e9");
		advancedWizardCheckBox.setSelection(true);
		advancedWizardCheckBox.setLayoutData(gridData11);
		advancedWizardCheckBox
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						showAdvancedWizard(advancedWizardCheckBox.getSelection());
					}
				});
		urlText.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				changedWizard();
			}
		});
		modifyCheckBox
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {						
						urlText.setEnabled(modifyCheckBox.getSelection());
					}
				});
		updateURL();
		name_text.setFocus();
	}

	void showAdvancedWizard(boolean showAdvancedSettings) {
		resizeWidget(descriptionLabel, !showAdvancedSettings);
		resizeWidget(descriptionTextArea, !showAdvancedSettings);		
		resizeWidget(protocolLabel, !showAdvancedSettings);
		resizeWidget(protocolsCombo, !showAdvancedSettings);		
		resizeWidget(portLabel, !showAdvancedSettings);
		resizeWidget(portText, !showAdvancedSettings);
		resizeWidget(pathLabel, !showAdvancedSettings);
		resizeWidget(pathText, !showAdvancedSettings);
		resizeWidget(userLabel, !showAdvancedSettings);
		resizeWidget(userText, !showAdvancedSettings);
		resizeWidget(passwordLabel, !showAdvancedSettings);
		resizeWidget(passwordText, !showAdvancedSettings);
		resizeWidget(modifyCheckBox, !showAdvancedSettings);
		pack();
	}
	
	void resizeWidget(Control control, boolean reduced) {
		control.setVisible(!reduced);
		/*GridData gd = ((GridData)control.getLayoutData());
		gd.heightHint = reduced ? 0 : -1;
		control.setLayoutData(gd);*/
	}
	
	
	/**
	 * This method initializes protocolsCombo	
	 *
	 */
	private void createProtocolsCombo() {
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalSpan = 5;
		gridData.grabExcessVerticalSpace = false;
		gridData.heightHint = -1;
		gridData.verticalAlignment = GridData.FILL;
		protocolsCombo = new Combo(this, SWT.NONE);
		protocolsCombo.setItems(PROTOCOLS);
		protocolsCombo.select(0);
		protocolsCombo.setLayoutData(gridData);
		protocolsCombo
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						updateURL();
					}
					public void widgetDefaultSelected(
							org.eclipse.swt.events.SelectionEvent e) {
					}
				});
		
	}

	protected String getProtocol() {
		return protocolsCombo != null ? protocolsCombo.getText() : "";
	}
	
	protected String getHost() {
		return hostText != null ? hostText.getText() : "";
	}
	
	protected String getPort() {
		return portText != null ? portText.getText() : "";
	}
	
	protected String getPath() {
		return pathText != null ? pathText.getText() : "";			
	}
	
	protected void updateURL() {
		if (urlText != null) {
			urlText.setText(PREFIX_JMX_URL + "rmi:///jndi/rmi://" + getHost() + ":" + getPort() + getPath());	
		}
	}
	
	public String getUser() {
		return userText.getText();
	}
	
	public String getPassword() {
		return passwordText.getText();
	}
	
	public String getUrl() {
		return urlText.getText();
	}
	
	public String getServerName() {
		return name_text.getText();
	}
	
	public String getDescription() {
		return descriptionTextArea.getText();
	}
	
}  //  @jve:decl-index=0:visual-constraint="19,10"
